package com.tiffintom.activity;

import android.os.Bundle;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.tiffintom.R;
import com.tiffintom.base.BaseActivity;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.utils.LogUtils;
import com.tiffintom.utils.ToastUtils;

import java.util.Timer;
import java.util.TimerTask;

/**
 * Created by Amrish on 02-11-2020.
 */
public class NoInternetActivity extends BaseActivity {
    TextView btnRefresh;
    Timer timer;
    TimerTask timerTask;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nointernet);
        initViews();
        btnRefresh.setOnClickListener(view -> {
            onBackPressed();
        });
        timer = new Timer();

        startTask();

    }

    private void startTask() {
        timerTask = new TimerTask() {
            @Override
            public void run() {
                LogUtils.e("Checking connectivity....");
                if (CommonFunctions.isConnected(NoInternetActivity.this)) {
                    LogUtils.e("Internet connected");
                    timerTask.cancel();
                    ToastUtils.makeSnackToast(NoInternetActivity.this, "Internet connection is back");
                    runOnUiThread(() -> {
                        onBackPressed();
                    });

                }
            }
        };
    }


    @Override
    protected void initViews() {
        super.initViews();
        btnRefresh = findViewById(R.id.btnRefresh);
    }

    @Override
    protected void onStop() {
        if (timerTask != null)
            timerTask.cancel();
        super.onStop();
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (timerTask != null) {
            startTask();
            timer.schedule(timerTask, 2000, 2000);
        }
    }

    @Override
    public void onBackPressed() {
        setResult(RESULT_OK);
        super.onBackPressed();
    }
}
