package com.tiffintom.activity;

import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.widget.ProgressBar;

import androidx.annotation.Nullable;

import com.tiffintom.BuildConfig;
import com.tiffintom.R;
import com.tiffintom.base.BaseActivity;
import com.tiffintom.utils.LogUtils;

import im.delight.android.webview.AdvancedWebView;

/**
 * Created by Amrish on 07-09-2020.
 */
public class WebViewActivity extends BaseActivity implements AdvancedWebView.Listener {
    private AdvancedWebView webView;
    private String checkoutUrl = "https://www.tiffintom.com/checkouts/paypalios/$res_id/$cust_id/$amount";
    String successUrl = "https://www.tiffintom.com/checkouts/success";
    String cancelUrl = "https://www.tiffintom.net/checkouts/cancel";
    private String res_id, customer_id, amount;
    private ProgressBar progressBar;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        res_id = getIntent().getStringExtra("res_id");
        customer_id = getIntent().getStringExtra("customer_id");
        amount = getIntent().getStringExtra("amount");
        setContentView(R.layout.activity_webview);
        initViews();
    }

    @Override
    protected void initViews() {
        super.initViews();
        if (!BuildConfig.DEBUG) {
            checkoutUrl = "https://www.tiffintom.com/checkouts/paypalios/$res_id/$cust_id/$amount";
        }
        checkoutUrl = checkoutUrl.replace("$res_id", res_id);
        checkoutUrl = checkoutUrl.replace("$cust_id", customer_id);
        checkoutUrl = checkoutUrl.replace("$amount", amount);
        webView = findViewById(R.id.webView);
        webView.setListener(this, this);
        webView.setMixedContentAllowed(false);
        webView.loadUrl(checkoutUrl);
    }

    @Override
    public void onPageStarted(String url, Bitmap favicon) {
        LogUtils.e("started url ", url);
        if (!BuildConfig.DEBUG) {
            successUrl = "https://www.tiffintom.com/checkouts/success";
        }
        if (url.startsWith(successUrl)) {
            Intent intent = new Intent();
            intent.putExtra("url", url);
            intent.putExtra("success", true);
            setResult(RESULT_OK, intent);
            finish();
        }
        if (!BuildConfig.DEBUG) {
            cancelUrl = "https://www.tiffintom.com/checkouts/cancel";
        }
        if (url.startsWith(cancelUrl)) {
            Intent intent = new Intent();
            intent.putExtra("url", url);
            intent.putExtra("success", false);
            setResult(RESULT_OK, intent);
            finish();
        }

    }

    @Override
    public void onPageFinished(String url) {
        LogUtils.e("finished url ", url);
    }

    @Override
    public void onPageError(int errorCode, String description, String failingUrl) {

    }

    @Override
    public void onDownloadRequested(String url, String suggestedFilename, String mimeType, long contentLength, String contentDisposition, String userAgent) {

    }

    @Override
    public void onExternalPageRequest(String url) {
        LogUtils.e("external url ", url);
    }
}
