package com.tiffintom.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.ChatSubQuestion;

import java.util.ArrayList;

/**
 * Created by Amrish on 17-09-2020.
 */
public class ChatDefaultQuestionsAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    public ArrayList<Object> objects;
    private RecyclerViewItemClickListener recyclerViewItemClickListener;

    public ChatDefaultQuestionsAdapter(ArrayList<Object> objects, RecyclerViewItemClickListener recyclerViewItemClickListener) {
        this.objects = objects;
        this.recyclerViewItemClickListener = recyclerViewItemClickListener;
    }

    @Override
    public int getItemViewType(int position) {
        if (objects.get(position) instanceof ChatSubQuestion) {
            return R.layout.item_default_questions_item;
        }
        return super.getItemViewType(position);
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(viewType, parent, false);
        if (viewType == R.layout.item_default_questions_item) {
            return new ChatQuestionViewHolder(view);
        }
        return null;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        if (getItemViewType(position) == R.layout.item_default_questions_item) {
            ChatQuestionViewHolder chatQuestionViewHolder = (ChatQuestionViewHolder) holder;
            ChatSubQuestion subQuestion = (ChatSubQuestion) objects.get(position);
            chatQuestionViewHolder.tvTitle.setText(subQuestion.question);
            chatQuestionViewHolder.itemView.setOnClickListener(view -> {
                if (recyclerViewItemClickListener != null)
                    recyclerViewItemClickListener.onItemClick(position, subQuestion);
            });
        }
    }

    @Override
    public int getItemCount() {
        return objects.size();
    }

    protected static class ChatQuestionViewHolder extends RecyclerView.ViewHolder {

        private TextView tvTitle;

        public ChatQuestionViewHolder(@NonNull View itemView) {
            super(itemView);
            tvTitle = itemView.findViewById(R.id.tvTitle);
        }
    }
}
