package com.tiffintom.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.DefaultInstructions;

import java.util.ArrayList;

/**
 * Created by Amrish on 22-09-2020.
 */
public class DefaultInstructionsAdapter extends RecyclerView.Adapter<DefaultInstructionsAdapter.InstructionViewHolder> {
    private ArrayList<DefaultInstructions> checkoutMessages;
    private RecyclerViewItemClickListener recyclerViewItemClickListener;

    public DefaultInstructionsAdapter(ArrayList<DefaultInstructions> checkoutMessages, RecyclerViewItemClickListener recyclerViewItemClickListener) {
        this.checkoutMessages = checkoutMessages;
        this.recyclerViewItemClickListener = recyclerViewItemClickListener;
    }

    @NonNull
    @Override
    public InstructionViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new InstructionViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.item_default_instruction, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull InstructionViewHolder holder, int position) {
        holder.rbMessage.setChecked(checkoutMessages.get(position).isSelected);
        holder.rbMessage.setText(checkoutMessages.get(position).message);
        holder.rbMessage.setOnCheckedChangeListener((compoundButton, b) -> {
            checkoutMessages.get(position).isSelected = b;
            if (recyclerViewItemClickListener != null)
                recyclerViewItemClickListener.onItemClick(position, checkoutMessages);
        });
    }


    @Override
    public int getItemCount() {
        return checkoutMessages.size();
    }

    protected static class InstructionViewHolder extends RecyclerView.ViewHolder {
        private CheckBox rbMessage;

        public InstructionViewHolder(@NonNull View itemView) {
            super(itemView);
            rbMessage = itemView.findViewById(R.id.rbMessage);
        }
    }
}
