package com.tiffintom.adapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RadioButton;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.TimeSlot;

import java.util.ArrayList;

/**
 * Created by Amrish on 19-08-2020.
 */
public class DeliveryTimeSlotAdapter extends RecyclerView.Adapter<DeliveryTimeSlotAdapter.CuisineViewHolder> {
    private Activity activity;
    private ArrayList<TimeSlot> timeSlots = new ArrayList<>();
    private int selectedCuisine = 0;
    private RecyclerViewItemClickListener recyclerViewItemClickListener;
    private int lastCheckedPosition = -1, checkedPosition = -1;
    private RadioButton checkedRadio;


    public DeliveryTimeSlotAdapter(Activity activity, ArrayList<TimeSlot> timeSlots, int selectedCuisine, RecyclerViewItemClickListener recyclerViewItemClickListener) {
        this.activity = activity;
        this.timeSlots = timeSlots;
        this.selectedCuisine = selectedCuisine;
        this.recyclerViewItemClickListener = recyclerViewItemClickListener;
    }

    @NonNull
    @Override
    public DeliveryTimeSlotAdapter.CuisineViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new CuisineViewHolder(LayoutInflater.from(activity).inflate(R.layout.delivery_time_slot_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull DeliveryTimeSlotAdapter.CuisineViewHolder holder, int position) {
        TimeSlot timeSlot = timeSlots.get(position);
        holder.rbTitle.setText(timeSlot.name);
        if (selectedCuisine != 0 && timeSlot.id == (selectedCuisine)) {
            holder.rbTitle.setChecked(true);
        } else {
            holder.rbTitle.setChecked(false);
        }
        holder.rbTitle.setOnClickListener((view) -> {
            selectedCuisine = timeSlot.id;
            if (checkedRadio != null) {
                checkedRadio.setChecked(false);
            }
            checkedRadio = (RadioButton) view;
            lastCheckedPosition = position;
            if (recyclerViewItemClickListener != null)
                recyclerViewItemClickListener.onItemClick(position, timeSlot);
        });

    }

    @Override
    public int getItemCount() {
        return timeSlots.size();
    }

    protected class CuisineViewHolder extends RecyclerView.ViewHolder {
        private RadioButton rbTitle;

        public CuisineViewHolder(@NonNull View itemView) {
            super(itemView);
            rbTitle = itemView.findViewById(R.id.rbTitle);
        }
    }
}
