package com.tiffintom.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RadioButton;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.DineinModels.Children;

import java.util.ArrayList;

/**
 * Created by Amrish on 19-08-2020.
 */
public class DineinChildrenAdapter extends RecyclerView.Adapter<DineinChildrenAdapter.CategoryViewHolder> {
    private ArrayList<Children> categories = new ArrayList<>();
    public static int selectedCategory = 0;
    private RecyclerViewItemClickListener onCuisineClick;
    private int lastCheckedPosition = -1, checkedPosition = -1;
    private RadioButton checkedRadio;


    public DineinChildrenAdapter(ArrayList<Children> categories, RecyclerViewItemClickListener onCuisineClick) {
        this.categories = categories;
        this.onCuisineClick = onCuisineClick;
    }

    @NonNull
    @Override
    public CategoryViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new CategoryViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.home_category_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull CategoryViewHolder holder, int position) {
        Children category = categories.get(position);
        holder.rbTitle.setText(category.name);
        if (category.id == (selectedCategory)) {
            holder.rbTitle.setChecked(true);
            lastCheckedPosition = position;
            checkedRadio = holder.rbTitle;
        } else {
            holder.rbTitle.setChecked(false);
        }
        holder.rbTitle.setOnClickListener((view) -> {
            // selectedCategory = category.id;
            if (checkedRadio != null) {
                checkedRadio.setChecked(false);
            }
            checkedRadio = (RadioButton) view;
            ((RadioButton) view).setChecked(true);
            lastCheckedPosition = position;
            if (onCuisineClick != null) onCuisineClick.onItemClick(position, category);
        });

    }

    @Override
    public int getItemCount() {
        return categories.size();
    }

    protected static class CategoryViewHolder extends RecyclerView.ViewHolder {
        private RadioButton rbTitle;

        public CategoryViewHolder(@NonNull View itemView) {
            super(itemView);
            rbTitle = itemView.findViewById(R.id.rbTitle);
        }
    }
}
