package com.tiffintom.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.viewpager.widget.PagerAdapter;
import androidx.viewpager.widget.ViewPager;

import com.tiffintom.R;
import com.tiffintom.models.PostcodeViewPager;

import java.util.ArrayList;

public class EnterPostCodeViewPagerAdapter extends PagerAdapter {

    private Context context;
    private ArrayList<PostcodeViewPager> postcodearraylist;
    private LayoutInflater layoutInflater;

    public EnterPostCodeViewPagerAdapter(Context context, ArrayList<PostcodeViewPager> postcodearraylist) {
        this.context = context;
        this.postcodearraylist = postcodearraylist;
    }

    @Override
    public int getCount() {
        return postcodearraylist.size();
    }

    @Override
    public boolean isViewFromObject(@NonNull View view, @NonNull Object object) {
        return view == object;
    }

    @NonNull
    @Override
    public Object instantiateItem(@NonNull ViewGroup container, int position) {
        layoutInflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View view = layoutInflater.inflate(R.layout.viewpager_enter_postcode, null);

        PostcodeViewPager postcodeModel = postcodearraylist.get(position);
        ImageView imageView = view.findViewById(R.id.ivViewpagerImg1);
        TextView tv_Title = view.findViewById(R.id.tvTitle);
        TextView tv_subtitle = view.findViewById(R.id.tvSubtitle);

        imageView.setImageResource(postcodeModel.image);
        tv_Title.setText(postcodeModel.title);
        tv_subtitle.setText(postcodeModel.subtitle);

        container.addView(view);
        return view;
    }

    @Override
    public void destroyItem(@NonNull ViewGroup container, int position, @NonNull Object object) {
        ViewPager vp = (ViewPager) container;
        View view = (View) object;
        vp.removeView(view);
    }
}
