package com.tiffintom.adapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.Cuisine;
import com.tiffintom.utils.ToastUtils;

import java.util.ArrayList;

/**
 * Created by Amrish on 19-08-2020.
 */
public class HomeCuisineAdapter extends RecyclerView.Adapter<HomeCuisineAdapter.CuisineViewHolder> {
    private Activity activity;
    private ArrayList<Cuisine> categories = new ArrayList<>();
    public ArrayList<Cuisine> selectedCuisines = new ArrayList<>();
    public int selectedCuisine = 0;
    private RecyclerViewItemClickListener onCuisineClick;
    private int lastCheckedPosition = -1, checkedPosition = -1;
    private RadioButton checkedRadio;
    private TextView selectedTextView;

    public HomeCuisineAdapter(Activity activity, ArrayList<Cuisine> categories, int selectedCuisine, RecyclerViewItemClickListener onCuisineClick) {
        this.activity = activity;
        this.categories = categories;
        this.selectedCuisine = selectedCuisine;
        this.onCuisineClick = onCuisineClick;
    }
    @NonNull
    @Override
    public HomeCuisineAdapter.CuisineViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new CuisineViewHolder(LayoutInflater.from(activity).inflate(R.layout.home_cuisine_item, parent, false));
    }
    @Override
    public void onBindViewHolder(@NonNull HomeCuisineAdapter.CuisineViewHolder holder, int position) {
        Cuisine cuisine = categories.get(position);
        holder.cbCuisine.setText(cuisine.cuisine_name);
        holder.cbCuisine.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) {
                cuisine.isSelected = true;
                selectedCuisines.add(cuisine);
            } else {
                selectedCuisines.remove(cuisine);
                cuisine.isSelected = false;
            }
            if (onCuisineClick != null) onCuisineClick.onItemClick(position, selectedCuisines);
        });
        holder.cbCuisine.setChecked(cuisine.isSelected);
    }

    @Override
    public int getItemCount() {
        return categories.size();
    }

    protected class CuisineViewHolder extends RecyclerView.ViewHolder {
        private CheckBox cbCuisine;

        public CuisineViewHolder(@NonNull View itemView) {
            super(itemView);
            cbCuisine = itemView.findViewById(R.id.cbCuisine);
        }
    }
}
