package com.tiffintom.adapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.MyApp;
import com.tiffintom.R;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.models.ReferredList;

import java.util.ArrayList;

public class ReferredAdapter extends RecyclerView.Adapter<ReferredAdapter.ViewHolder> {
    private Activity activity;
    private ArrayList<ReferredList> referredLists;

    public ReferredAdapter(Activity activity, ArrayList<ReferredList> referredLists) {
        this.activity = activity;
        this.referredLists = referredLists;
    }

    @NonNull
    @Override
    public ReferredAdapter.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new ViewHolder(LayoutInflater.from(activity).inflate(R.layout.item_referred_list, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull ReferredAdapter.ViewHolder holder, int position) {
        ReferredList referreds = referredLists.get(position);
        holder.tvName.setText(referreds.first_name + referreds.last_name);
        holder.tvEmail.setText(referreds.username);
        holder.tvStatus.setText(referreds.status);
        holder.tvDate.setText(CommonFunctions.formatTimestampZulu(referreds.created, "dd/MM/yyyy"));
        holder.tvAmount.setText(MyApp.getInstance().getCurrencySymbol() + MyApp.df.format(referreds.receive_amount) + " received");
    }

    @Override
    public int getItemCount() {
        return referredLists.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        private TextView tvName, tvDate, tvEmail, tvStatus, tvAmount;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            tvName = itemView.findViewById(R.id.tvName);
            tvEmail = itemView.findViewById(R.id.tvUserName);
            tvStatus = itemView.findViewById(R.id.tvStatus);
            tvAmount = itemView.findViewById(R.id.tvAmount);
            tvDate = itemView.findViewById(R.id.tvDate);
        }
    }
}
