package com.tiffintom.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RadioButton;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.Category;

import java.util.ArrayList;

/**
 * Created by Amrish on 19-08-2020.
 */
public class RestaurantMenuCategoryAdapter extends RecyclerView.Adapter<RestaurantMenuCategoryAdapter.CategoryViewHolder> {
    private ArrayList<Category> categories = new ArrayList<>();
    public static int selectedCategory = 0, selectedDineinCategory = 0;
    private RecyclerViewItemClickListener onCuisineClick;
    private int lastCheckedPosition = -1, checkedPosition = -1;
    private RadioButton checkedRadio;
    private boolean isDinein;

    public RestaurantMenuCategoryAdapter(ArrayList<Category> categories, boolean isDinein, RecyclerViewItemClickListener onCuisineClick) {
        this.categories = categories;
        this.onCuisineClick = onCuisineClick;
        this.isDinein = isDinein;
    }

    @NonNull
    @Override
    public CategoryViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new CategoryViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.home_category_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull CategoryViewHolder holder, int position) {
        Category category = categories.get(position);
        if (!isDinein) {
            holder.rbTitle.setText(category.category_name);
            if (category.category_id == (selectedCategory)) {
                holder.rbTitle.setChecked(true);
                lastCheckedPosition = position;
                checkedRadio = holder.rbTitle;
            } else {
                holder.rbTitle.setChecked(false);
            }
            holder.rbTitle.setOnClickListener((view) -> {
                selectedCategory = category.category_id;
                if (checkedRadio != null) {
                    checkedRadio.setChecked(false);
                }
                checkedRadio = (RadioButton) view;
                ((RadioButton) view).setChecked(true);
                lastCheckedPosition = position;
                if (onCuisineClick != null) onCuisineClick.onItemClick(position, category);
            });
        } else {
            holder.rbTitle.setText(category.category_name);
            if (category.category_id == (selectedDineinCategory)) {
                holder.rbTitle.setChecked(true);
                lastCheckedPosition = position;
                checkedRadio = holder.rbTitle;
            } else {
                holder.rbTitle.setChecked(false);
            }
            holder.rbTitle.setOnClickListener((view) -> {
                selectedDineinCategory = category.category_id;
                if (checkedRadio != null) {
                    checkedRadio.setChecked(false);
                }
                checkedRadio = (RadioButton) view;
                ((RadioButton) view).setChecked(true);
                lastCheckedPosition = position;
                if (onCuisineClick != null) onCuisineClick.onItemClick(position, category);
            });
        }

    }

    @Override
    public int getItemCount() {
        return categories.size();
    }

    protected static class CategoryViewHolder extends RecyclerView.ViewHolder {
        private RadioButton rbTitle;

        public CategoryViewHolder(@NonNull View itemView) {
            super(itemView);
            rbTitle = itemView.findViewById(R.id.rbTitle);
        }
    }
}
