package com.tiffintom.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.fragment.CuisineBottomSheetFragment;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.Cuisine;

import java.util.ArrayList;

public class SelectedCuisionAdapter extends RecyclerView.Adapter<SelectedCuisionAdapter.RemoveCusionHolder> {

    private Context context;
    private ArrayList<Cuisine> selectedlist;
    private RecyclerViewItemClickListener itemSelectListener;

    public SelectedCuisionAdapter(Context context, ArrayList<Cuisine> selectedlist, RecyclerViewItemClickListener itemSelectListener) {
        this.context = context;
        this.selectedlist = selectedlist;
        this.itemSelectListener = itemSelectListener;
    }

    @NonNull
    @Override
    public RemoveCusionHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new RemoveCusionHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.cuision_remove_items, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull RemoveCusionHolder holder, int position) {

        Cuisine cuisine = selectedlist.get(position);
        holder.tvCuision.setText(cuisine.cuisine_name);

        holder.ivRemoveitem.setOnClickListener(view -> {

            CuisineBottomSheetFragment.selectedCuisineCount--;
            if (itemSelectListener != null) {
                itemSelectListener.onItemClick(position, cuisine);
            }
        });
    }

    @Override
    public int getItemCount() {
        return selectedlist.size();
    }

    public class RemoveCusionHolder extends RecyclerView.ViewHolder {
        private ImageView ivRemoveitem;
        private TextView tvCuision;

        public RemoveCusionHolder(@NonNull View itemView) {
            super(itemView);
            ivRemoveitem = itemView.findViewById(R.id.ivRemove);
            tvCuision = itemView.findViewById(R.id.tvSelectedCuisine);
        }
    }
}
