package com.tiffintom.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.Tables;

import java.util.ArrayList;

public class TableSelectAdapater extends RecyclerView.Adapter<TableSelectAdapater.ViewHolder> {

    private ArrayList<Tables> tables;
    private RecyclerViewItemClickListener itemClickListener;
    public static int selectedTable = 0;

    public TableSelectAdapater(ArrayList<Tables> tables, RecyclerViewItemClickListener itemClickListener) {
        this.tables = tables;
        this.itemClickListener = itemClickListener;
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new ViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.select_table_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        Tables table = tables.get(position);
        holder.tvTables.setText(table.number + "(" + table.floor_name + ")");
        if (selectedTable == Integer.parseInt(table.id)) {
            holder.cbSelect.setChecked(true);
        } else
            holder.cbSelect.setChecked(false);
        holder.cvTables.setOnClickListener(view -> {
            if (itemClickListener != null)
                itemClickListener.onItemClick(position, table);
        });

    }

    @Override
    public int getItemCount() {
        return tables.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        private CardView cvTables;
        private TextView tvTables;
        private CheckBox cbSelect;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            cvTables = itemView.findViewById(R.id.cvTables);
            tvTables = itemView.findViewById(R.id.tvTableName);
            cbSelect = itemView.findViewById(R.id.cbSelect);
        }
    }
}
