package com.tiffintom.adapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;

import java.util.ArrayList;

import static com.tiffintom.fragment.CartCheckoutFragment.selectedTimeSlot;

/**
 * Created by Amrish on 19-08-2020.
 */
public class TimeSlotAdapter extends RecyclerView.Adapter<TimeSlotAdapter.CuisineViewHolder> {
    private Activity activity;
    private ArrayList<String> slots = new ArrayList<>();
    private RecyclerViewItemClickListener recyclerViewItemClickListener;
    private RadioButton checkedRadio;
    private TextView selectedTextView;
    private int lastCheckedPosition = -1;

    public TimeSlotAdapter(Activity activity, ArrayList<String> slots, RecyclerViewItemClickListener recyclerViewItemClickListener) {
        this.activity = activity;
        this.slots = slots;
        this.recyclerViewItemClickListener = recyclerViewItemClickListener;
    }

    @NonNull
    @Override
    public TimeSlotAdapter.CuisineViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new CuisineViewHolder(LayoutInflater.from(activity).inflate(R.layout.checkout_time_slot, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull TimeSlotAdapter.CuisineViewHolder holder, int position) {
        holder.rbTitle.setText(slots.get(position));
        holder.tvTitle.setText(slots.get(position));
        if (slots.get(position).equals(selectedTimeSlot)) {
            holder.rbTitle.setChecked(true);
            lastCheckedPosition = position;
            checkedRadio = holder.rbTitle;
        } else {
            holder.rbTitle.setChecked(false);
        }
        holder.rbTitle.setOnClickListener((view) -> {
            selectedTimeSlot = slots.get(position);
            if (checkedRadio != null) {
                checkedRadio.setChecked(false);
            }
            checkedRadio = (RadioButton) view;
            ((RadioButton) view).setChecked(true);
            lastCheckedPosition = position;
            if (recyclerViewItemClickListener != null)
                recyclerViewItemClickListener.onItemClick(position, slots.get(position));
        });
    }

    @Override
    public int getItemCount() {
        return slots.size();
    }

    protected class CuisineViewHolder extends RecyclerView.ViewHolder {
        private RadioButton rbTitle;
        private TextView tvTitle;

        public CuisineViewHolder(@NonNull View itemView) {
            super(itemView);
            rbTitle = itemView.findViewById(R.id.rbTitle);
            tvTitle = itemView.findViewById(R.id.tvTitle);
        }
    }
}
