package com.tiffintom.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.viewpager.widget.PagerAdapter;
import androidx.viewpager.widget.ViewPager;

import com.tiffintom.R;
import com.tiffintom.models.PostcodeViewPager;

import java.util.ArrayList;

public class ViewPagerAdepter extends PagerAdapter {

    private Context context;
    private LayoutInflater layoutInflater;
    private ArrayList<PostcodeViewPager> partnerarraylist;

    public ViewPagerAdepter(Context context, ArrayList<PostcodeViewPager> partnerarraylist) {
        this.context = context;
        this.partnerarraylist = partnerarraylist;
    }

    @Override
    public int getCount() {
        return partnerarraylist.size();
    }

    @Override
    public boolean isViewFromObject(@NonNull View view, @NonNull Object object) {
        return view == object;
    }

    @NonNull
    @Override
    public Object instantiateItem(@NonNull ViewGroup container, int position) {

        layoutInflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View view = layoutInflater.inflate(R.layout.viewpager_layout, null);

        PostcodeViewPager model = partnerarraylist.get(position);
        ImageView imageView = view.findViewById(R.id.ivViewpagerImg1);
        TextView tvTiTile = view.findViewById(R.id.tvTitle);

        imageView.setImageResource(model.image);
        tvTiTile.setText(model.title);

        container.addView(view);
        return view;
    }

    @Override
    public void destroyItem(@NonNull ViewGroup container, int position, @NonNull Object object) {
        ViewPager vp = (ViewPager) container;
        View view = (View) object;
        vp.removeView(view);
    }
}
