package com.tiffintom.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;
import com.tiffintom.interfaces.RecyclerViewItemClickListener;
import com.tiffintom.models.DineinModels.DineinVoucherList;
import com.tiffintom.models.RestaurantVoucher;

import java.util.ArrayList;

/**
 * Created by Amrish on 20-08-2020.
 */
public class VoucherListAdapter extends RecyclerView.Adapter<VoucherListAdapter.AddressViewHolder> {
    ArrayList<Object> vouchers;
    RecyclerViewItemClickListener recyclerViewItemClickListener;

    public VoucherListAdapter(ArrayList<Object> vouchers, RecyclerViewItemClickListener recyclerViewItemClickListener) {
        this.vouchers = vouchers;
        this.recyclerViewItemClickListener = recyclerViewItemClickListener;
    }

    @NonNull
    @Override
    public AddressViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new AddressViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.item_voucher, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull AddressViewHolder holder, int position) {
        if (vouchers.get(position) instanceof RestaurantVoucher) {
            RestaurantVoucher voucher = (RestaurantVoucher) vouchers.get(position);
            holder.tvCode.setText(voucher.voucher_code);
            holder.tvMessage.setText(voucher.voucher_message);
            holder.tvApply.setOnClickListener(view -> {
                if (recyclerViewItemClickListener != null) {
                    recyclerViewItemClickListener.onItemClick(position, vouchers.get(position));
                }
            });
        } else if (vouchers.get(position) instanceof DineinVoucherList) {
            DineinVoucherList voucher = (DineinVoucherList) vouchers.get(position);
            holder.tvCode.setText(voucher.voucher_code);
            holder.tvMessage.setVisibility(View.GONE);
            //  holder.tvMessage.setText(voucher.voucher_message);
            holder.tvApply.setOnClickListener(view -> {
                if (recyclerViewItemClickListener != null) {
                    recyclerViewItemClickListener.onItemClick(position, vouchers.get(position));
                }
            });
        }

    }

    @Override
    public int getItemCount() {
        return vouchers.size();
    }

    public class AddressViewHolder extends RecyclerView.ViewHolder {
        private TextView tvCode, tvMessage, tvApply;

        public AddressViewHolder(@NonNull View itemView) {
            super(itemView);
            tvCode = itemView.findViewById(R.id.tvCode);
            tvMessage = itemView.findViewById(R.id.tvMessage);
            tvApply = itemView.findViewById(R.id.tvApply);

        }
    }
}
