package com.tiffintom.fragment;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.tiffintom.R;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.base.BaseFragment;

public class AboutFragment extends BaseFragment {

    private LinearLayout cvVisitwebsite, cvPrivacy, cvTermsConditions, cvCopyright;

    public static AboutFragment getInstance() {
        return new AboutFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_about, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        setListener();
    }

    private void setListener() {
        cvVisitwebsite.setOnClickListener(view1 -> {
            startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "webview").putExtra("url", "https://www.tiffintom.com/"));
        });
        cvPrivacy.setOnClickListener(view1 -> {
            startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "webview").putExtra("url", "https://www.tiffintom.com/pages/privacy-policy"));
        });
        cvTermsConditions.setOnClickListener(view1 -> {
            startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "webview").putExtra("url", "https://www.tiffintom.com/pages/privacy-policy"));
        });
        cvCopyright.setOnClickListener(view1 -> {
            startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "webview").putExtra("url", "https://www.tiffintom.com/pages/privacy-policy"));
        });


    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);
        cvVisitwebsite = view.findViewById(R.id.cvVisitwebsite);
        cvPrivacy = view.findViewById(R.id.cvPrivacyPolicy);
        cvTermsConditions = view.findViewById(R.id.cvTermCondition);
        cvCopyright = view.findViewById(R.id.cvCopyright);
    }
}
