package com.tiffintom.fragment;

import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.google.android.material.bottomsheet.BottomSheetDialogFragment;
import com.tiffintom.R;
import com.tiffintom.interfaces.DialogDismissListener;

/**
 * Created by Amrish on 12-09-2020.
 */
public class CancellationReasonFragment extends BottomSheetDialogFragment {
    private EditText etReason;
    private DialogDismissListener dialogDismissListener;

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    public static CancellationReasonFragment getInstance() {
        return new CancellationReasonFragment();
    }

    @Override
    public int getTheme() {
        if (Build.VERSION.SDK_INT > 21) {
            return R.style.BottomSheetDialogTheme;
        } else {
            return super.getTheme();
        }
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.dialog_reservation_cancel_reason, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        etReason = view.findViewById(R.id.etReason);
        Button btnCancel = view.findViewById(R.id.btnCancel);

        btnCancel.setOnClickListener(view1 -> {
            dismiss();
            if (dialogDismissListener != null)
                dialogDismissListener.onDialogDismiss(etReason.getText().toString());
        });
    }
}
