package com.tiffintom.fragment;

import android.animation.Animator;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.core.content.ContextCompat;
import androidx.core.widget.NestedScrollView;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.airbnb.lottie.LottieAnimationView;
import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONArrayRequestListener;
import com.androidnetworking.interfaces.JSONObjectRequestListener;
import com.bumptech.glide.Glide;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.stripe.android.ApiResultCallback;
import com.stripe.android.PaymentIntentResult;
import com.stripe.android.Stripe;
import com.stripe.android.model.ConfirmPaymentIntentParams;
import com.stripe.android.model.PaymentIntent;
import com.tiffintom.MyApp;
import com.tiffintom.R;
import com.tiffintom.activity.AuthActivity;
import com.tiffintom.activity.NoInternetActivity;
import com.tiffintom.activity.RestaurantDetailsActivity;
import com.tiffintom.activity.SplashActivity;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.activity.WebViewActivity;
import com.tiffintom.adapters.CartBasketItemsAdapter;
import com.tiffintom.adapters.DefaultInstructionsAdapter;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.common.Validators;
import com.tiffintom.interfaces.DialogDismissListener;
import com.tiffintom.interfaces.MoneyTextWatcher;
import com.tiffintom.models.Address;
import com.tiffintom.models.ApiError;
import com.tiffintom.models.Cart;
import com.tiffintom.models.CartItem;
import com.tiffintom.models.CartSummary;
import com.tiffintom.models.DayOffer;
import com.tiffintom.models.DayPriceOffer;
import com.tiffintom.models.DayProductOffer;
import com.tiffintom.models.DefaultInstructions;
import com.tiffintom.models.Header;
import com.tiffintom.models.Menu;
import com.tiffintom.models.MenuItemNew;
import com.tiffintom.models.MultiplePriceOffer;
import com.tiffintom.models.Offer;
import com.tiffintom.models.OfferCheck;
import com.tiffintom.models.OfferProduct;
import com.tiffintom.models.OfferSimplify;
import com.tiffintom.models.PaymentMethod;
import com.tiffintom.models.PlaceOrder;
import com.tiffintom.models.Postcode;
import com.tiffintom.models.PriceOffer;
import com.tiffintom.models.ProductOffer;
import com.tiffintom.models.Restaurant;
import com.tiffintom.models.RestaurantPaymentMethod;
import com.tiffintom.models.Rewards;
import com.tiffintom.models.TimeSlot;
import com.tiffintom.models.TimeSlots;
import com.tiffintom.models.UploadCartItems;
import com.tiffintom.models.User;
import com.tiffintom.models.Variant;
import com.tiffintom.models.Voucher;
import com.tiffintom.network.ApiEndPoints;
import com.tiffintom.network.ApiUtils;
import com.tiffintom.utils.LogUtils;
import com.tiffintom.utils.ToastUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.lang.reflect.Type;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.ConcurrentModificationException;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.Callable;

import static com.tiffintom.network.ApiEndPoints.ACCOUNT;
import static com.tiffintom.network.ApiEndPoints.NEW_OFFER_CHECK;
import static com.tiffintom.network.ApiEndPoints.NEW_REWARDS;
import static com.tiffintom.utils.Constants.CODE_NO_INTERNET;
import static com.tiffintom.utils.Constants.CODE_PAYPAL;
import static com.tiffintom.utils.Constants.CODE_REFRESH;

/**
 * Created by Amrish on 19-08-2020.
 */
public class CartCheckoutFragment extends BaseFragment {
    public static CartCheckoutFragment getInstance() {
        CartCheckoutFragment exploreCategoryFragment = new CartCheckoutFragment();
        Bundle bundle = new Bundle();
        exploreCategoryFragment.setArguments(bundle);
        return exploreCategoryFragment;
    }

    private User loggedInUser = myApp.getMyPreferences().getLoggedInUser();
    Postcode defaultPostCode = myApp.getMyPreferences().getCurrentPostcode();
    private TextView tvAddress, tvZipcode, tvChangeAddress, tvAddressUsername;
    private boolean moveToNext;
    private RecyclerView rvCartItems;
    ArrayList<UploadCartItems> cartItemArrayList = new ArrayList<>();
    ArrayList<Cart> CartArrayList = new ArrayList<>();
    private CartBasketItemsAdapter cartBasketItemsAdapter;
    private final ArrayList<Object> feed = new ArrayList<>();
    private final ArrayList<CartItem> cartItems = new ArrayList<>();
    private final ArrayList<CartItem> freeItems = new ArrayList<>();
    private ArrayList<Menu> restaurant_menu = new ArrayList<>();
    private final ArrayList<Menu> suggestedMenuItems = new ArrayList<>();
    private SupportMapFragment mapFragment = null;
    private TextView tvDeliveryDate, tvDeliveryInstructions;
    private int today_day;
    private int today_month;
    private int today_year;
    private String Order_point;

    Calendar calendar = Calendar.getInstance();
    private int delivery_date, delivery_month, delivery_year;
    private boolean isDeliveryType = true; //delivery,collection
    private int orderType = 0;//0 for not selected,1 for delivery 2 for collection
    private LinearLayout cvDeliveryInstructions;
    private LinearLayout llDeliveryInstructions, ll_Discount, ll_Reward_Discount;
    private EditText etDeliveryInstructions, etOrderInstruction;
    private Restaurant restaurant;
    private final ArrayList<OfferSimplify> offers = new ArrayList<>();
    private final ArrayList<Cart> CartArraylist = new ArrayList<>();
    private int res_id = -1;
    private RelativeLayout rlNoData;
    private LinearLayout llLoading, llPlaceOrder;
    private ProgressBar pbLoading;
    private NestedScrollView nestedScrollView;
    private ImageView ivRestaurantLogo, ivSelectProduct;
    private CartSummary cartSummary;
    private final String currency = myApp.getCurrencySymbol();
    private TextView tvCharityFee, cvCharityFee, tvSubtotal, tvServiceFee, tvDeliveryFee, tvDiscount, cvDiscount, tvRewardDiscount, tvTotal, tvOrderTotal;
    private float cartSubtotal = 0, cartServiceFee = 0, cartDeliveryFee = 0, cartDiscount = 0, cartRewardDiscount = 0, cartTotal = 0, voucherDiscount, cartTip = 0, cartCharity = 0, cartOffer = 0, offerAmount, offerPercentage, cartRedeem, cartEarn;
    private LinearLayout llPaymentMethod, llServiceCharge, llDeliveryFee, llCherityFee;
    private TextView tvPaymentMethodName;
    private ImageView ivPaymentMethod;
    private PaymentMethod paymentMethod;
    private TextView tvScreenTitle;
    private ImageView ivBackArrow;
    private LinearLayout llBackArrow;
    public static String selectedTimeSlot = null, deliveryTimeSlot = null, pickupTimeSlot = null;
    private EditText etPromocode;
    private Button btnApplyPromocode;
    private Voucher appliedVoucher;
    private boolean voucherApplied = false;
    private boolean isPlaceOrderAddress = false;
    private Address defaultAddress;

    private GoogleMap userMap;
    private TextView tvOrderDateLabel, tvOrderTimeLabel, tvSelectProducts;
    private final ArrayList<Address> deliverableAddresses = new ArrayList<>();
    private final ArrayList<DefaultInstructions> defaultInstructions = new ArrayList<>();
    private final ArrayList<DefaultInstructions> selectedDeliveryInstructions = new ArrayList<>();
    private ProgressBar pbAddress;
    private LinearLayout llAddress, llSelectProducts;
    private Address deliverableAddress;
    private RadioGroup rgTip;
    private RadioButton rb1, rb2, rbEdit, rbNo, rbCustom;
    private final boolean dineIn = false;
    private LinearLayout llSplitWalletMethod;
    private TextView tvSplitWalletInfo, tvWalletSplitName;
    private ImageView ivCloseSplit;
    private LinearLayout llTip, llCharity;
    private CheckBox cbCharity;
    private TextView tvCharity;
    private DefaultInstructionsAdapter defaultInstructionsAdapter;
    private RecyclerView rvInstructions;
    private TextView tvEditOrder;
    private CheckBox cbRedeem;
    private TextView tvRedeemPoints, tvEarn;
    private LinearLayout llRedeem, llEarn;
    private LinearLayout llCustomDelivery, llCustomPickup, llTopCustomDelivery, llTopCustomPickup, ll_DriverTip;
    private ImageView ivCustomDelivery, ivCustomPickup;
    private TextView tvCustomDelivery, tvCustomPickup, tvDriverTip;
    private TextView tvCustomSubDelivery, tvCustomSubPickup, tvVoucherList;
    private LinearLayout cvDeliveryDate;
    private LinearLayout llData;
    private boolean LoadData = false;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if (getActivity() != null)
            getActivity().getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE);
        new Thread(() -> {
            res_id = myApp.getAppDatabase().cartDao().getRestaurantId();
        }).start();
        return inflater.inflate(R.layout.fragment_cart_checkout, container, false);
    }

    private void fetchCartSummary() {
        new Thread(() -> {
            cartSummary = myApp.getAppDatabase().cartDao().getCartSummary();
            cartSubtotal = cartSummary.total;
            CommonFunctions.notifyCartCount(getContext());
            checkAndGetRewards();
        }).start();
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if (getArguments() != null) {
            boolean showBack = getArguments().getBoolean("show_back", false);
            if (showBack) {
                ivBackArrow.setVisibility(View.VISIBLE);
            } else {
                ivBackArrow.setVisibility(View.GONE);
            }
        }
        selectedTimeSlot = "";
        pickupTimeSlot = "";
        deliveryTimeSlot = "";
        orderType = 0;
        setListeners();
        firstMethod();
    }

    private void firstMethod() {
        new Handler().postDelayed(() -> {
            if (loggedInUser == null) {
                startActivity(new Intent(getActivity(), AuthActivity.class));
                getActivity().finish();
            } else {
                if (res_id != 0 && res_id != -1) {
                    fetchData();
                    loadGoogleMap();
                } else {
                    showEmptyCartUi();
                }
            }
        }, 10);

    }

    private void loadGoogleMap() {
        if (mapFragment == null) {
            mapFragment = SupportMapFragment.newInstance();
            mapFragment.getMapAsync(googleMap -> {
                if (getActivity() != null) {
                    userMap = googleMap;
                    if (defaultAddress != null) {
                        LatLng restaurantLocation = new LatLng(Double.parseDouble(defaultAddress.latitude), Double.parseDouble(defaultAddress.longitude));
                        googleMap.addMarker(new MarkerOptions()
                                .position(restaurantLocation)
                                .title(defaultAddress.flat_no + ", " + defaultAddress.address));
                        float zoom = 15;
                        googleMap.moveCamera(CameraUpdateFactory.newLatLngZoom(restaurantLocation, zoom));
                    }
                }
            });
            getChildFragmentManager()
                    .beginTransaction()
                    .add(R.id.map, mapFragment)
                    .commit();
        }

    }

    private void showEmptyCartUi() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                llData.setVisibility(View.GONE);
                llLoading.setVisibility(View.GONE);
                rlNoData.setVisibility(View.VISIBLE);
                CommonFunctions.notifyCartCount(getContext());
            });
        }
        new Thread(() -> {
            CommonFunctions.deleteAllCart();
        }).start();

    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);
        tvVoucherList = view.findViewById(R.id.tvVoucherLists);
        tvScreenTitle = view.findViewById(R.id.tvScreenTitle);
        ivBackArrow = view.findViewById(R.id.ivBackArrow);
        llBackArrow = view.findViewById(R.id.llBackArrow);
        tvUserName = view.findViewById(R.id.tvUserName);

        tvScreenTitle.setText("Checkout");
        tvScreenTitle.setVisibility(View.VISIBLE);
        ll_Discount = view.findViewById(R.id.ll_Discount);
        ll_Reward_Discount = view.findViewById(R.id.ll_Reward_Discount);
        rlNoData = view.findViewById(R.id.llNoData);
        llLoading = view.findViewById(R.id.llLoading);
        pbLoading = view.findViewById(R.id.pbLoading);
        nestedScrollView = view.findViewById(R.id.nestedScrollView);
        llData = view.findViewById(R.id.llData);

        llData.setVisibility(View.GONE);
        llLoading.setVisibility(View.VISIBLE);

        pbAddress = view.findViewById(R.id.pbAddress);
        llAddress = view.findViewById(R.id.llAddressBlock);

        tvUserName = view.findViewById(R.id.tvUserName);
        tvAddressUsername = view.findViewById(R.id.tvAddressUsername);
        tvAddress = view.findViewById(R.id.tvAddress);
        tvZipcode = view.findViewById(R.id.tvZipcode);
        tvChangeAddress = view.findViewById(R.id.tvChangeLocation);

        ivRestaurantLogo = view.findViewById(R.id.ivRestaurantLogo);
        rvCartItems = view.findViewById(R.id.rvCartItems);
        tvDeliveryDate = view.findViewById(R.id.tvDeliveryDate);

        cvDeliveryInstructions = view.findViewById(R.id.cvDeliveryInstructions);
        llDeliveryInstructions = view.findViewById(R.id.llDeliveryInstructions);

        llCustomDelivery = view.findViewById(R.id.llLeft);
        llCustomPickup = view.findViewById(R.id.llRight);

        llTopCustomDelivery = view.findViewById(R.id.topLeft);
        llTopCustomPickup = view.findViewById(R.id.topRight);

        tvCustomDelivery = view.findViewById(R.id.title1);
        tvCustomPickup = view.findViewById(R.id.title2);
        tvCustomSubDelivery = view.findViewById(R.id.subtitle1);
        tvCustomSubPickup = view.findViewById(R.id.subtitle2);
        ivCustomDelivery = view.findViewById(R.id.icon1);
        ivCustomPickup = view.findViewById(R.id.icon2);
        cvDeliveryDate = view.findViewById(R.id.cvDeliveryDate);

        tvDeliveryInstructions = view.findViewById(R.id.tvDeliveryInstructions);
        etDeliveryInstructions = view.findViewById(R.id.etDeliveryInstructions);
        etDeliveryInstructions.clearFocus();

        etPromocode = view.findViewById(R.id.etPromocode);
        btnApplyPromocode = view.findViewById(R.id.btnPromoApply);

        tvOrderDateLabel = view.findViewById(R.id.tvOrderDateLabel);

        tvSelectProducts = view.findViewById(R.id.tvSelectProducts);
        llSelectProducts = view.findViewById(R.id.llSelectProducts);
        ivSelectProduct = view.findViewById(R.id.ivSelectProducts);
        llSelectProducts.setEnabled(false);

        tvSubtotal = view.findViewById(R.id.tvSubtotal);
        tvDeliveryFee = view.findViewById(R.id.tvDeliveryFee);
        tvServiceFee = view.findViewById(R.id.tvServiceFee);
        tvDriverTip = view.findViewById(R.id.tvDriverTip);
        llServiceCharge = view.findViewById(R.id.ll_ServiceCharge);
        llDeliveryFee = view.findViewById(R.id.llDeliveryFee);
        ll_DriverTip = view.findViewById(R.id.ll_DriverTip);
        tvDiscount = view.findViewById(R.id.tvDiscount);
        cvDiscount = view.findViewById(R.id.cvDiscount);
        tvRewardDiscount = view.findViewById(R.id.tvRewardDiscount);
        tvTotal = view.findViewById(R.id.tvTotal);
        tvOrderTotal = view.findViewById(R.id.tvOrderTotal);

        llPaymentMethod = view.findViewById(R.id.llPaymentMethod);
        tvPaymentMethodName = view.findViewById(R.id.tvPaymentMethodName);
        ivPaymentMethod = view.findViewById(R.id.ivPaymentMethod);

        tvWalletSplitName = view.findViewById(R.id.tvWalletSplitName);
        llSplitWalletMethod = view.findViewById(R.id.llWalletSplit);
        tvSplitWalletInfo = view.findViewById(R.id.tvWalletSplitInfo);
        ivCloseSplit = view.findViewById(R.id.ivCloseSplit);

        etOrderInstruction = view.findViewById(R.id.etOrderInstruction);
        llPlaceOrder = view.findViewById(R.id.llPlaceOrder);
        llTip = view.findViewById(R.id.llTip);

        llCharity = view.findViewById(R.id.llCharity);
        tvCharity = view.findViewById(R.id.tvCharityAmount);
        cbCharity = view.findViewById(R.id.cbCharity);
        llCherityFee = view.findViewById(R.id.llCherityFee);
        cvCharityFee = view.findViewById(R.id.cvCharityFee);
        tvCharityFee = view.findViewById(R.id.tvCharityFee);

        llRedeem = view.findViewById(R.id.llRedeem);
        cbRedeem = view.findViewById(R.id.cbRedeem);
        tvRedeemPoints = view.findViewById(R.id.tvRedeemPoints);
        animationRedeemLoading = view.findViewById(R.id.animationRedeemLoading);
        tvEarn = view.findViewById(R.id.tvEarn);
        llEarn = view.findViewById(R.id.llEarn);

        rgTip = view.findViewById(R.id.rgTip);
        rbNo = view.findViewById(R.id.rbNo);
        rb1 = view.findViewById(R.id.rb1);
        rb2 = view.findViewById(R.id.rb2);
        rbCustom = view.findViewById(R.id.rbCustom);
        rbEdit = view.findViewById(R.id.rbEdit);
        tvEditOrder = view.findViewById(R.id.tvEditOrder);


        rvInstructions = view.findViewById(R.id.rvDeliveryInstructions);
        rvInstructions.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.HORIZONTAL, false));
        defaultInstructionsAdapter = new DefaultInstructionsAdapter(defaultInstructions, (position, data) -> {
            selectedDeliveryInstructions.clear();
            ArrayList<DefaultInstructions> defaultInstructionsArrayList = (ArrayList<DefaultInstructions>) data;
            for (DefaultInstructions defaultInst : defaultInstructionsArrayList) {
                if (defaultInst.isSelected) {
                    selectedDeliveryInstructions.add(defaultInst);
                } else {
                    selectedDeliveryInstructions.remove(defaultInst);
                }
            }
        });
        rvInstructions.setAdapter(defaultInstructionsAdapter);

        rvCartItems.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));

        cartBasketItemsAdapter = new CartBasketItemsAdapter(getActivity(), feed, (position, data) -> {
            if (data instanceof CartItem) {
                incrementQuantity(position, data);
            } else if (data instanceof Menu) {
                if (((Menu) data).price_option.equalsIgnoreCase("multiple") || ((Menu) data).menu_addon.equalsIgnoreCase("yes")) {
                    MenuItemDetailBottomsheetFragment menuItemDetailBottomsheetFragment = MenuItemDetailBottomsheetFragment.getInstance((Menu) data);
                    menuItemDetailBottomsheetFragment.show(getChildFragmentManager(), "addon");
                    menuItemDetailBottomsheetFragment.setDialogDismissListener(addItemCartDialogListener);
                } else {
                    addItemToCart((Menu) data, position);
                }
            }
        }, (position, data) -> {
            if (data instanceof CartItem) {
                decrementQuantity(position, data);
            }
        });
        rvCartItems.setAdapter(cartBasketItemsAdapter);
        rvCartItems.setItemAnimator(null);

        today_day = calendar.get(Calendar.DAY_OF_MONTH);
        today_month = calendar.get(Calendar.MONTH);
        today_year = calendar.get(Calendar.YEAR);
        delivery_month = today_month + 1;
        delivery_year = today_year;
        delivery_date = today_day;

        tvDeliveryDate.setText("Select date: Today");
        defaultAddress = myApp.getMyPreferences().getCurrentAddress();

        rb1.setText(myApp.getCurrencySymbol() + "1.00");
        rb2.setText(myApp.getCurrencySymbol() + "2.00");

        if (myApp.getMyPreferences().getSiteSettings().charity_amount > 0) {
            tvCharity.setText(currency + MyApp.df.format(myApp.getMyPreferences().getSiteSettings().charity_amount));
            cbCharity.setText(myApp.getMyPreferences().getSiteSettings().charity_message);
            llCharity.setVisibility(View.VISIBLE);
        } else {
            llCharity.setVisibility(View.GONE);
        }

        llSelectProducts.setVisibility(View.GONE);


    }

    private TimeSlot selectedDeliveryTimeSlot, selectedPickupTimeSlot;

    private void setListeners() {
        llBackArrow.setOnClickListener(view -> {
            if (getActivity() != null) {
                getActivity().onBackPressed();
            }
        });
        llCustomPickup.setOnClickListener(view -> {
            pickupType(1);
            if (llCustomDelivery.isEnabled())
                deliveryType(2);
            if (selectedPickupTimeSlot != null) {
                tvDeliveryDate.setText(selectedPickupTimeSlot.name);
            } else {
                tvDeliveryDate.setText(getFirstSlot(restaurant.pickup_time_slot));
            }
            appliedVoucher = null;
            CommonFunctions.hideKeyboard(getActivity(), etPromocode);
            if (voucherApplied)
                validateVoucher(false);
            else cartCalculations();
        });
        llCustomDelivery.setOnClickListener(view -> {
            deliveryType(1);
            if (llCustomPickup.isEnabled())
                pickupType(2);
            if (selectedDeliveryTimeSlot != null) {
                tvDeliveryDate.setText(selectedDeliveryTimeSlot.name);
            } else {
                tvDeliveryDate.setText(getFirstSlot(restaurant.delivery_time_slot));
            }
            appliedVoucher = null;
            CommonFunctions.hideKeyboard(getActivity(), etPromocode);
            if (voucherApplied)
                validateVoucher(false);
            else cartCalculations();
        });
        llTopCustomDelivery.setOnClickListener(view -> {
            if (llCustomDelivery.isEnabled()) llCustomDelivery.performClick();
            else if (LoadData)
                showRestaurantIsClosed(restaurant.restaurant_name + " is not providing delivery at the moment", false);
        });
        llTopCustomPickup.setOnClickListener(view -> {
            if (llCustomPickup.isEnabled()) llCustomPickup.performClick();
            else if (LoadData)
                showRestaurantIsClosed(restaurant.restaurant_name + " is not providing collections at the moment", false);
        });
        tvDeliveryDate.setOnClickListener(view -> {
            TimeSlots tslot = null;
            TimeSlot selectedSlot;
            if (orderType == 1) {
                tslot = restaurant.delivery_time_slot;
                selectedSlot = selectedDeliveryTimeSlot;
            } else if (orderType == 2) {
                tslot = restaurant.pickup_time_slot;
                selectedSlot = selectedPickupTimeSlot;
            } else {
                return;
            }
            if (selectedSlot == null) {
                selectedSlot = new TimeSlot();
                selectedSlot.name = selectedTimeSlot;
            }
            ShowTimeSlotBottomSheetFragment timeSlotBottomSheetFragment = ShowTimeSlotBottomSheetFragment.getInstance(tslot, selectedSlot);
            timeSlotBottomSheetFragment.show(getChildFragmentManager(), "timeslots");
            timeSlotBottomSheetFragment.setDialogDismissListener(o -> {
                TimeSlot t = (TimeSlot) o;
                tvDeliveryDate.setText(t.name);
                if (orderType == 1) {
                    isDeliveryType = true;
                    selectedDeliveryTimeSlot = t;
                    deliveryTimeSlot = selectedDeliveryTimeSlot.time;
                    selectedTimeSlot = deliveryTimeSlot;
                }
                if (orderType == 2) {
                    selectedPickupTimeSlot = t;
                    isDeliveryType = false;
                    pickupTimeSlot = selectedPickupTimeSlot.time;
                    selectedTimeSlot = pickupTimeSlot;
                }
                Calendar calendar = Calendar.getInstance();
                calendar.add(Calendar.DAY_OF_MONTH, t.plusDay);
                delivery_date = calendar.get(Calendar.DAY_OF_MONTH);
                delivery_month = calendar.get(Calendar.MONTH) + 1;
                delivery_year = calendar.get(Calendar.YEAR);

                cartCalculations();
            });

        });
        btnApplyPromocode.setOnClickListener(view -> {
            if (voucherApplied) {
                voucherApplied = false;
                appliedVoucher = null;
                validateVoucher(false);
                ToastUtils.makeSnackToast(getActivity(), "Promo code removed");
            } else {
                if (!Validators.isNullOrEmpty(etPromocode.getText().toString())) {
                    new Thread(this::applyPromocode).start();
                } else {
                    ToastUtils.makeSnackToast(getActivity(), "Please enter promo code first");
                }
            }
        });
        tvVoucherList.setOnClickListener(view -> {
            VoucherListBottomsheetFragment voucherListBottomsheetFragment = VoucherListBottomsheetFragment.getInstance(restaurant, orderType == 1 ? "delivery" : "pickup", orderType == 1 ? selectedDeliveryTimeSlot != null ? selectedDeliveryTimeSlot.date : "" + delivery_year + "-" + delivery_month + "-" + delivery_date : selectedPickupTimeSlot != null ? selectedPickupTimeSlot.date : "" + delivery_year + "-" + delivery_month + "-" + delivery_date);
            voucherListBottomsheetFragment.show(getActivity().getSupportFragmentManager(), "vouchers");
            voucherListBottomsheetFragment.setDialogDismissListener((data) -> {
                if (data instanceof Voucher) {
                    etPromocode.setText(((Voucher) data).voucher_code);
                    applyPromocode();
//                    applyPromocode();
//                    voucherApplied = true;
//                    validateVoucher(true);
                }
            });
        });
        tvChangeAddress.setOnClickListener(view -> {
            openDeliveryAddressDialog(true);
        });
        llPlaceOrder.setOnClickListener(view -> {

            if (isValidOrder()) {
                {
                    startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "payment_method").putExtra("name", "Payment")
                            .putExtra("dineIn", dineIn).putExtra("wallet_payment", restaurant.wallet_payment).putExtra("dinein_wallet_payment", restaurant.dinein_wallet_payment)
                            .putExtra("restaurant_id", String.valueOf(res_id)).putExtra("place_order", new Gson().toJson(PlaceOrderParms())).putExtra("Total", getCartTotal()));

                }
            }
        });

        ivCloseSplit.setOnClickListener(view -> {
            cartCalculations();
            llSplitWalletMethod.setVisibility(View.GONE);
            split = false;
            paidFull = true;
        });
        rgTip.setOnCheckedChangeListener((radioGroup, i) -> {
            if (i == R.id.rbNo) {
                cartTip = 0;
            } else if (i == R.id.rb1) {
                cartTip = 1;
            } else if (i == R.id.rb2) {
                cartTip = 2;
            } else if (i == R.id.rbCustom) {
                cartTip = customTipAmount;
            } else if (i == R.id.rbEdit) {
                showEditTip();
            }
            cartCalculations();
        });
        cbCharity.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) {
                cartCharity = myApp.getMyPreferences().getSiteSettings().charity_amount;
                llCherityFee.setVisibility(View.VISIBLE);
                cvCharityFee.setText(myApp.getMyPreferences().getSiteSettings().charity_message);
            } else {
                cartCharity = 0;
                llCherityFee.setVisibility(View.GONE);
            }
            cartCalculations();
        });
        tvEditOrder.setOnClickListener(view -> {
            startActivity(new Intent(getActivity(), RestaurantDetailsActivity.class).putExtra("resId", res_id).putExtra("res_name", restaurant.restaurant_name));
            if (getActivity() != null) getActivity().finish();
        });

        llSelectProducts.setOnClickListener(view -> {
            MultipleFreeItemsOfferBottomFragment multipleFreeItemsOfferBottomFragment = MultipleFreeItemsOfferBottomFragment.getInstance(appliedPriceOffer, appliedPriceOffer.getProducts());
            multipleFreeItemsOfferBottomFragment.show(getChildFragmentManager(), "multiple_product_offers");
            multipleFreeItemsOfferBottomFragment.setDialogDismissListener((o) -> {
                new RemoveFreeItemAsync(() -> {
                    if (o instanceof MultiplePriceOffer) {
                        appliedPriceOffer = (MultiplePriceOffer) o;
                        tvSelectProducts.setText("Free product(s) selected, Click to view/change");
                        ArrayList<OfferProduct> products = appliedPriceOffer.getProducts();
                        for (OfferProduct offerProduct : products) {
                            if (offerProduct.checked && offerProduct.quantity > 0) {
                                CartItem toBeSave = new CartItem();
                                toBeSave.Menu_price = 0;
                                toBeSave.menu_id = 0;
                                toBeSave.id = 0;
                                toBeSave.menu_name = offerProduct.name;
                                toBeSave.menu_size = "";
                                toBeSave.res_id = res_id;
                                toBeSave.menu_type = "";
                                toBeSave.quantity = offerProduct.quantity;
                                toBeSave.Addon_name = "Offer";
                                toBeSave.Addon_price = 0;
                                toBeSave.Total = 0;
                                freeItems.add(toBeSave);
                                offerApplied = true;
                            }
                        }
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                feed.addAll(freeItems);
                                showSuggestions();
                                cartBasketItemsAdapter.notifyDataSetChanged();


                            });
                        }
                    }
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);

            });

        });


    }

    private void fetchData() {
        new Thread(this::fetchRestaurantDetails).start();
    }

    private void fetchRestaurantDetails() {
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> {
                llLoading.setVisibility(View.VISIBLE);
                llData.setVisibility(View.GONE);
                llPlaceOrder.setEnabled(false);
            });
        ApiUtils.getRestaurantDetails(String.valueOf(res_id), String.valueOf(loggedInUser.id), myApp.getMyPreferences().getCurrentPostcode().post_code)
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {

                        restaurant = new Gson().fromJson(String.valueOf(response.toString()), Restaurant.class);
                        fetchMenuItem();
                        fetchTimeSlots();
                        fetchAllOffers();
                        myApp.getMyPreferences().saveOrderRestaurant(restaurant);

                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                llLoading.setVisibility(View.GONE);
                                llData.setVisibility(View.VISIBLE);
                                llPlaceOrder.setEnabled(true);
                            });
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                llLoading.setVisibility(View.GONE);
                                llData.setVisibility(View.VISIBLE);
                                llPlaceOrder.setEnabled(true);
                            });
                        }
                        LogUtils.e("FETCH RESTAURANT FROM CART:::::", anError.getErrorBody());
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void fetchTimeSlots() {
        ApiUtils.getRestaurantTimeSlots(String.valueOf(res_id), CommonFunctions.getToday())
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        try {
                            JSONObject JsonObject = new JSONObject(response.toString());
                            restaurant.delivery_time_slot = new Gson().fromJson(JsonObject.getJSONObject("delivery").toString(), TimeSlots.class);
                            restaurant.pickup_time_slot = new Gson().fromJson(JsonObject.getJSONObject("pickup").toString(), TimeSlots.class);
                            if (getActivity() != null)
                                validateRestaurantOpeningAndClosing();
                        } catch (JSONException e) {
                            e.printStackTrace();
                            ToastUtils.makeToast(getContext(), e.toString());
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                    }
                });
    }

    private void setupDeliveryInstructions() {
        selectedDeliveryInstructions.clear();
        if (restaurant.checkout_list != null && restaurant.checkout_list.size() > 0) {
            defaultInstructions.clear();
            for (DefaultInstructions defaultInstruction : restaurant.checkout_list) {
                defaultInstruction.isSelected = false;
                if (orderType == 2 && defaultInstruction.order_type.equalsIgnoreCase("pickup")) {
                    defaultInstructions.add(defaultInstruction);
                } else if (orderType == 1 && defaultInstruction.order_type.equalsIgnoreCase("delivery")) {
                    defaultInstructions.add(defaultInstruction);
                } else if (defaultInstruction.order_type.equalsIgnoreCase("both"))
                    defaultInstructions.add(defaultInstruction);
            }

            if (getActivity() != null)
                getActivity().runOnUiThread(() -> {
                    if (defaultInstructions.size() > 0) {
                        rvInstructions.setVisibility(View.VISIBLE);
                    } else {
                        rvInstructions.setVisibility(View.GONE);
                    }
                    defaultInstructionsAdapter.notifyDataSetChanged();
                });

        }
    }

    private void setupDeliveryInstructions(String OrderType) {
        restaurant.checkout_list.clear();
        AndroidNetworking.get(ApiEndPoints.NEW_CHECKOUT_LIST)
                .addQueryParameter("order_type", OrderType.equalsIgnoreCase("1") ? "delivery" : "pickup")
                .addQueryParameter("restaurant_id", String.valueOf(res_id))
                .build().getAsJSONArray(new JSONArrayRequestListener() {
            @Override
            public void onResponse(JSONArray response) {
                Type type = new TypeToken<List<DefaultInstructions>>() {
                }.getType();
                ArrayList<DefaultInstructions> checkout_list = new ArrayList<>(new Gson().fromJson(response.toString(), type));
                try {
                    restaurant.checkout_list.addAll(checkout_list);
                    setupDeliveryInstructions();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            @Override
            public void onError(ANError anError) {
                anError.getErrorBody();
                rvInstructions.setVisibility(View.GONE);
            }
        });
    }

    private void validateRestaurantOpeningAndClosing() {
        if (restaurant.online_order.equalsIgnoreCase("no")) {
            showRestaurantIsClosed("Unfortunately, " + restaurant.restaurant_name + " is currently not accepting online orders", true);
            deliveryType(0);
            pickupType(0);
            orderType = 0;
        } else if (restaurant.status.equalsIgnoreCase("false") || (restaurant.restaurant_delivery.equalsIgnoreCase("no") && restaurant.restaurant_pickup.equalsIgnoreCase("no"))) {
            showRestaurantIsClosed("Unfortunately, " + restaurant.restaurant_name + " is currently closed", true);
            deliveryType(0);
            pickupType(0);
            orderType = 0;
            cvDeliveryDate.setVisibility(View.GONE);
        } else {
            if (!restaurant.restaurant_delivery.equalsIgnoreCase("no") && isSlotsAvailable(restaurant.delivery_time_slot)) {
                deliveryType(1);
                orderType = 1;
                cvDeliveryDate.setVisibility(View.VISIBLE);
                tvDeliveryDate.setText(getFirstSlot(restaurant.delivery_time_slot));
                if (restaurant.restaurant_pickup.equalsIgnoreCase("no") || !isSlotsAvailable(restaurant.pickup_time_slot)) {
                    pickupType(0);
                }
            } else {
                deliveryType(0);
                orderType = 0;
                if (!restaurant.restaurant_pickup.equalsIgnoreCase("no") && isSlotsAvailable(restaurant.pickup_time_slot)) {
                    pickupType(1);
                    tvDeliveryDate.setText(getFirstSlot(restaurant.pickup_time_slot));
                    orderType = 2;
                    cvDeliveryDate.setVisibility(View.VISIBLE);
                } else {
                    pickupType(0);
                    orderType = 0;
                    cvDeliveryDate.setVisibility(View.GONE);
                }
            }

        }
        continueSetupCheckoutScreen();
        if (orderType == 0) {
            showRestaurantIsClosed("Unfortunately, " + restaurant.restaurant_name + " is currently closed", true);
        }
    }

    private boolean isSlotsAvailable(TimeSlots timeSlots) {

        return !(Validators.isNullOrEmpty(timeSlots.today) && Validators.isNullOrEmpty(timeSlots.tomorrow) && Validators.isNullOrEmpty(timeSlots.dayaftertomorrow));
    }

    private void showRestaurantIsClosed(String message, boolean shouldGoBack) {
        RestaurantClosedDialogFragment restaurantClosedDialogFragment = RestaurantClosedDialogFragment.getInstance(message);
        restaurantClosedDialogFragment.show(getChildFragmentManager(), "restaurant_closed");
        restaurantClosedDialogFragment.setDialogDismissListener(o -> {
            if (shouldGoBack) {
                if (getActivity() != null)
                    getActivity().onBackPressed();
            }
        });
    }

    private void continueSetupCheckoutScreen() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                Glide.with(getActivity())
                        .load(restaurant.image_url)
                        .placeholder(R.drawable.restaurant_logo_placeholder)
                        .error(R.drawable.restaurant_logo_placeholder)
                        .into(ivRestaurantLogo);
                updateAddress();
                updateCartAdapterAndAmount();
//                displayPaymentMethod();
                fetchCartSummary();
                updateTipLayoutVisibility();
            });
        }
    }


    private void updateTipLayoutVisibility() {
        if (restaurant != null) {
            if (orderType == 1 && restaurant.driver_tip) {
                llTip.setVisibility(View.VISIBLE);
                if (cartTip == 0) {
                    rbNo.setChecked(true);
                } else if (cartTip == 1) {
                    rb1.setChecked(true);
                } else if (cartTip == 2) {
                    rb2.setChecked(true);
                } else if (customTipAmount > 0) {
                    rbCustom.setChecked(true);
                }
            } else {
                llTip.setVisibility(View.GONE);
                cartTip = 0;
            }
        }
    }

    private void deliveryType(int state) {
        if (state == 0) { // Unavailable
            llCustomDelivery.setBackgroundResource(R.drawable.round_corner_left_radio_normal);
            ivCustomDelivery.setImageResource(R.drawable.icon_delivery);
            tvCustomDelivery.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
            tvCustomSubDelivery.setVisibility(View.VISIBLE);
            llCustomDelivery.setEnabled(false);
            cvDeliveryInstructions.setVisibility(View.GONE);
            tvChangeAddress.setVisibility(View.GONE);
        }
        if (state == 1) {
            //Selected
            llCustomDelivery.setBackgroundResource(R.drawable.round_corner_left_radio_selected);
            ivCustomDelivery.setImageResource(R.drawable.icon_delivery_white);
            tvCustomDelivery.setTextColor(ContextCompat.getColor(getActivity(), R.color.white));
            tvCustomSubDelivery.setVisibility(View.GONE);
            tvOrderDateLabel.setText("Delivery date & time");
            cvDeliveryInstructions.setVisibility(View.VISIBLE);
            etDeliveryInstructions.clearFocus();
            tvChangeAddress.setVisibility(View.VISIBLE);
            orderType = 1;
            setupDeliveryInstructions(String.valueOf(orderType));
        }
        if (state == 2) {
            //Un Selected
            llCustomDelivery.setBackgroundResource(R.drawable.round_corner_left_radio_normal);
            ivCustomDelivery.setImageResource(R.drawable.icon_delivery);
            tvCustomDelivery.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
            tvCustomSubDelivery.setVisibility(View.GONE);
            cvDeliveryInstructions.setVisibility(View.GONE);
        }
        updateTipLayoutVisibility();
    }

    private void pickupType(int state) {
        if (state == 0) { // Unavailable
            llCustomPickup.setBackgroundResource(R.drawable.round_corner_right_radio_normal);
            ivCustomPickup.setImageResource(R.drawable.icon_pickup);
            tvCustomPickup.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
            tvCustomSubPickup.setVisibility(View.VISIBLE);
            llCustomPickup.setEnabled(false);
        }
        if (state == 1) {
            //Selected
            llCustomPickup.setBackgroundResource(R.drawable.round_corner_right_radio_selected);
            ivCustomPickup.setImageResource(R.drawable.icon_pickup_white);
            tvCustomPickup.setTextColor(ContextCompat.getColor(getActivity(), R.color.white));
            tvCustomSubPickup.setVisibility(View.GONE);
            tvOrderDateLabel.setText("Collection date & time");
            tvChangeAddress.setVisibility(View.GONE);
            orderType = 2;
            setupDeliveryInstructions(String.valueOf(orderType));
        }
        if (state == 2) {
            //Un Selected
            llCustomPickup.setBackgroundResource(R.drawable.round_corner_right_radio_normal);
            ivCustomPickup.setImageResource(R.drawable.icon_pickup);
            tvCustomPickup.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
            tvCustomSubPickup.setVisibility(View.GONE);
        }
        updateTipLayoutVisibility();
    }

    private String getFirstSlot(TimeSlots timeSlots) {
        String firstTimeslot = "";
        if (timeSlots != null) {
            if (!Validators.isNullOrEmpty(timeSlots.today)) {
                String[] timeSlotsArray = timeSlots.today.split(",");
                if (timeSlotsArray.length > 0) {
                    for (String slot : timeSlotsArray) {
                        Date slotDateTime = CommonFunctions.convertStringDateToDate(CommonFunctions.formatMili(System.currentTimeMillis(), "dd-MM-yyyy") + " " + slot, "dd-MM-yyyy hh:mm a");
                        Date today = new Date();
                        if (slotDateTime.before(today)) {
                            selectedTimeSlot = "ASAP";
                            if (orderType == 1) {
                                deliveryTimeSlot = selectedTimeSlot;
                                selectedDeliveryTimeSlot = new TimeSlot();
                                selectedDeliveryTimeSlot.date = CommonFunctions.formatMili(System.currentTimeMillis(), "yyyy-MM-dd");
                                selectedDeliveryTimeSlot.name = "ASAP";
                                selectedDeliveryTimeSlot.time = CommonFunctions.formatMili(System.currentTimeMillis(), "hh:mm a");
                            }
                            if (orderType == 2) {
                                pickupTimeSlot = selectedTimeSlot;
                                selectedPickupTimeSlot = new TimeSlot();
                                selectedPickupTimeSlot.date = CommonFunctions.formatMili(System.currentTimeMillis(), "yyyy-MM-dd");
                                selectedPickupTimeSlot.name = "ASAP";
                                selectedPickupTimeSlot.time = CommonFunctions.formatMili(System.currentTimeMillis(), "hh:mm a");
                            }
                            return "ASAP";
                        }
                    }
                }
                selectedTimeSlot = timeSlotsArray[0];
                firstTimeslot = String.format("Today: %s", CommonFunctions.formatDate(selectedTimeSlot, "hh:mm a", "HH:mm"));
                Calendar calendar = Calendar.getInstance();
                delivery_date = calendar.get(Calendar.DAY_OF_MONTH);
                delivery_month = calendar.get(Calendar.MONTH) + 1;
                delivery_year = calendar.get(Calendar.YEAR);
                return firstTimeslot;
            } else if (!Validators.isNullOrEmpty(timeSlots.tomorrow)) {
                String[] timeSlotsArray = timeSlots.tomorrow.split(",");
                if (timeSlotsArray.length > 0) {
                    selectedTimeSlot = timeSlotsArray[0];
                    Calendar calendar = Calendar.getInstance();
                    calendar.add(Calendar.DAY_OF_MONTH, 1);
                    delivery_date = calendar.get(Calendar.DAY_OF_MONTH);
                    delivery_month = calendar.get(Calendar.MONTH) + 1;
                    delivery_year = calendar.get(Calendar.YEAR);
                    firstTimeslot = String.format("Tomorrow: %s", CommonFunctions.formatDate(selectedTimeSlot, "hh:mm a", "HH:mm"));
                    return firstTimeslot;
                }
            } else if (!Validators.isNullOrEmpty(timeSlots.dayaftertomorrow)) {
                String[] timeSlotsArray = timeSlots.dayaftertomorrow.split(",");
                if (timeSlotsArray.length > 0) {
                    selectedTimeSlot = timeSlotsArray[0];
                    Calendar calendar = Calendar.getInstance();
                    calendar.add(Calendar.DAY_OF_MONTH, 2);
                    delivery_date = calendar.get(Calendar.DAY_OF_MONTH);
                    delivery_month = calendar.get(Calendar.MONTH) + 1;
                    delivery_year = calendar.get(Calendar.YEAR);
                    firstTimeslot = String.format("%d/%d/%d: %s", delivery_date, delivery_month, delivery_year, CommonFunctions.formatDate(selectedTimeSlot, "hh:mm a", "HH:mm"));
                    return firstTimeslot;
                }
            }
        }
        return "Closed";
    }

    private void displayPaymentMethod() {

        paymentMethod = myApp.getMyPreferences().getDefaultPaymentMethod();
        if (paymentMethod != null) {
            if (!Validators.isNullOrEmpty(restaurant.wallet_payment)) {
                boolean canBeAdd = false;
                if (dineIn && restaurant.dinein_wallet_payment.equalsIgnoreCase("yes")) {
                    canBeAdd = true;
                }
                if (restaurant.wallet_payment.equalsIgnoreCase("yes")) {
                    canBeAdd = true;
                }
                if (canBeAdd && (paymentMethod.type.equalsIgnoreCase("wallet") || canBeAdd && paymentMethod.type.equalsIgnoreCase("credit"))) {
                    displayDefaultPayment();
                    return;
                } else {
                    displaySelectPaymentMethod();
                }
            }
            for (RestaurantPaymentMethod restaurantPaymentMethod : restaurant.payment_methods) {
                if (restaurantPaymentMethod.payment_method.payment_method_name.equalsIgnoreCase("cod")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd && paymentMethod.type.equalsIgnoreCase("cod")) {
                        displayDefaultPayment();
                        return;
                    } else {
                        displaySelectPaymentMethod();
                    }
                } else if (restaurantPaymentMethod.payment_method.payment_method_name.equalsIgnoreCase("stripe")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd && paymentMethod.type.equalsIgnoreCase("stripe")) {
                        displayDefaultPayment();
                        return;
                    } else {
                        displaySelectPaymentMethod();
                    }
                } else if (restaurantPaymentMethod.payment_method.payment_method_name.equalsIgnoreCase("paypal")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd && paymentMethod.type.equalsIgnoreCase("paypal")) {
                        displayDefaultPayment();
                        return;
                    } else {
                        displaySelectPaymentMethod();
                    }
                }

            }
        } else {
            displaySelectPaymentMethod();
        }

    }

    private void displaySelectPaymentMethod() {
        ivPaymentMethod.setVisibility(View.GONE);
        tvPaymentMethodName.setText(null);
        tvPaymentMethodName.setHint("Select payment method");
    }

    private void displayDefaultPayment() {
        ivPaymentMethod.setVisibility(View.VISIBLE);
        tvPaymentMethodName.setHint(null);
        int logo = myApp.paymentMethodLogo(paymentMethod);
        if (logo != -1) {
            ivPaymentMethod.setImageResource(logo);
        } else {
            ivPaymentMethod.setVisibility(View.INVISIBLE);
        }
        tvPaymentMethodName.setText(paymentMethod.title);
    }

    private void updateCartAdapterAndAmount() {
        new Thread(() -> {
            feed.clear();
            cartItems.clear();
            cartItems.addAll(myApp.getAppDatabase().cartDao().getAll());
            if (cartItems.size() == 0) {
                showEmptyCartUi();
            } else {
                feed.addAll(cartItems);
                if (getActivity() != null) {
                    getActivity().runOnUiThread(() -> {
                        cartBasketItemsAdapter.notifyDataSetChanged();
                    });
                }

//                ArrayList<UploadCartItems> cartItemArrayList = new ArrayList<>();
                cartItemArrayList.clear();
                for (CartItem c : cartItems) {
                    UploadCartItems uploadCartItems = new UploadCartItems();
                    if (!Validators.isNullOrEmpty(c.Addon_name)) {
                        uploadCartItems.subaddons_name = c.menu_name + ":" + c.Addon_name;//
                    } else {
                        uploadCartItems.subaddons_name = c.menu_name;//
                    }
//                    uploadCartItems.subaddons_name = c.Addon_name;//
                    uploadCartItems.menu_price = c.Menu_price;//
                    uploadCartItems.menu_id = c.menu_id;//
                    uploadCartItems.menu_name = c.menu_name;//
                    uploadCartItems.quantity = c.quantity;//
                    uploadCartItems.restaurant_id = c.res_id;//
                    uploadCartItems.total_price = c.Total;
                    uploadCartItems.customer_id = loggedInUser.id;
                    cartItemArrayList.add(uploadCartItems);
                }
                CommonFunctions.updateCartOnline(loggedInUser.id, new Gson().toJson(cartItemArrayList));
                if (myApp.getMyPreferences().getRewardPoint() != null && myApp.getMyPreferences().getRewardPoint().reward_option.equalsIgnoreCase("yes") && restaurant != null && restaurant.reward_option.equalsIgnoreCase("yes")) {
                    cbRedeem.setOnCheckedChangeListener((compoundButton, b) -> cartCalculations());
                    Offer_Check();
                }
            }
        }).start();

    }

    private void setupcartItems() {
        CartArraylist.clear();
        for (CartItem c : cartItems) {
            Cart uploadCartItems = new Cart();

            if (!Validators.isNullOrEmpty(c.Addon_name)) {
                uploadCartItems.subaddons_name = c.menu_name + ":" + c.Addon_name;//
            } else {
                uploadCartItems.subaddons_name = c.menu_name;//
            }
            uploadCartItems.menu_price = String.valueOf(c.Menu_price);//
            uploadCartItems.menu_id = String.valueOf(c.menu_id);//
            uploadCartItems.menu_name = c.menu_name;//
            uploadCartItems.quantity = String.valueOf(c.quantity);//
            uploadCartItems.restaurant_id = String.valueOf(c.res_id);//
            uploadCartItems.total_price = String.valueOf(c.Total);
//        uploadCartItems.customer_id = loggedInUser.id;
            CartArraylist.add(uploadCartItems);
        }
    }

    MarkerOptions markerOptions;
    Marker m;

    private void checkWithDeliverableAddresses(Address defaultaddress) {
        AndroidNetworking.get(ApiEndPoints.NEW_ADDRESSBOOK + "/" + defaultaddress.id)
                .addQueryParameter("customer_id", String.valueOf(loggedInUser.id))
                .addQueryParameter("restaurant_id", String.valueOf(res_id))
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        deliverableAddress = (new Gson().fromJson(response.toString(), Address.class));
                        cartCalculations();
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();

                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });

    }

    private void updateAddress() {
        if (deliverableAddress == null) {
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> {
                    tvAddressUsername.setText(loggedInUser.first_name + " " + loggedInUser.last_name);
                    tvAddress.setText(defaultPostCode.street);
                    tvZipcode.setText(defaultPostCode.post_code);
                    llAddress.setVisibility(View.VISIBLE);
                    if (userMap != null) {
                        LatLng userAddressLocation = new LatLng(Double.parseDouble(defaultPostCode.latitude), Double.parseDouble(defaultPostCode.longitude));
                        if (m == null) {
                            markerOptions = new MarkerOptions().position(userAddressLocation).title(defaultPostCode.street + ", " + defaultPostCode.post_code);
                            m = userMap.addMarker(markerOptions);
                        } else {
                            m.setPosition(userAddressLocation);
                        }
                        float zoom = 15;
                        userMap.moveCamera(CameraUpdateFactory.newLatLngZoom(userAddressLocation, zoom));
                    }

                   /* if (defaultAddress != null) {
                        checkWithDeliverableAddresses(defaultAddress);
                    }*/
                });

            }

        } else {
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> {
                    tvAddressUsername.setText(loggedInUser.first_name + " " + loggedInUser.last_name);
                    tvAddress.setText(deliverableAddress.flat_no + ", " + deliverableAddress.address);
                    tvZipcode.setText(deliverableAddress.zipcode);
                    if (userMap != null) {
                        LatLng userAddressLocation = new LatLng(Double.parseDouble(deliverableAddress.latitude), Double.parseDouble(deliverableAddress.longitude));
                        if (m == null) {
                            markerOptions = new MarkerOptions().position(userAddressLocation).title(deliverableAddress.flat_no + ", " + deliverableAddress.address);
                            m = userMap.addMarker(markerOptions);
                        } else {
                            m.setPosition(userAddressLocation);
                        }
                        float zoom = 15;
                        userMap.moveCamera(CameraUpdateFactory.newLatLngZoom(userAddressLocation, zoom));
                    }
                    cartCalculations();
                    pbAddress.setVisibility(View.GONE);
                    llAddress.setVisibility(View.VISIBLE);
                });


            }
        }
    }

    private void openDeliveryAddressDialog(boolean cancellable) {
        DeliverableChangeAddressDialog dialogFragment = DeliverableChangeAddressDialog.getInstance(String.valueOf(res_id));
        dialogFragment.show(getChildFragmentManager(), "dialog");
        dialogFragment.setCancelable(cancellable);
        dialogFragment.setDialogDismissListener(deliverableAddressSelectListener);
    }


    private void selectPaymentMethod() {
        PaymentMethodsFragment paymentMethodsFragment = PaymentMethodsFragment.getInstance(dineIn, restaurant.payment_methods, restaurant.wallet_payment, restaurant.dinein_wallet_payment, ((paymentMethod != null) ? paymentMethod : new PaymentMethod()));
        paymentMethodsFragment.show(getChildFragmentManager(), "select_payment_method");
        paymentMethodsFragment.setDialogDismissListener(paymentMethodSelectListener);
    }

    private float customTipAmount = 0;

    private void showEditTip() {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        View dialogView = inflater.inflate(R.layout.dialog_edit_fund, null);

        TextView tvHeading = dialogView.findViewById(R.id.tvHeading);
        TextView tvInfo = dialogView.findViewById(R.id.tvInfo);
        TextView tvCancel = dialogView.findViewById(R.id.tvCancel);
        TextView tvConfirm = dialogView.findViewById(R.id.tvConfirm);
        EditText etAmount = dialogView.findViewById(R.id.etFundAmount);

        tvHeading.setText("Leave a tip");
        tvInfo.setVisibility(View.VISIBLE);
        etAmount.setHint("Enter tip amount");
        etAmount.addTextChangedListener(new MoneyTextWatcher(etAmount));
        if (customTipAmount > 0) {
            etAmount.setText(MyApp.df.format(customTipAmount));
            etAmount.setSelection(etAmount.getText().toString().length());
        }
        tvConfirm.setOnClickListener(view -> {
            if (!etAmount.getText().toString().isEmpty() && Float.parseFloat(etAmount.getText().toString().replace(",", "")) > 0) {
                CommonFunctions.hideKeyboard(getActivity(), etAmount);
                customTipAmount = Float.parseFloat(etAmount.getText().toString().replace(",", ""));
                cartTip = customTipAmount;
                rbCustom.setText(myApp.getCurrencySymbol() + MyApp.df.format(customTipAmount));
                rbCustom.setChecked(true);
                rbCustom.setVisibility(View.VISIBLE);
                alertDialog.dismiss();
                cartCalculations();
            } else {
                ToastUtils.makeSnackToast(getActivity(), "Please enter valid amount");
            }
        });
        tvCancel.setOnClickListener(view -> {
            if (cartTip == 0) {
                rbNo.setChecked(true);
            } else if (cartTip == 1) {
                rb1.setChecked(true);
            } else if (cartTip == 2) {
                rb2.setChecked(true);
            } else if (customTipAmount > 0) {
                rbCustom.setChecked(true);
            }
            alertDialog.dismiss();
        });
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();
    }

    private void addItemToCart(Menu menuItem, int position) {
        new Thread(() -> {
            String variantName = null;
            if (menuItem.variants != null && menuItem.variants.size() > 0) {
                variantName = menuItem.variants.get(0).sub_name;
            }
            CartItem dbCartItem = myApp.getAppDatabase().cartDao().getCartMenuItem(menuItem.id, variantName);
            if (dbCartItem == null) {
                CartItem cartItem = new CartItem();
                if (menuItem.variants != null && menuItem.variants.size() > 0) {

                    Variant selectedVariant = menuItem.variants.get(0);
                    cartItem.quantity = 1;
                    float discount = (selectedVariant.orginal_price * menuItem.getProductPercentage() / 100);
                    cartItem.Menu_price = selectedVariant.orginal_price - discount;
                    cartItem.menu_id = selectedVariant.menu_id;
                    cartItem.id = selectedVariant.id;
                    cartItem.menu_name = menuItem.menu_name;
                    cartItem.menu_size = (menuItem.menu_name.equalsIgnoreCase(selectedVariant.sub_name)) ? "" : selectedVariant.sub_name;
                    cartItem.res_id = menuItem.restaurant_id;
                    cartItem.menu_type = menuItem.menu_type;

                    cartItem.Addon_name = "";
                    cartItem.Addon_price = 0;
                    cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                    myApp.getAppDatabase().cartDao().insertAll(cartItem);
                    if (getActivity() != null)
                        getActivity().runOnUiThread(this::updateCartAdapterAndAmount);
                }
            } else {
                if (menuItem.variants != null && menuItem.variants.size() > 0) {
                    Variant selectedVariant = menuItem.variants.get(0);
                    dbCartItem.quantity++;
                    float discount = (selectedVariant.orginal_price * menuItem.getProductPercentage() / 100);
                    dbCartItem.Menu_price = +selectedVariant.orginal_price - discount;
                    dbCartItem.Total = dbCartItem.quantity * (dbCartItem.Menu_price + dbCartItem.Addon_price);
                    myApp.getAppDatabase().cartDao().update(dbCartItem);
                }

            }
            if (getActivity() != null) {
                getActivity().runOnUiThread(this::fetchCartSummary);
            }
        }).start();
    }

    private void incrementQuantity(int i, Object o) {
        CartItem cartItem = (CartItem) o;
        new Thread(() -> {
            CartItem c = MyApp.getInstance().getAppDatabase().cartDao().getCartItem(cartItem.cartItemId);
            boolean removed = false;
            if (c == null) {
                ToastUtils.makeSnackToast(getActivity(), "Item already removed");
                removed = true;
            } else {
                cartItem.quantity++;
                cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                MyApp.getInstance().getAppDatabase().cartDao().update(cartItem);
            }
            if (getActivity() != null) {
                boolean finalRemoved = removed;
                getActivity().runOnUiThread(() -> {
                    if (finalRemoved) {
                        feed.remove(i);
                        cartBasketItemsAdapter.notifyItemRemoved(i);
                        if (feed.size() == 0) {
                            ToastUtils.makeSnackToast(getActivity(), "Cart is empty");
                            showEmptyCartUi();
                        }
                    } else {

                        cartBasketItemsAdapter.notifyDataSetChanged();
                    }
                });
            }
            fetchCartSummary();
        }).start();

    }

    private void decrementQuantity(int i, Object o) {
        CartItem cartItem = (CartItem) o;
        new Thread(() -> {
            CartItem c = MyApp.getInstance().getAppDatabase().cartDao().getCartItem(cartItem.cartItemId);
            boolean removed = false;
            if (c == null) {
                ToastUtils.makeSnackToast(getActivity(), "Item already removed");
                removed = true;
            } else {
                if (cartItem.quantity <= 1) {
                    MyApp.getInstance().getAppDatabase().cartDao().delete(cartItem);
                    ToastUtils.makeSnackToast(getActivity(), "Item removed");

                    removed = true;
                } else {
                    cartItem.quantity--;
                    cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                    MyApp.getInstance().getAppDatabase().cartDao().update(cartItem);

                }
            }
            if (getActivity() != null) {
                boolean finalRemoved = removed;
                getActivity().runOnUiThread(() -> {
                    if (finalRemoved) {
                        updateCartAdapterAndAmount();
                    } else {
                        cartBasketItemsAdapter.notifyDataSetChanged();
                    }

                });
            }
            fetchCartSummary();

        }).start();

    }

    private void applyPromocode() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                progressDialog.show();
                CommonFunctions.hideKeyboard(getActivity(), etPromocode);
            });
        }
        ApiUtils.applyPromoCode(String.valueOf(loggedInUser.id), String.valueOf(res_id), etPromocode.getText().toString(), orderType == 1 ? "delivery" : "pickup", orderType == 1 ? selectedDeliveryTimeSlot != null ? selectedDeliveryTimeSlot.date : "" + delivery_year + "-" + delivery_month + "-" + delivery_date : selectedPickupTimeSlot != null ? selectedPickupTimeSlot.date : "" + delivery_year + "-" + delivery_month + "-" + delivery_date)
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        appliedVoucher = new Gson().fromJson(response.toString(), Voucher.class);
                        validateVoucher(true);


                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                etPromocode.setText("");
                                progressDialog.dismiss();
                            });
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("APPLY PROMO ANERROR");

                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                progressDialog.dismiss();
                                etPromocode.setText("");
                            });
                        }
                        if (anError.getErrorCode() == 400) {
                            ApiError apiError = anError.getErrorAsObject(ApiError.class);
                            ToastUtils.makeSnackToast(getActivity(), apiError.getMessage());
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private boolean freeDelivery;

    private void validateVoucher(boolean showToast) {
        freeDelivery = false;
        String message = "";
        if (appliedVoucher != null) {
            voucherDiscount = 0;
            if (orderType != 1 && appliedVoucher.offer_mode.equalsIgnoreCase("free_delivery")) {
                message = "Promo code is not applicable";
                //ToastUtils.makeSnackToast();(getActivity(), "Promo code is not applicable");
            } else {
                if (appliedVoucher.minimum_value <= cartSubtotal) {

                    if (appliedVoucher.offer_mode.equalsIgnoreCase("price")) {
                        voucherApplied = true;
                        if (!Validators.isNullOrEmpty((appliedVoucher.delivery_type)) && !Validators.isNullOrEmpty((appliedVoucher.dinein_type)) && !Validators.isNullOrEmpty((appliedVoucher.pickup_type))) {
                            if ((appliedVoucher.delivery_type.equalsIgnoreCase("true") || appliedVoucher.delivery_type.equalsIgnoreCase("1")) && (appliedVoucher.pickup_type.equalsIgnoreCase("yes") || appliedVoucher.pickup_type.equalsIgnoreCase("1"))) {
                                voucherDiscount = appliedVoucher.offer_value;
                                message = "Promo code applied successfully";
                            } else if ((appliedVoucher.pickup_type.equalsIgnoreCase("false") || appliedVoucher.pickup_type.equalsIgnoreCase("0")) && (appliedVoucher.delivery_type.equalsIgnoreCase("true") || appliedVoucher.delivery_type.equalsIgnoreCase("1")) && orderType == 1) {
                                voucherDiscount = appliedVoucher.offer_value;
                                message = "Promo code applied successfully";
                            } else if ((appliedVoucher.delivery_type.equalsIgnoreCase("false") || appliedVoucher.delivery_type.equalsIgnoreCase("0")) && (appliedVoucher.pickup_type.equalsIgnoreCase("true") || appliedVoucher.pickup_type.equalsIgnoreCase("1")) && orderType == 2) {
                                voucherDiscount = appliedVoucher.offer_value;
                                message = "Promo code applied successfully";
                            } else if ((appliedVoucher.delivery_type.equalsIgnoreCase("false") || appliedVoucher.delivery_type.equalsIgnoreCase("0")) && (appliedVoucher.pickup_type.equalsIgnoreCase("false") || appliedVoucher.pickup_type.equalsIgnoreCase("0")) && (appliedVoucher.dinein_type.equalsIgnoreCase("true") || appliedVoucher.dinein_type.equalsIgnoreCase("1"))) {
                                LogUtils.e("DINEIN VOUCHER");
                                message = "Promo code is not applicable";
                                voucherDiscount = 0;
                                voucherApplied = false;
                                appliedVoucher = null;
                            } else {
                                LogUtils.e("CONDITIONS NOT SATISFIED");
                                voucherDiscount = 0;
                                LogUtils.e(new Gson().toJson(appliedVoucher));
                                message = "Promo code is not applicable";
                                appliedVoucher = null;
                                voucherApplied = false;
                            }
                            cartCalculations();
                        } else {

                            voucherApplied = false;
                            appliedVoucher = null;
                        }
                    } else if (appliedVoucher.offer_mode.equalsIgnoreCase("percentage")) {
                        voucherApplied = true;
                        if (!Validators.isNullOrEmpty((appliedVoucher.delivery_type)) && !Validators.isNullOrEmpty((appliedVoucher.dinein_type)) && !Validators.isNullOrEmpty((appliedVoucher.pickup_type))) {
                            if ((appliedVoucher.delivery_type.equalsIgnoreCase("true") || appliedVoucher.delivery_type.equalsIgnoreCase("1")) && (appliedVoucher.pickup_type.equalsIgnoreCase("true") || appliedVoucher.pickup_type.equalsIgnoreCase("1"))) {
                                voucherDiscount = cartSubtotal * (appliedVoucher.offer_value / 100);
                                message = "Promo code applied successfully";
                            } else if ((appliedVoucher.pickup_type.equalsIgnoreCase("false") || appliedVoucher.pickup_type.equalsIgnoreCase("0")) && (appliedVoucher.pickup_type.equalsIgnoreCase("true") || appliedVoucher.pickup_type.equalsIgnoreCase("1")) && orderType == 1) {
                                voucherDiscount = cartSubtotal * (appliedVoucher.offer_value / 100);
                                message = "Promo code applied successfully";
                            } else if ((appliedVoucher.delivery_type.equalsIgnoreCase("false") || appliedVoucher.delivery_type.equalsIgnoreCase("0")) && (appliedVoucher.pickup_type.equalsIgnoreCase("true") || appliedVoucher.pickup_type.equalsIgnoreCase("1")) && orderType == 2) {
                                voucherDiscount = cartSubtotal * (appliedVoucher.offer_value / 100);
                                message = "Promo code applied successfully";
                            } else if ((appliedVoucher.delivery_type.equalsIgnoreCase("false") || appliedVoucher.delivery_type.equalsIgnoreCase("0")) && (appliedVoucher.pickup_type.equalsIgnoreCase("false") || appliedVoucher.pickup_type.equalsIgnoreCase("0")) && (appliedVoucher.dinein_type.equalsIgnoreCase("true") || appliedVoucher.dinein_type.equalsIgnoreCase("1"))) {
                                LogUtils.e("DINEIN VOUCHER");
                                message = "Promo code is not applicable";
                                voucherDiscount = 0;
                                voucherApplied = false;
                                appliedVoucher = null;
                            } else {
                                LogUtils.e("CONDITIONS NOT SATISFIED");
                                LogUtils.e(new Gson().toJson(appliedVoucher));
                                message = "Promo code is not applicable";
                                voucherDiscount = 0;
                                voucherApplied = false;
                                appliedVoucher = null;
                            }
                            cartCalculations();
                        } else {

                            voucherApplied = false;
                            appliedVoucher = null;
                        }
                    } else if (appliedVoucher.offer_mode.equalsIgnoreCase("free_delivery")) {
                        voucherDiscount = 0;
                        cartDeliveryFee = 0;
                        voucherApplied = true;
                        freeDelivery = true;
                        cartCalculations();
                        message = "Promo code applied successfully";
                    }
                } else {
                    message = "Minimum order value is " + currency + appliedVoucher.minimum_value;
                    appliedVoucher = null;
                    voucherApplied = false;
                    cartCalculations();
                }
                if (showToast) {
                    ToastUtils.makeSnackToast(getActivity(), message);
                }
            }
        } else {
//            LogUtils.e("PROMOCODE IS NULL");
            voucherApplied = false;
            voucherDiscount = 0;
            cartCalculations();
        }
    }

    private void fetchAllOffers() {
        AndroidNetworking.get(ApiEndPoints.NEW_OFFERSALL)
                .addQueryParameter("restaurant_id", String.valueOf(res_id))
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        Type type = new TypeToken<List<Voucher>>() {
                        }.getType();
                        Type MultiplePriceOffertype = new TypeToken<List<MultiplePriceOffer>>() {
                        }.getType();
                        Type DayOffertype = new TypeToken<List<DayOffer>>() {
                        }.getType();
                        Type DayProductOffertype = new TypeToken<List<DayProductOffer>>() {
                        }.getType();
                        Type DayPriceOffertype = new TypeToken<List<DayPriceOffer>>() {
                        }.getType();
                        Type Offerstype = new TypeToken<List<Offer>>() {
                        }.getType();
                        Type ProductOfferstype = new TypeToken<List<ProductOffer>>() {
                        }.getType();
                        Type PriceOfferstype = new TypeToken<List<PriceOffer>>() {
                        }.getType();
                        try {
                            ArrayList<Voucher> vouchers = new ArrayList<>(new Gson().fromJson(response.getJSONArray("restaurant_vouchers").toString(), type));

                            ArrayList<Voucher> user_vouchers = new ArrayList<>(new Gson().fromJson(response.getJSONArray("user_vouchers").toString(), type));
                            ArrayList<MultiplePriceOffer> multiplePriceOffer = new ArrayList<>(new Gson().fromJson(response.getJSONArray("multiple_price_offers").toString(), MultiplePriceOffertype));
                            ArrayList<DayOffer> dayOffer = new ArrayList<>(new Gson().fromJson(response.getJSONArray("day_offers").toString(), DayOffertype));
                            ArrayList<DayProductOffer> dayProductOffer = new ArrayList<>(new Gson().fromJson(response.getJSONArray("day_product_offers").toString(), DayProductOffertype));
                            ArrayList<DayPriceOffer> dayPriceOffer = new ArrayList<>(new Gson().fromJson(response.getJSONArray("day_price_offers").toString(), DayPriceOffertype));
                            ArrayList<Offer> Offers = new ArrayList<>(new Gson().fromJson(response.getJSONArray("offers").toString(), Offerstype));
                            ArrayList<ProductOffer> ProductOffers = new ArrayList<>(new Gson().fromJson(response.getJSONArray("product_offers").toString(), ProductOfferstype));
                            ArrayList<PriceOffer> PriceOffers = new ArrayList<>(new Gson().fromJson(response.getJSONArray("price_offers").toString(), PriceOfferstype));

                            restaurant.multiple_price_offers.addAll(multiplePriceOffer);
                            restaurant.voucherLists.addAll(user_vouchers);
                            restaurant.voucherLists.addAll(vouchers);
                            restaurant.day_offers.addAll(dayOffer);
                            restaurant.day_product_offers.addAll(dayProductOffer);
                            restaurant.day_price_offers.addAll(dayPriceOffer);
                            restaurant.offers.addAll(Offers);
                            restaurant.product_offers.addAll(ProductOffers);
                            restaurant.price_offers.addAll(PriceOffers);

                        } catch (JSONException exception) {
                            exception.printStackTrace();
                        }


                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                    }
                });
    }

    private void fetchMenuItem() {
        ApiUtils.getMenuDetails("1", String.valueOf(res_id), "1")
                .getAsJSONArray(new JSONArrayRequestListener() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Type type = new TypeToken<List<MenuItemNew>>() {
                        }.getType();
                        ArrayList<MenuItemNew> menuItems = new ArrayList<>(new Gson().fromJson(response.toString(), type));
                        try {
                            restaurant_menu = new ArrayList<>();
                            restaurant.new_restaurant_menu.addAll(menuItems);
                            restaurant_menu.clear();
                            if (restaurant != null && restaurant.new_restaurant_menu != null) {
                                for (MenuItemNew menuItem : restaurant.new_restaurant_menu) {
                                    restaurant_menu.addAll(menuItem.menu);

                                }
                            }
                            if (getActivity() != null)
                                getActivity().runOnUiThread(() -> {
                                    if (defaultAddress != null) {
                                        checkWithDeliverableAddresses(defaultAddress);
                                    }

                                });


                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                    }
                });
    }

    private void showSuggestions() {

        if (restaurant != null && restaurant_menu != null) {
            removeSuggestedMenuItems();
            new Thread(() -> {
                for (Menu menu : restaurant_menu) {
                    if (menu.is_suggest == 1) {
                        if (myApp.getAppDatabase().cartDao().getMenuItemCartCounts(menu.id) == 0) {
                            suggestedMenuItems.add(menu);
                        }
                    }
                }

                if (suggestedMenuItems.size() > 0) {
                    ArrayList<Object> objects = new ArrayList<>();
                    objects.add(new Header());
                    objects.addAll(suggestedMenuItems);
                    feed.addAll(objects);
                    if (getActivity() != null) {
                        getActivity().runOnUiThread(() -> cartBasketItemsAdapter.notifyDataSetChanged());
                    }

                }
            }).start();
        }


    }

    private Rewards appliedRewards;
    private OfferCheck offerCheck;
    private boolean isRewardsLoading;
    private LottieAnimationView animationRedeemLoading;

    private void checkAndGetRewards() {
        if (myApp.getMyPreferences().getRewardPoint() != null && myApp.getMyPreferences().getRewardPoint().reward_option.equalsIgnoreCase("yes") && restaurant != null && restaurant.reward_option.equalsIgnoreCase("yes")) {
            cbRedeem.setOnCheckedChangeListener((compoundButton, b) -> cartCalculations());
            Offer_Check();
        } else {
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> {
                    llEarn.setVisibility(View.GONE);
                    cbRedeem.setOnCheckedChangeListener(null);
                    cbRedeem.setChecked(false);
                    cartRedeem = 0;
                    llRedeem.setVisibility(View.GONE);
                    animationRedeemLoading.setVisibility(View.GONE);
                });
            }
            validateVoucher(false);
        }
    }


    private HashMap<String, String> generateOfferCheckParams() {
        HashMap<String, String> formBody = new HashMap<>();
        setupcartItems();
        formBody.put("customer_id", String.valueOf(loggedInUser.id));
        formBody.put("restaurant_id", String.valueOf(res_id));
        formBody.put("customer_email", loggedInUser.username);
        formBody.put("customer_phone", loggedInUser.phone_number);
        formBody.put("customer_name", loggedInUser.first_name + " " + loggedInUser.last_name);

        formBody.put("source_latitude", restaurant.sourcelatitude);
        formBody.put("source_longitude", restaurant.sourcelongitude);

        formBody.put("destination_latitude", "");
        formBody.put("destination_longitude", "");
        formBody.put("flat_no", "");
        formBody.put("address", "");


        if (orderType == 1) {
            formBody.put("order_type", "delivery");
        } else if (orderType == 2) {
            formBody.put("order_type", "pickup");
        }
        formBody.put("delivery_charge", "");
        formBody.put("driver_tip", "");
        formBody.put("delivery_instruction", "");
        formBody.put("assoonas", "");
        formBody.put("delivery_time", CommonFunctions.formatMili(System.currentTimeMillis(), "hh:mm a"));

        formBody.put("order_description", "");
        formBody.put("delivery_date", String.format("%d-%d-%d", delivery_year, delivery_month, delivery_date));

        formBody.put("offer_amount", "0");
        formBody.put("offer_percentage", "0");

        formBody.put("day_offer", "");
        formBody.put("tax_percentage", "0");
        formBody.put("tax_amount", "0");
        formBody.put("service_charge", "");
        formBody.put("voucher_code", "");
        formBody.put("voucher_amount", "0.0");
        formBody.put("voucher_percentage", "0.0");
        formBody.put("order_sub_total", MyApp.df.format(cartSubtotal));


        formBody.put("payment_status", "NP");
        formBody.put("payment_method", "");

        formBody.put("card_id", "");
        formBody.put("payment_wallet", "No");
        formBody.put("paid_full", "No");
        formBody.put("split_payment", "No");
        formBody.put("wallet_amount", "");
        formBody.put("transaction_id", "");
        formBody.put("paymentID", "");
        formBody.put("paymentToken", "");
        formBody.put("order_point", "");
        formBody.put("reward_used", "Y");
        formBody.put("spent_point", "");
        formBody.put("reward_offer", "");
        formBody.put("reward_offer_percentage", "");
        formBody.put("failed_reason", "");
        formBody.put("status", "Pending");
        formBody.put("type", "Android");

        formBody.put("preparation", "");
        formBody.put("dont_bell", "0");
        formBody.put("dont_cutlery", "0");//when we check cutlery check box then 1 else 0

        formBody.put("is_favourite", "0");
        formBody.put("order_grand_total", MyApp.df.format(getCartTotal()));
        formBody.put("charity_message", "");
        formBody.put("charity_amount", "0");
        try {
            formBody.put("carts", new Gson().toJson(CartArraylist));
        } catch (ConcurrentModificationException e) {
            e.printStackTrace();
        }


        return formBody;
    }

    private void Offer_Check() {
        isRewardsLoading = true;
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> {
                if (llRedeem.getVisibility() == View.GONE)
                    animationRedeemLoading.setVisibility(View.VISIBLE);
            });
        AndroidNetworking.post(NEW_OFFER_CHECK).addBodyParameter(generateOfferCheckParams()).build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        try {
                            offerCheck = new Gson().fromJson((response.toString()), OfferCheck.class);
                            Order_point = String.valueOf(offerCheck.order_point);
                            getRewards();
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                animationRedeemLoading.setVisibility(View.GONE);
                            });
                        ToastUtils.makeSnackToast(getActivity(), "Something went wrong!");
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        if (anError.getErrorCode() == 400) {
                            ApiError apiError = anError.getErrorAsObject(ApiError.class);
                            ToastUtils.makeSnackToast(getActivity(), apiError.getMessage());
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void getRewards() {
        isRewardsLoading = true;
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> {
                if (llRedeem.getVisibility() == View.GONE)
                    animationRedeemLoading.setVisibility(View.VISIBLE);
            });
        AndroidNetworking.get(NEW_REWARDS).build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null && progressDialog != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        isRewardsLoading = false;
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                animationRedeemLoading.setVisibility(View.GONE);
                            });
                        appliedRewards = new Gson().fromJson(response.toString(), Rewards.class);
                        applyRewards();
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        isRewardsLoading = false;
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                animationRedeemLoading.setVisibility(View.GONE);
                            });
                        ToastUtils.makeSnackToast(getActivity(), "Something went wrong!");
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        if (anError.getErrorCode() == 400) {
                            ApiError apiError = anError.getErrorAsObject(ApiError.class);
                            ToastUtils.makeSnackToast(getActivity(), apiError.getMessage());
                            appliedRewards = null;
                            llRedeem.setVisibility(View.GONE);
                            cartRedeem = 0;
                            cbRedeem.setChecked(false);
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void applyRewards() {

        if (appliedRewards != null) {
            if (Float.parseFloat(Order_point) > 0) {
                llEarn.setVisibility(View.VISIBLE);
                tvEarn.setText(String.format("You will earn %s points", MyApp.df.format(Float.parseFloat(Order_point))));
            } else {
                llEarn.setVisibility(View.GONE);
            }
            cartEarn = Float.parseFloat(Order_point);
            if (appliedRewards.minimum_order > cartSubtotal) {
                appliedRewards = null;
                cartRedeem = 0;
                cbRedeem.setChecked(false);
                llRedeem.setVisibility(View.GONE);
            } else {
                if (appliedRewards.value_type == 1) {
                    if (appliedRewards.reward_percentage > 0 && myApp.getMyPreferences().getLoggedInUser().total_earn_point >= offerCheck.rewardPoint && cartSubtotal >= appliedRewards.minimum_order && offerCheck.rewardPoint > 0) {

                        cartRedeem = offerCheck.rewardPoint;
                        if (cbRedeem.isChecked() && appliedRewards != null) {
                            cartRewardDiscount = cartRedeem;
                        } else {
                            cartRewardDiscount = 0;
                        }
                        if (cartRewardDiscount > 0)
                            tvRewardDiscount.setText("-" + currency + MyApp.df.format(cartRewardDiscount));
                        else
                            tvRewardDiscount.setText(currency + MyApp.df.format(cartRewardDiscount));
                        llRedeem.setVisibility(View.VISIBLE);
                        tvRedeemPoints.setText(myApp.getCurrencySymbol() + MyApp.df.format(cartRedeem));
                        cbRedeem.setText(String.format("Redeem amount (%s%%)", new DecimalFormat("#.##").format(offerCheck.rewardPercentage)));

                    } else {
                        llRedeem.setVisibility(View.GONE);
                        cbRedeem.setChecked(false);
                    }
                } else {
                    if (appliedRewards.reward_point > 0 && myApp.getMyPreferences().getLoggedInUser().total_earn_point > offerCheck.rewardPoint && offerCheck.rewardPoint < cartSubtotal && offerCheck.rewardPoint > 0) {
                        cartRedeem = offerCheck.rewardPoint;

                        if (cbRedeem.isChecked() && appliedRewards != null) {
                            cartRewardDiscount = cartRedeem;
                        } else {
                            cartRewardDiscount = 0;
                        }
                        if (cartRewardDiscount > 0)
                            tvRewardDiscount.setText("-" + currency + MyApp.df.format(cartRewardDiscount));
                        else
                            tvRewardDiscount.setText(currency + MyApp.df.format(cartRewardDiscount));
                        llRedeem.setVisibility(View.VISIBLE);
                        tvRedeemPoints.setText(myApp.getCurrencySymbol() + MyApp.df.format(cartRedeem));
                        cbRedeem.setText("Redeem amount");
                    } else {
                        llRedeem.setVisibility(View.GONE);
                        cbRedeem.setChecked(false);
                    }
                }

            }
        } else {
            llRedeem.setVisibility(View.GONE);
            llEarn.setVisibility(View.GONE);
            cbRedeem.setChecked(false);
        }
        validateVoucher(false);
    }

    boolean paidFull = true, split = false;

    private void cartCalculations() {

        if (orderType == 1) {
            // Service charges for delivery
            if (restaurant.servicecharge_delivery.equalsIgnoreCase("true")) {
                if (restaurant.service_charge_type == 0) {
                    // charges in percentage
                    cartServiceFee = cartSubtotal * (restaurant.service_charge / 100);
                } else {
                    // flat charges
                    cartServiceFee = restaurant.service_charge;
                }
            } else {
                cartServiceFee = 0;
            }
            // Delivery charges
            if (!freeDelivery && deliverableAddress != null && !Validators.isNullOrEmpty(deliverableAddress.deliveryCharge)) {
                cartDeliveryFee = Float.parseFloat(deliverableAddress.deliveryCharge);
            } else {
                cartDeliveryFee = 0;
            }
        } else if (orderType == 2) {
            // Service charges for pickup
            if (restaurant.servicecharge_picked.equalsIgnoreCase("true")) {
                if (restaurant.service_charge_type == 0) {
                    // charges in percentage
                    cartServiceFee = cartSubtotal * (restaurant.service_charge / 100);
                } else {
                    //flat charges
                    cartServiceFee = restaurant.service_charge;
                }

                if (getActivity() != null)
                    getActivity().runOnUiThread(() -> llServiceCharge.setVisibility(View.VISIBLE));
            } else {
                cartServiceFee = 0;
                if (getActivity() != null)
                    getActivity().runOnUiThread(() -> llServiceCharge.setVisibility(View.GONE));
            }
            cartDeliveryFee = 0;
        }
        if (!voucherApplied) {
            if (getActivity() != null)
                getActivity().runOnUiThread(() -> {
//                    new ApplyOfferAsync(() -> {
                    applyOffers();
                    feed.addAll(freeItems);
                    cartBasketItemsAdapter.notifyDataSetChanged();
                    showCalculatedAmountsAndMoveNext();
//                        return null;
//                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);

                });
        } else {
            offerApplied = true;
            multiplePriceOfferApplied = true;
            multiplPriceOfferApplicable = false;
            new RemoveFreeItemAsync(() -> {
                if (getActivity() != null)
                    getActivity().runOnUiThread(() -> {
                        llSelectProducts.setVisibility(View.GONE);
                    });
                cartOffer = 0;
                showCalculatedAmountsAndMoveNext();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        }

    }

    private void showCalculatedAmountsAndMoveNext() {

        showSuggestions();
        if (cbRedeem.isChecked() && appliedRewards != null) {
            cartRewardDiscount = cartRedeem;
        } else {
            cartRewardDiscount = 0;
        }
        if (voucherDiscount > 0 || cartOffer > 0) {
            cartDiscount = voucherDiscount + cartOffer;
        } else {
            cartDiscount = 0;
        }
        if (orderType == 1) {
            cartTotal = cartSubtotal + cartTip
                    + cartDeliveryFee + cartServiceFee - cartDiscount - cartRewardDiscount + cartCharity;
        } else {
            cartTotal = cartSubtotal + cartServiceFee - cartDiscount - cartRewardDiscount + cartCharity;
        }
        if (loggedInUser.wallet_amount < cartTotal && paymentMethod != null && (paymentMethod.type.equalsIgnoreCase("credit") || paymentMethod.type.equalsIgnoreCase("wallet"))) {
            paymentMethod = null;
        }

        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                tvSubtotal.setText(currency + MyApp.df.format(cartSubtotal));
                tvServiceFee.setText(currency + MyApp.df.format(cartServiceFee));
                tvDeliveryFee.setText(currency + MyApp.df.format(cartDeliveryFee));
                tvDiscount.setText("-" + currency + MyApp.df.format(cartDiscount));
                if (voucherApplied) {
                    cvDiscount.setText(String.format("Discount (%s%%)", (appliedVoucher.offer_mode.equals("percentage") ? String.valueOf(appliedVoucher.offer_value) : "")));
                } else {
                    cvDiscount.setText(String.format("Discount (%s%%)", offerPercentage));
                }

                tvRewardDiscount.setText("-" + currency + MyApp.df.format(cartRewardDiscount));
                tvCharityFee.setText(currency + MyApp.df.format(cartCharity));
                tvDriverTip.setText(currency + MyApp.df.format(cartTip));
                if (cartDiscount > 0) {
                    ll_Discount.setVisibility(View.VISIBLE);
                } else {
                    ll_Discount.setVisibility(View.GONE);
                }
                if (cartRewardDiscount > 0) {
                    ll_Reward_Discount.setVisibility(View.VISIBLE);
                } else {
                    ll_Reward_Discount.setVisibility(View.GONE);
                }
                if (cartDeliveryFee > 0) {
                    llDeliveryFee.setVisibility(View.VISIBLE);
                } else {
                    llDeliveryFee.setVisibility(View.GONE);
                }
                if (cartTip > 0) {
                    ll_DriverTip.setVisibility(View.VISIBLE);
                } else {
                    ll_DriverTip.setVisibility(View.GONE);
                }
                tvTotal.setText(currency + MyApp.df.format(cartTotal));
                tvOrderTotal.setText("Total: " + currency + MyApp.df.format(getCartTotal()));

                if (voucherApplied) {
                    etPromocode.setEnabled(false);
                    btnApplyPromocode.setBackground(ContextCompat.getDrawable(getActivity(), R.drawable.rounded_button_red_filled));
                    btnApplyPromocode.setTextColor(ContextCompat.getColor(getActivity(), R.color.white));
                    btnApplyPromocode.setText("Remove");
                    etPromocode.setHint(appliedVoucher.voucher_code);
                } else {
                    etPromocode.setEnabled(true);
                    etPromocode.setText("");
                    btnApplyPromocode.setBackground(ContextCompat.getDrawable(getActivity(), R.drawable.rounded_button_white_filled));
                    btnApplyPromocode.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
                    btnApplyPromocode.setText("Apply");
                    etPromocode.setHint("Promo code... ");
                }
            });
        }
    }


    private String getCartDetails() {
        ArrayList<Object> cartDetails = new ArrayList<>(cartItems);
        ArrayList<Cart> uploadCartArraylist = new ArrayList<Cart>();
    /*    LogUtils.e("Arraylist-cartDetails"+new Gson().toJson(cartDetails));
        LogUtils.e("Arraylist-feed"+new Gson().toJson(feed));
        LogUtils.e("Arraylist-CartArrDetails"+new Gson().toJson(CartArrDetails));*/
        for (Object o : feed) {
            if (o instanceof CartItem) {
                CartItem c = (CartItem) o;
                if (c.Addon_name.equalsIgnoreCase("offer")) {
                    cartDetails.add(c);
                }
            }

        }
        for (Object o : cartDetails) {
            CartItem c = (CartItem) o;
            Cart uploadCartItems = new Cart();
            uploadCartItems.subaddons_name = c.Addon_name;//
            uploadCartItems.menu_price = String.valueOf(c.Menu_price);//
            uploadCartItems.menu_id = String.valueOf(c.menu_id);//
            uploadCartItems.menu_name = c.menu_name;//
            uploadCartItems.quantity = String.valueOf(c.quantity);//
            uploadCartItems.restaurant_id = String.valueOf(c.res_id);//
            uploadCartItems.total_price = String.valueOf(c.Total);
            uploadCartArraylist.add(uploadCartItems);
        }
        LogUtils.e(new Gson().toJson(uploadCartArraylist));
        return new Gson().toJson(uploadCartArraylist);
    }

    private boolean isValidOrder() {
        if (orderType == 1 && (Validators.isNullOrEmpty(loggedInUser.phone_number) || loggedInUser.phone_number.length() < 10)) {
            ToastUtils.makeSnackToast(getActivity(), "Please enter your phone number");
            openPhoneDialog();
            return false;
        }
        if (isRewardsLoading) {
            ToastUtils.makeSnackToast(getActivity(), "Please wait rewards are loading");
            return false;
        }
        if (orderType == 1 && restaurant.minimum_order > cartSubtotal) {
            ToastUtils.makeSnackToast(getActivity(), "Minimum order value is " + myApp.getCurrencySymbol() + MyApp.df.format(restaurant.minimum_order));
            return false;
        }

        if (Validators.isNullOrEmpty(selectedTimeSlot)) {
            if (orderType == 1)
                ToastUtils.makeSnackToast(getActivity(), "Please select delivery slot");
            else ToastUtils.makeSnackToast(getActivity(), "Please select collection slot");
            return false;
        }
        moveToNext = false;
        if (orderType == 0) {
            showRestaurantIsClosed("Unfortunately, " + restaurant.restaurant_name + " is currently closed", true);
            return false;
        }
        if (multiplePriceOfferApplied && !multiplPriceOfferApplicable) {
            int checkedQty = 0;
            if (appliedPriceOffer != null) {
                for (OfferProduct offerProduct : appliedPriceOffer.getProducts()) {
                    checkedQty = checkedQty + offerProduct.quantity;
                }
                if (checkedQty != appliedPriceOffer.offer_qty) {
                    moveToNext = false; // by kamal
                    llSelectProducts.performClick();
                    return false;
                }
            }

        }
      /*  if (paymentMethod != null && (!Validators.isNullOrEmpty(paymentMethod.type))) {
            if (paymentMethod.type.equalsIgnoreCase("paypal") && restaurant.paypal_minimum_order > cartSubtotal) {
                ToastUtils.makeSnackToast(getActivity(), "Paypal minimum order value is " + myApp.getCurrencySymbol() + MyApp.df.format(restaurant.paypal_minimum_order));
                return false;
            }
        }

        if (paymentMethod == null) {
            //moveToNext = true;
            moveToNext = false;
//            selectPaymentMethod();
            return false;
        }*/
        if (orderType == 1 && defaultAddress == null) {
            isPlaceOrderAddress = true;
            openDeliveryAddressDialog(false);
            return false;
        }
        if (orderType == 1 && deliverableAddress != null && !deliverableAddress.delivery_status.equalsIgnoreCase("delivery_available")) {
            isPlaceOrderAddress = true;
            ToastUtils.makeSnackToast(getActivity(), "Please select other address,Could not deliver to this address");
            openDeliveryAddressDialog(false);
            return false;
        }
        return true;
    }

    private void openPhoneDialog() {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        View dialogView = inflater.inflate(R.layout.dialog_enter_phonenumber, null);

        EditText etPhoneNumber = dialogView.findViewById(R.id.etPhoneNumber);
        TextView tvConfirm = dialogView.findViewById(R.id.tvConfirm);
        if (!Validators.isNullOrEmpty(loggedInUser.phone_number)) {
            etPhoneNumber.setText(loggedInUser.phone_number);
            etPhoneNumber.setSelection(etPhoneNumber.getText().toString().length());
        }
        tvConfirm.setOnClickListener(view -> {
            if (Validators.isNullOrEmpty(etPhoneNumber.getText().toString())) {
                ToastUtils.makeSnackToast(getActivity(), "Please enter your phone number");
            } else {
                User user = new User();
                user.first_name = loggedInUser.first_name;
                user.last_name = loggedInUser.last_name;
                user.email = loggedInUser.email;
                user.phone_number = etPhoneNumber.getText().toString();
                user.customer_id = String.valueOf(loggedInUser.id);
                updateProfile(user);
                alertDialog.dismiss();
            }

        });
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();

    }

    private void updateProfile(User user) {

        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> progressDialog.show());
        }
        AndroidNetworking.post(ApiEndPoints.UPDATE_ACCOUNT + loggedInUser.id).addApplicationJsonBody(user).build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        fetchProfile();

                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void fetchProfile() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> progressDialog.show());
        }
        AndroidNetworking.get(ApiEndPoints.NEW_ACCOUNT)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        User user1 = new Gson().fromJson(response.toString(), User.class);
                        myApp.getMyPreferences().saveLoggedInUser(user1);
                        loggedInUser = myApp.getMyPreferences().getLoggedInUser();
                        myApp.profileChanged();

                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        if (anError.getErrorCode() == 401) {
                            myApp.logout(getActivity());
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());

                    }
                });
    }


    private Object PlaceOrderParms() {
        PlaceOrder placeOrder = new PlaceOrder();

        StringBuilder instructionBuilder = new StringBuilder();
        if (selectedDeliveryInstructions.size() > 0) {
            for (DefaultInstructions d : selectedDeliveryInstructions) {
                if (d.isSelected) {
                    instructionBuilder.append(d.message);
                    instructionBuilder.append(", ");
                }
            }
        }
        if (etOrderInstruction.getText().toString().isEmpty()) {
            placeOrder.order_description = instructionBuilder.toString();
        } else {
            placeOrder.order_description = etOrderInstruction.getText().toString() + ", " + instructionBuilder.toString();
        }

        placeOrder.order_point = Order_point;
        placeOrder.reward_used = "N";
        placeOrder.spent_point = "";
        placeOrder.reward_offer = "";
        placeOrder.reward_offer_percentage = "";
        if (cbRedeem.isChecked() && appliedRewards != null) {
            placeOrder.order_point = Order_point;
            placeOrder.reward_used = "Y";
            placeOrder.spent_point = MyApp.df.format(offerCheck.rewardPoint);
            placeOrder.reward_offer = MyApp.df.format(cartRedeem);
            placeOrder.reward_offer_percentage = MyApp.df.format(offerCheck.rewardPercentage);
        }
        placeOrder.carts = getCartDetails();
        placeOrder.order_sub_total = MyApp.df.format(cartSubtotal);
        placeOrder.service_charge = MyApp.df.format(cartServiceFee);
        if (orderType == 1) {
            placeOrder.order_type = "delivery";
            placeOrder.delivery_charge = String.valueOf(cartDeliveryFee);
            placeOrder.delivery_instruction = etDeliveryInstructions.getText().toString();
            placeOrder.driver_tip = String.valueOf(cartTip);

        } else if (orderType == 2) {
            placeOrder.order_type = "pickup";
            placeOrder.delivery_charge = "";
            placeOrder.delivery_instruction = "";
        }

        placeOrder.dont_bell = "0";
        placeOrder.delivery_date = String.format("%d-%d-%d", delivery_year, delivery_month, delivery_date);


        if (selectedTimeSlot.equalsIgnoreCase("asap")) {
            placeOrder.assoonas = "Now";
            placeOrder.delivery_time = CommonFunctions.formatMili(System.currentTimeMillis(), "hh:mm a");

        } else {
            placeOrder.assoonas = "Later";

            placeOrder.delivery_time = selectedTimeSlot;
        }

        placeOrder.tax_percentage = "0";
        placeOrder.tax_amount = "0";

        placeOrder.voucher_code = "";
        placeOrder.voucher_amount = "0.0";
        placeOrder.voucher_percentage = "0.0";
        if (voucherApplied) {
            placeOrder.voucher_code = appliedVoucher.voucher_code;
            placeOrder.voucher_amount = String.valueOf(voucherDiscount);
            placeOrder.voucher_percentage = (appliedVoucher.offer_mode.equals("percentage")) ? String.valueOf(appliedVoucher.offer_value) : "0";

        }
        placeOrder.offer_amount = "0.0";
        placeOrder.offer_percentage = "0.0";
        if (offerApplied) {
            placeOrder.offer_amount = MyApp.df.format(cartOffer);
            placeOrder.offer_percentage = MyApp.df.format(offerPercentage);
        }
        placeOrder.customer_id = String.valueOf(loggedInUser.id);
        placeOrder.restaurant_id = String.valueOf(res_id);
        placeOrder.customer_email = loggedInUser.username;
        placeOrder.customer_phone = loggedInUser.phone_number;
        placeOrder.customer_name = loggedInUser.first_name + "" + loggedInUser.last_name;
        if (defaultAddress != null) {
            placeOrder.destination_latitude = defaultAddress.latitude;
            placeOrder.destination_longitude = defaultAddress.longitude;
            placeOrder.flat_no = defaultAddress.flat_no;
            placeOrder.address = defaultAddress.address;
        }
        placeOrder.source_latitude = restaurant.sourcelatitude;
        placeOrder.source_longitude = restaurant.sourcelongitude;
        placeOrder.day_offer = "";
        placeOrder.failed_reason = "";
        placeOrder.status = "Pending";
        placeOrder.type = "Android";
        placeOrder.preparation = "";
        placeOrder.dont_cutlery = "0";
        placeOrder.is_favourite = "0";
        if (cbCharity.isChecked()) {
            placeOrder.charity_message = cbCharity.getText().toString();
            placeOrder.charity_amount = MyApp.df.format(cartCharity);
            placeOrder.order_grand_total = MyApp.df.format(getCartTotal());
        } else {
            placeOrder.charity_message = "";
            placeOrder.charity_amount = "0";
            placeOrder.order_grand_total = MyApp.df.format(getCartTotal());
        }
        if (orderType == 1) {
            placeOrder.order_type = "delivery";
        } else {
            placeOrder.order_type = "pickup";
        }
        return placeOrder;
    }


    DialogDismissListener paymentMethodSelectListener = new DialogDismissListener() {
        @Override
        public void onDialogDismiss(Object o) {
            if (o instanceof PaymentMethod) {
                paymentMethod = (PaymentMethod) o;
                if (paymentMethod.type.equalsIgnoreCase("paypal") && restaurant.paypal_minimum_order > cartSubtotal) {
                    ToastUtils.makeSnackToast(getActivity(), "Paypal minimum order value is " + myApp.getCurrencySymbol() + MyApp.df.format(restaurant.paypal_minimum_order));
                    paymentMethod = null;
                    moveToNext = false;
                }
            }
            moveToNext = false;
        }
    };


    private float getCartTotal() {
        if (orderType == 1) {
            return cartSubtotal + cartTip
                    + cartDeliveryFee + cartServiceFee - cartDiscount - cartRewardDiscount + cartCharity;
        } else {
            return cartSubtotal + cartServiceFee - cartDiscount - cartRewardDiscount + cartCharity;
        }
    }

    private final DialogDismissListener addItemCartDialogListener = o -> {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                updateCartAdapterAndAmount();
                fetchCartSummary();
            });
        }
    };

    private final DialogDismissListener deliverableAddressSelectListener = o -> {
        if (o instanceof Address) {
            deliverableAddress = (Address) o;
            defaultAddress = (Address) o;
            updateAddress();
            if (isValidOrder() && isPlaceOrderAddress) {
                startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "payment").putExtra("name", "Payment")
                        .putExtra("dineIn", dineIn).putExtra("wallet_payment", restaurant.wallet_payment).putExtra("dinein_wallet_payment", restaurant.dinein_wallet_payment)
                        .putExtra("restaurant_id", String.valueOf(res_id)).putExtra("place_order", new Gson().toJson(PlaceOrderParms())).putExtra("Total", getCartTotal()));

            }
            isPlaceOrderAddress = false;
        }

    };

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == CODE_REFRESH) {
            LogUtils.e("REFRESH");
        } else if (requestCode == CODE_NO_INTERNET) {
            fetchData();

        }
    }

    private boolean offerApplied = false;
    private boolean multiplePriceOfferApplied = false, multiplPriceOfferApplicable = false;
    private MultiplePriceOffer appliedPriceOffer;

    private class ApplyOfferAsync extends AsyncTask<String, String, String> {
        Callable<Void> nextThing;

        public ApplyOfferAsync(Callable<Void> nextThing) {
            this.nextThing = nextThing;
        }

        @Override
        protected String doInBackground(String... strings) {
            cartOffer = 0;

            if (offerApplied) {
                freeItems.clear();
                Iterator<Object> iterator = feed.iterator();
                while (iterator.hasNext()) {
                    Object object = iterator.next();
                    if (object instanceof CartItem) {
                        CartItem c = (CartItem) object;
                        if (c.Addon_name.equalsIgnoreCase("offer")) {
                            iterator.remove();
                        }
                    }

                }
                offerApplied = false;
            }
            SimpleDateFormat sdf = new SimpleDateFormat("EEEE");
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date d = new Date();
            String dayOfTheWeek = sdf.format(d);
            Date today = null;
            try {
                today = dateFormat.parse(dateFormat.format(new Date()));
                today = CommonFunctions.convertStringDateToDate(delivery_year + "-" + delivery_month + "-" + delivery_date, "yyyy-MM-dd");
                if (orderType == 1 && selectedDeliveryTimeSlot != null && !Validators.isNullOrEmpty(selectedDeliveryTimeSlot.date)) {
                    today = CommonFunctions.convertStringDateToDate(selectedDeliveryTimeSlot.date, "yyyy-MM-dd");
                }

                if (orderType == 2 && selectedPickupTimeSlot != null && !Validators.isNullOrEmpty(selectedPickupTimeSlot.date)) {
                    today = CommonFunctions.convertStringDateToDate(selectedPickupTimeSlot.date, "yyyy-MM-dd");
                }
            } catch (ParseException e) {
                e.printStackTrace();
            }
            if (restaurant.multiple_price_offers != null && restaurant.multiple_price_offers.size() > 0) {
                multiplePriceOfferApplied = false;
                if (getActivity() != null) {
                    getActivity().runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            tvSelectProducts.setText("Claim your free product(s)");
                        }
                    });
                }

                for (MultiplePriceOffer multiplePriceOffer : restaurant.multiple_price_offers) {
                    boolean canApply = false;
                    if (orderType == 1 && multiplePriceOffer.delivery_type.equalsIgnoreCase("true")) {
                        canApply = true;
                    }
                    if (orderType == 2 && multiplePriceOffer.pickup_type.equalsIgnoreCase("true")) {
                        canApply = true;
                    }
                    if (canApply && cartSubtotal > multiplePriceOffer.purchase_price) {
                        offerApplied = true;
                        multiplePriceOfferApplied = true;
                        multiplPriceOfferApplicable = false;
                        if (appliedPriceOffer == null) {
                            appliedPriceOffer = multiplePriceOffer;
                        } else {
                            if (!appliedPriceOffer.id.equalsIgnoreCase(multiplePriceOffer.id)) {
                                appliedPriceOffer = multiplePriceOffer;
                            }
                        }

                        if (getActivity() != null) {
                            getActivity().runOnUiThread(new Runnable() {

                                @Override
                                public void run() {
                                    ivSelectProduct.setVisibility(View.VISIBLE);
                                    llSelectProducts.setVisibility(View.VISIBLE);
                                    tvSelectProducts.setText("Claim free product(s)");
                                    llSelectProducts.setEnabled(true);
                                }
                            });
                        }

                        offerAmount = 0;
                        offerPercentage = 0;
                        cartOffer = 0;

                        ArrayList<OfferProduct> products = appliedPriceOffer.getProducts();
                        for (OfferProduct offerProduct : products) {
                            if (offerProduct.checked && offerProduct.quantity > 0) {
                                CartItem toBeSave = new CartItem();
                                toBeSave.Menu_price = 0;
                                toBeSave.menu_id = 0;
                                toBeSave.id = 0;
                                toBeSave.menu_name = offerProduct.name;
                                toBeSave.menu_size = "";
                                toBeSave.res_id = res_id;
                                toBeSave.menu_type = "";
                                toBeSave.quantity = offerProduct.quantity;
                                toBeSave.Addon_name = "Offer";
                                toBeSave.Addon_price = 0;
                                toBeSave.Total = 0;
                                freeItems.add(toBeSave);
                                if (getActivity() != null) {
                                    getActivity().runOnUiThread(new Runnable() {
                                        @Override
                                        public void run() {
                                            tvSelectProducts.setText("Free product(s) selected, Click to view/change");
                                        }
                                    });
                                }
                            }
                        }

                        return null;
                    }
                    if (canApply) {
                        offerApplied = true;
                        multiplePriceOfferApplied = true;
                        multiplPriceOfferApplicable = true;
                        moveToNext = false;
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    llSelectProducts.setVisibility(View.VISIBLE);
                                    ivSelectProduct.setVisibility(View.INVISIBLE);
                                    tvSelectProducts.setText(String.format("Spend %s%s to claim free product(s)", myApp.getCurrencySymbol(), MyApp.df.format(multiplePriceOffer.purchase_price)));
                                    llSelectProducts.setEnabled(false);
                                }
                            });
                        }

                        return null;
                    }
                }
            }
            multiplePriceOfferApplied = false;
            appliedPriceOffer = null;
            if (getActivity() != null) {
                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        llSelectProducts.setVisibility(View.GONE);
                        llSelectProducts.setEnabled(false);
                    }
                });
            }

            // Set up day offers
            if (restaurant.day_offers != null)
                for (DayOffer dayOffer : restaurant.day_offers) {

                    if (!dayOfTheWeek.equalsIgnoreCase(dayOffer.day)) {
                        break;
                    }
                    if (dayOffer.status == false) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    offerTitle.append("Earn ");
                    if (dayOffer.day_offer_type.equalsIgnoreCase("1")) {
                        offerTitle.append(dayOffer.offer_amount).append("%");
                    } else {
                        offerTitle.append("Flat ").append(myApp.getCurrencySymbol()).append(dayOffer.offer_amount);
                    }
                    offerTitle.append(" OFF on your next purchase");
                    boolean canApply = false;
                    if (cartSubtotal >= dayOffer.purchase_price) {
                        if (orderType == 1 && dayOffer.delivery_type) {
                            canApply = true;
                        }
                        if (orderType == 2 && dayOffer.pickup_type) {
                            canApply = true;
                        }
                        // TODO dinein type;
                    }

                    if (canApply) {
                        offerApplied = true;
                        if (dayOffer.day_offer_type.equalsIgnoreCase("1")) {
                            float amount = dayOffer.offer_amount;
                            cartOffer = cartSubtotal * (amount / 100);
                            offerPercentage = dayOffer.offer_amount;
                        } else {
                            cartOffer = dayOffer.offer_amount;
                            offerAmount = dayOffer.offer_amount;
                        }
                        return null;
                    }

                }
            // set day product offers
            if (restaurant.day_product_offers != null)
                for (DayProductOffer offer : restaurant.day_product_offers) {

                    if (!dayOfTheWeek.equalsIgnoreCase(offer.day_product)) {
                        break;
                    }
                    if (offer.status == false) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    try {
                        offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                        offerSubTitle.append("Offer applicable on minimum purchase of ").append(offer.product_qty).append(" ").append(findMenuItemById(offer.menu_id).menu_name);

                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);
                    CartItem cartItem = findCartItemByMenuId(offer.menu_id);
                    if (cartItem != null) {
                        if (cartItem.quantity >= offer.product_qty) {
                            if (orderType == 1 && offer.delivery_type) {
                                canApply = true;
                            }
                            if (orderType == 2 && offer.pickup_type) {
                                canApply = true;
                            }
                            // TODO dinein type;
                        }
                    }
                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                            Variant selectedVariant = freeItem.variants.get(0);
                            CartItem toBeSave = new CartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = (freeItem.menu_name.equalsIgnoreCase(selectedVariant.sub_name)) ? "" : selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;
                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            offerApplied = true;
                            offerAmount = 0;
                            offerPercentage = 0;
                            cartOffer = 0;
                        }
                        return null;
                    }
                }
            if (restaurant.day_price_offers != null)
                for (DayPriceOffer offer : restaurant.day_price_offers) {

                    if (!dayOfTheWeek.equalsIgnoreCase(offer.day)) {
                        break;
                    }
                    if (offer.status == false) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    try {
                        offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                        offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.purchase_price));

                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);

                    if (cartSubtotal >= offer.purchase_price) {
                        if (orderType == 1 && offer.delivery_type) {
                            canApply = true;
                        }
                        if (orderType == 2 && offer.pickup_type) {
                            canApply = true;
                        }
                        // TODO dinein type;
                    }
                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                            Variant selectedVariant = freeItem.variants.get(0);
                            CartItem toBeSave = new CartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;
                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            offerApplied = true;
                            offerAmount = 0;
                            offerPercentage = 0;
                            cartOffer = 0;
                        }
                        return null;
                    }
                }

            if (restaurant.offers != null)
                for (Offer offer : restaurant.offers) {
                    Date startDate = null, endDate = null;
                    try {
                        startDate = dateFormat.parse(offer.offer_from);
                        endDate = dateFormat.parse(offer.offer_to);

                        if (today.after(endDate)) break;
                        if (today.before(startDate)) break;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    boolean canApply = false;
                    if (offer.first_user.equalsIgnoreCase("y")) {
                        if (loggedInUser.first_user != null && loggedInUser.first_user.equalsIgnoreCase("yes")) {
                            offerTitle.append("Get ").append(MyApp.df.format(offer.free_percentage)).append("%").append(" OFF ").append(" on your next purchase");
                            offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.free_price));
                            if (cartSubtotal >= offer.free_price) {
                                if (orderType == 1 && offer.delivery_type) {
                                    canApply = true;
                                }
                                if (orderType == 2 && offer.pickup_type) {
                                    canApply = true;
                                }
                                // TODO dinein type;
                            }
                            if (canApply) {
                                if (offer.offer_mode.equalsIgnoreCase("flat")) {
                                    cartOffer = offer.free_percentage;
                                } else {
                                    cartOffer = cartSubtotal * (offer.free_percentage / 100);
                                }
                                offerPercentage = (offer.free_percentage);
                                offerAmount = 0;
                                offerApplied = true;
                                return null;
                            }

                        }
                    }
                    if (!canApply && offer.normal.equalsIgnoreCase("y")) {
                        offerTitle.append("Get ").append(MyApp.df.format(offer.normal_percentage)).append("%").append(" OFF ").append(" on your next purchase");
                        offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.normal_price));
                        if (cartSubtotal >= offer.normal_price) {
                            if (orderType == 1 && offer.delivery_type) {
                                canApply = true;
                            }
                            if (orderType == 2 && offer.pickup_type) {
                                canApply = true;
                            }
                            // TODO dinein type;
                        }
                        if (canApply) {
                            offerApplied = true;
                            if (offer.offer_mode.equalsIgnoreCase("flat")) {
                                cartOffer = offer.normal_percentage;
                            } else {
                                cartOffer = cartSubtotal * (offer.free_percentage / 100);
                            }
                            offerPercentage = (offer.free_percentage);
                            offerAmount = 0;
                            return null;
                        }


                    }


                }

            if (restaurant.product_offers != null)
                for (ProductOffer offer : restaurant.product_offers) {
                    Date startDate = null, endDate = null;
                    try {
                        startDate = dateFormat.parse(offer.offer_from);
                        endDate = dateFormat.parse(offer.offer_to);

                        if (today.after(endDate)) break;
                        if (today.before(startDate)) break;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }

                    if (offer.status == false) {
                        break;
                    }

                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    if (getActivity() != null) {
                        getActivity().runOnUiThread(() -> {
                            offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);
                            offerSubTitle.append("Offer applicable on minimum purchase of ").append(offer.product_qty).append(" ").append(findMenuItemById(offer.menu_id).menu_name);

                        });
                    }
                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);
                    CartItem cartItem = findCartItemByMenuId(offer.menu_id);

                    if (cartItem != null) {
                        if (cartItem.quantity >= offer.product_qty) {
                            if (orderType == 1 && offer.delivery_type) {
                                canApply = true;
                            }
                            if (orderType == 2 && offer.pickup_type) {
                                canApply = true;
                            }
                            // TODO dinein type;
                        }
                    }

                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                            Variant selectedVariant = freeItem.variants.get(0);
                            CartItem toBeSave = new CartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;

                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            feed.add(toBeSave);
                            offerAmount = 0;
                            offerPercentage = 0;
                            cartOffer = 0;
                            offerApplied = true;
                        }
                        return null;
                    }

                }
            if (restaurant.price_offers != null)
                for (PriceOffer offer : restaurant.price_offers) {
                    Date startDate = null, endDate = null;
                    try {
                        startDate = dateFormat.parse(offer.offer_from);
                        endDate = dateFormat.parse(offer.offer_to);

                        if (today.after(endDate)) break;
                        if (today.before(startDate)) break;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                    if (offer.status == false) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.purchase_price));
                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);

                    if (cartSubtotal >= offer.purchase_price) {
                        if (orderType == 1 && offer.delivery_type) {
                            canApply = true;
                        }
                        if (orderType == 2 && offer.pickup_type) {
                            canApply = true;
                        }
                        // TODO dinein type;
                    }
                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {

                            Variant selectedVariant = freeItem.variants.get(0);
                            CartItem toBeSave = new CartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;
                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            cartOffer = 0;
                            offerAmount = 0;
                            offerPercentage = 0;
                            offerApplied = true;
                        }
                        return null;
                    }


                }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (nextThing != null) {
                try {
                    nextThing.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private void applyOffers() {
        cartOffer = 0;

        if (offerApplied) {
            freeItems.clear();
            Iterator<Object> iterator = feed.iterator();
            while (iterator.hasNext()) {
                Object object = iterator.next();
                if (object instanceof CartItem) {
                    CartItem c = (CartItem) object;
                    if (c.Addon_name.equalsIgnoreCase("offer")) {
                        iterator.remove();
                    }
                }

            }
            offerApplied = false;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("EEEE");
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date d = new Date();
        String dayOfTheWeek = sdf.format(d);
        Date today = null;
        try {
            today = dateFormat.parse(dateFormat.format(new Date()));
            today = CommonFunctions.convertStringDateToDate(delivery_year + "-" + delivery_month + "-" + delivery_date, "yyyy-MM-dd");
            if (orderType == 1 && selectedDeliveryTimeSlot != null && !Validators.isNullOrEmpty(selectedDeliveryTimeSlot.date)) {
                today = CommonFunctions.convertStringDateToDate(selectedDeliveryTimeSlot.date, "yyyy-MM-dd");
            }

            if (orderType == 2 && selectedPickupTimeSlot != null && !Validators.isNullOrEmpty(selectedPickupTimeSlot.date)) {
                today = CommonFunctions.convertStringDateToDate(selectedPickupTimeSlot.date, "yyyy-MM-dd");
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }
        if (restaurant.multiple_price_offers != null && restaurant.multiple_price_offers.size() > 0) {
            multiplePriceOfferApplied = false;
            if (getActivity() != null) {
                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        tvSelectProducts.setText("Claim your free product(s)");
                    }
                });
            }

            for (MultiplePriceOffer multiplePriceOffer : restaurant.multiple_price_offers) {
                boolean canApply = false;
                if (orderType == 1 && multiplePriceOffer.delivery_type.equalsIgnoreCase("true")) {
                    canApply = true;
                }
                if (orderType == 2 && multiplePriceOffer.pickup_type.equalsIgnoreCase("true")) {
                    canApply = true;
                }
                if (canApply && cartSubtotal > multiplePriceOffer.purchase_price) {
                    offerApplied = true;
                    multiplePriceOfferApplied = true;
                    multiplPriceOfferApplicable = false;
                    if (appliedPriceOffer == null) {
                        appliedPriceOffer = multiplePriceOffer;
                    } else {
                        if (!appliedPriceOffer.id.equalsIgnoreCase(multiplePriceOffer.id)) {
                            appliedPriceOffer = multiplePriceOffer;
                        }
                    }

                    if (getActivity() != null) {
                        getActivity().runOnUiThread(new Runnable() {

                            @Override
                            public void run() {
                                ivSelectProduct.setVisibility(View.VISIBLE);
                                llSelectProducts.setVisibility(View.VISIBLE);
                                tvSelectProducts.setText("Claim free product(s)");
                                llSelectProducts.setEnabled(true);
                            }
                        });
                    }

                    offerAmount = 0;
                    offerPercentage = 0;
                    cartOffer = 0;

                    ArrayList<OfferProduct> products = appliedPriceOffer.getProducts();
                    for (OfferProduct offerProduct : products) {
                        if (offerProduct.checked && offerProduct.quantity > 0) {
                            CartItem toBeSave = new CartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = 0;
                            toBeSave.id = 0;
                            toBeSave.menu_name = offerProduct.name;
                            toBeSave.menu_size = "";
                            toBeSave.res_id = res_id;
                            toBeSave.menu_type = "";
                            toBeSave.quantity = offerProduct.quantity;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            if (getActivity() != null) {
                                getActivity().runOnUiThread(new Runnable() {
                                    @Override
                                    public void run() {
                                        tvSelectProducts.setText("Free product(s) selected, Click to view/change");
                                    }
                                });
                            }
                        }
                    }

                }
                if (canApply) {
                    offerApplied = true;
                    multiplePriceOfferApplied = true;
                    multiplPriceOfferApplicable = true;
                    moveToNext = false;
                    if (getActivity() != null) {
                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                llSelectProducts.setVisibility(View.VISIBLE);
                                ivSelectProduct.setVisibility(View.INVISIBLE);
                                tvSelectProducts.setText(String.format("Spend %s%s to claim free product(s)", myApp.getCurrencySymbol(), MyApp.df.format(multiplePriceOffer.purchase_price)));
                                llSelectProducts.setEnabled(false);
                            }
                        });
                    }

                }
            }
        }
        multiplePriceOfferApplied = false;
        appliedPriceOffer = null;
        if (getActivity() != null) {
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    llSelectProducts.setVisibility(View.GONE);
                    llSelectProducts.setEnabled(false);
                }
            });
        }

        // Set up day offers
        if (restaurant.day_offers != null)
            for (DayOffer dayOffer : restaurant.day_offers) {

                if (!dayOfTheWeek.equalsIgnoreCase(dayOffer.day)) {
                    break;
                }
                if (dayOffer.status == false) {
                    break;
                }
                StringBuilder offerTitle = new StringBuilder();
                offerTitle.append("Earn ");
                if (dayOffer.day_offer_type.equalsIgnoreCase("1")) {
                    offerTitle.append(dayOffer.offer_amount).append("%");
                } else {
                    offerTitle.append("Flat ").append(myApp.getCurrencySymbol()).append(dayOffer.offer_amount);
                }
                offerTitle.append(" OFF on your next purchase");
                boolean canApply = false;
                if (cartSubtotal >= dayOffer.purchase_price) {
                    if (orderType == 1 && dayOffer.delivery_type) {
                        canApply = true;
                    }
                    if (orderType == 2 && dayOffer.pickup_type) {
                        canApply = true;
                    }
                    // TODO dinein type;
                }

                if (canApply) {
                    offerApplied = true;
                    if (dayOffer.day_offer_type.equalsIgnoreCase("1")) {
                        float amount = dayOffer.offer_amount;
                        cartOffer = cartSubtotal * (amount / 100);
                        offerPercentage = dayOffer.offer_amount;
                    } else {
                        cartOffer = dayOffer.offer_amount;
                        offerAmount = dayOffer.offer_amount;
                    }
                }

            }
        // set day product offers
        if (restaurant.day_product_offers != null)
            for (DayProductOffer offer : restaurant.day_product_offers) {

                if (!dayOfTheWeek.equalsIgnoreCase(offer.day_product)) {
                    break;
                }
                if (offer.status == false) {
                    break;
                }
                StringBuilder offerTitle = new StringBuilder();
                StringBuilder offerSubTitle = new StringBuilder();
                try {
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(offer.product_qty).append(" ").append(findMenuItemById(offer.menu_id).menu_name);

                } catch (Exception e) {
                    e.printStackTrace();
                }

                boolean canApply = false;
                Menu freeItem = findMenuItemById(offer.offer_id);
                CartItem cartItem = findCartItemByMenuId(offer.menu_id);
                if (cartItem != null) {
                    if (cartItem.quantity >= offer.product_qty) {
                        if (orderType == 1 && offer.delivery_type) {
                            canApply = true;
                        }
                        if (orderType == 2 && offer.pickup_type) {
                            canApply = true;
                        }
                        // TODO dinein type;
                    }
                }
                if (canApply) {
                    if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                        Variant selectedVariant = freeItem.variants.get(0);
                        CartItem toBeSave = new CartItem();
                        toBeSave.Menu_price = 0;
                        toBeSave.menu_id = selectedVariant.menu_id;
                        toBeSave.id = selectedVariant.id;
                        toBeSave.menu_name = freeItem.menu_name;
                        toBeSave.menu_size = (freeItem.menu_name.equalsIgnoreCase(selectedVariant.sub_name)) ? "" : selectedVariant.sub_name;
                        toBeSave.res_id = freeItem.restaurant_id;
                        toBeSave.menu_type = freeItem.menu_type;
                        toBeSave.quantity = offer.offer_qty;
                        toBeSave.Addon_name = "Offer";
                        toBeSave.Addon_price = 0;
                        toBeSave.Total = 0;
                        freeItems.add(toBeSave);
                        offerApplied = true;
                        offerAmount = 0;
                        offerPercentage = 0;
                        cartOffer = 0;
                    }
                }
            }
        if (restaurant.day_price_offers != null)
            for (DayPriceOffer offer : restaurant.day_price_offers) {

                if (!dayOfTheWeek.equalsIgnoreCase(offer.day)) {
                    break;
                }
                if (offer.status == false) {
                    break;
                }
                StringBuilder offerTitle = new StringBuilder();
                StringBuilder offerSubTitle = new StringBuilder();
                try {
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.purchase_price));

                } catch (Exception e) {
                    e.printStackTrace();
                }

                boolean canApply = false;
                Menu freeItem = findMenuItemById(offer.offer_id);

                if (cartSubtotal >= offer.purchase_price) {
                    if (orderType == 1 && offer.delivery_type) {
                        canApply = true;
                    }
                    if (orderType == 2 && offer.pickup_type) {
                        canApply = true;
                    }
                    // TODO dinein type;
                }
                if (canApply) {
                    if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                        Variant selectedVariant = freeItem.variants.get(0);
                        CartItem toBeSave = new CartItem();
                        toBeSave.Menu_price = 0;
                        toBeSave.menu_id = selectedVariant.menu_id;
                        toBeSave.id = selectedVariant.id;
                        toBeSave.menu_name = freeItem.menu_name;
                        toBeSave.menu_size = selectedVariant.sub_name;
                        toBeSave.res_id = freeItem.restaurant_id;
                        toBeSave.menu_type = freeItem.menu_type;
                        toBeSave.quantity = offer.offer_qty;
                        toBeSave.Addon_name = "Offer";
                        toBeSave.Addon_price = 0;
                        toBeSave.Total = 0;
                        freeItems.add(toBeSave);
                        offerApplied = true;
                        offerAmount = 0;
                        offerPercentage = 0;
                        cartOffer = 0;
                    }
                }
            }

        if (restaurant.offers != null)
            for (Offer offer : restaurant.offers) {
                Date startDate = null, endDate = null;
                try {
                    startDate = dateFormat.parse(offer.offer_from);
                    endDate = dateFormat.parse(offer.offer_to);

                    if (today.after(endDate)) break;
                    if (today.before(startDate)) break;
                } catch (ParseException e) {
                    e.printStackTrace();
                }
                StringBuilder offerTitle = new StringBuilder();
                StringBuilder offerSubTitle = new StringBuilder();
                boolean canApply = false;
                if (offer.first_user.equalsIgnoreCase("y")) {
                    if (loggedInUser.first_user != null && loggedInUser.first_user.equalsIgnoreCase("yes")) {
                        offerTitle.append("Get ").append(MyApp.df.format(offer.free_percentage)).append("%").append(" OFF ").append(" on your next purchase");
                        offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.free_price));
                        if (cartSubtotal >= offer.free_price) {
                            if (orderType == 1 && offer.delivery_type) {
                                canApply = true;
                            }
                            if (orderType == 2 && offer.pickup_type) {
                                canApply = true;
                            }
                            // TODO dinein type;
                        }
                        if (canApply) {
                            if (offer.offer_mode.equalsIgnoreCase("flat")) {
                                cartOffer = offer.free_percentage;
                            } else {
                                cartOffer = cartSubtotal * (offer.free_percentage / 100);
                            }
                            offerPercentage = (offer.free_percentage);
                            offerAmount = 0;
                            offerApplied = true;
                        }

                    }
                }
                if (!canApply && offer.normal.equalsIgnoreCase("y")) {
                    offerTitle.append("Get ").append(MyApp.df.format(offer.normal_percentage)).append("%").append(" OFF ").append(" on your next purchase");
                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.normal_price));
                    if (cartSubtotal >= offer.normal_price) {
                        if (orderType == 1 && offer.delivery_type) {
                            canApply = true;
                        }
                        if (orderType == 2 && offer.pickup_type) {
                            canApply = true;
                        }
                        // TODO dinein type;
                    }
                    if (canApply) {
                        offerApplied = true;
                        if (offer.offer_mode.equalsIgnoreCase("flat")) {
                            cartOffer = offer.normal_percentage;
                        } else {
                            cartOffer = cartSubtotal * (offer.normal_percentage / 100);
                        }
                        offerPercentage = (offer.normal_percentage);
                        offerAmount = 0;
                    }


                }


            }

        if (restaurant.product_offers != null)
            for (ProductOffer offer : restaurant.product_offers) {
                Date startDate = null, endDate = null;
                try {
                    startDate = dateFormat.parse(offer.offer_from);
                    endDate = dateFormat.parse(offer.offer_to);

                    if (today.after(endDate)) break;
                    if (today.before(startDate)) break;
                } catch (ParseException e) {
                    e.printStackTrace();
                }

                if (offer.status == false) {
                    break;
                }

                StringBuilder offerTitle = new StringBuilder();
                StringBuilder offerSubTitle = new StringBuilder();
                if (getActivity() != null) {
                    getActivity().runOnUiThread(() -> {
                        offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);
                        offerSubTitle.append("Offer applicable on minimum purchase of ").append(offer.product_qty).append(" ").append(findMenuItemById(offer.menu_id).menu_name);

                    });
                }
                boolean canApply = false;
                Menu freeItem = findMenuItemById(offer.offer_id);
                CartItem cartItem = findCartItemByMenuId(offer.menu_id);

                if (cartItem != null) {
                    if (cartItem.quantity >= offer.product_qty) {
                        if (orderType == 1 && offer.delivery_type) {
                            canApply = true;
                        }
                        if (orderType == 2 && offer.pickup_type) {
                            canApply = true;
                        }
                        // TODO dinein type;
                    }
                }

                if (canApply) {
                    if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                        Variant selectedVariant = freeItem.variants.get(0);
                        CartItem toBeSave = new CartItem();
                        toBeSave.Menu_price = 0;
                        toBeSave.menu_id = selectedVariant.menu_id;
                        toBeSave.id = selectedVariant.id;
                        toBeSave.menu_name = freeItem.menu_name;
                        toBeSave.menu_size = selectedVariant.sub_name;
                        toBeSave.res_id = freeItem.restaurant_id;
                        toBeSave.menu_type = freeItem.menu_type;

                        toBeSave.quantity = offer.offer_qty;
                        toBeSave.Addon_name = "Offer";
                        toBeSave.Addon_price = 0;
                        toBeSave.Total = 0;
                        feed.add(toBeSave);
                        offerAmount = 0;
                        offerPercentage = 0;
                        cartOffer = 0;
                        offerApplied = true;
                    }
                }

            }
        if (restaurant.price_offers != null)
            for (PriceOffer offer : restaurant.price_offers) {
                Date startDate = null, endDate = null;
                try {
                    startDate = dateFormat.parse(offer.offer_from);
                    endDate = dateFormat.parse(offer.offer_to);

                    if (today.after(endDate)) break;
                    if (today.before(startDate)) break;
                } catch (ParseException e) {
                    e.printStackTrace();
                }
                if (offer.status == false) {
                    break;
                }
                StringBuilder offerTitle = new StringBuilder();
                StringBuilder offerSubTitle = new StringBuilder();
                offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.purchase_price));
                boolean canApply = false;
                Menu freeItem = findMenuItemById(offer.offer_id);

                if (cartSubtotal >= offer.purchase_price) {
                    if (orderType == 1 && offer.delivery_type) {
                        canApply = true;
                    }
                    if (orderType == 2 && offer.pickup_type) {
                        canApply = true;
                    }
                    // TODO dinein type;
                }
                if (canApply) {
                    if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {

                        Variant selectedVariant = freeItem.variants.get(0);
                        CartItem toBeSave = new CartItem();
                        toBeSave.Menu_price = 0;
                        toBeSave.menu_id = selectedVariant.menu_id;
                        toBeSave.id = selectedVariant.id;
                        toBeSave.menu_name = freeItem.menu_name;
                        toBeSave.menu_size = selectedVariant.sub_name;
                        toBeSave.res_id = freeItem.restaurant_id;
                        toBeSave.menu_type = freeItem.menu_type;
                        toBeSave.quantity = offer.offer_qty;
                        toBeSave.Addon_name = "Offer";
                        toBeSave.Addon_price = 0;
                        toBeSave.Total = 0;
                        freeItems.add(toBeSave);
                        cartOffer = 0;
                        offerAmount = 0;
                        offerPercentage = 0;
                        offerApplied = true;
                    }
                }
            }
    }

    private class RemoveFreeItemAsync extends AsyncTask<String, String, String> {
        Callable<Void> nextThing;

        public RemoveFreeItemAsync(Callable<Void> nextThing) {
            this.nextThing = nextThing;
        }

        @Override
        protected String doInBackground(String... strings) {
            freeItems.clear();
            Iterator<Object> iterator = feed.iterator();
            while (iterator.hasNext()) {
                Object object = iterator.next();
                if (object instanceof CartItem) {
                    CartItem c = (CartItem) object;
                    if (c.Addon_name.equalsIgnoreCase("offer")) {
                        iterator.remove();
                    }
                }

            }
            offerApplied = false;
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (nextThing != null) {
                try {
                    nextThing.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private void removeSuggestedMenuItems() {
        suggestedMenuItems.clear();
        Iterator<Object> iterator = feed.iterator();
        while (iterator.hasNext()) {
            Object object = iterator.next();
            if (object instanceof Header) {
                iterator.remove();
            }
            if (object instanceof Menu) {
                iterator.remove();
            }
        }
    }

    private Menu findMenuItemById(int id) {
        if (id != -1) {
            Menu toBeFineMenu = new Menu();
            toBeFineMenu.id = id;
            int menuIndex = restaurant_menu.indexOf(toBeFineMenu);
            if (menuIndex != -1) {
                return restaurant_menu.get(menuIndex);
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    private CartItem findCartItemByMenuId(int id) {
        if (id != -1) {
            CartItem toBeFineMenu = new CartItem();
            toBeFineMenu.menu_id = id;
            int menuIndex = cartItems.indexOf(toBeFineMenu);
            if (menuIndex != -1) {
                return cartItems.get(menuIndex);
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    @Override
    public void onResume() {
        if (mapFragment != null)
            mapFragment.onResume();
        super.onResume();
    }

    @Override
    public void onPause() {
        if (mapFragment != null) mapFragment.onPause();
        if (progressDialog != null) progressDialog.dismiss();
        super.onPause();
    }

    @Override
    public void onStop() {
        if (mapFragment != null) mapFragment.onStop();
        if (progressDialog != null) progressDialog.dismiss();
        super.onStop();
    }

    @Override
    public void onDestroy() {
        if (mapFragment != null)
            mapFragment.onDestroy();
        if (progressDialog != null) progressDialog.dismiss();
        super.onDestroy();
    }
}
