package com.tiffintom.fragment;

import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.google.android.material.bottomsheet.BottomSheetDialogFragment;
import com.tiffintom.R;
import com.tiffintom.interfaces.DialogDismissListener;

public class DeliveryInstructionsBottomsheetFragment extends BottomSheetDialogFragment {
    private DialogDismissListener dialogDismissListener;
    private EditText etInstructions;
    private Button btnSubmit;

    public static DeliveryInstructionsBottomsheetFragment getInstance(String instructions) {
        DeliveryInstructionsBottomsheetFragment deliveryInstructionsBottomsheetFragment = new DeliveryInstructionsBottomsheetFragment();
        Bundle bundle = new Bundle();
        bundle.putString("instructions", instructions);
        deliveryInstructionsBottomsheetFragment.setArguments(bundle);
        return deliveryInstructionsBottomsheetFragment;
    }

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    @Override
    public int getTheme() {
        if (Build.VERSION.SDK_INT > 21) {
            return R.style.BottomSheetDialogTheme;
        } else {
            return super.getTheme();
        }
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_delivery_instruction, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initViews(view);
        setListners();
    }

    private void setListners() {
        btnSubmit.setOnClickListener(view1 -> {
            if (dialogDismissListener != null)
                dialogDismissListener.onDialogDismiss(etInstructions.getText().toString());
            dismiss();
        });
    }

    private void initViews(View view) {

        etInstructions = view.findViewById(R.id.etInstructions);
        btnSubmit = view.findViewById(R.id.btnSubmit);
        if (getArguments() != null) {
            etInstructions.setText(getArguments().getString("instructions"));
        }
    }

}
