package com.tiffintom.fragment;

import static com.tiffintom.network.ApiEndPoints.payment_intent;
import static com.tiffintom.utils.Constants.CODE_NO_INTERNET;
import static com.tiffintom.utils.Constants.CODE_PAYPAL;
import static com.tiffintom.utils.Constants.CODE_REFRESH;

import android.animation.Animator;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.PorterDuffColorFilter;
import android.graphics.drawable.ColorDrawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.os.Handler;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.airbnb.lottie.LottieAnimationView;
import com.airbnb.lottie.LottieProperty;
import com.airbnb.lottie.model.KeyPath;
import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONArrayRequestListener;
import com.androidnetworking.interfaces.JSONObjectRequestListener;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.stripe.android.ApiResultCallback;
import com.stripe.android.PaymentIntentResult;
import com.stripe.android.Stripe;
import com.stripe.android.model.ConfirmPaymentIntentParams;
import com.stripe.android.model.PaymentIntent;
import com.tiffintom.MyApp;
import com.tiffintom.R;
import com.tiffintom.activity.AuthActivity;
import com.tiffintom.activity.MainActivity;
import com.tiffintom.activity.NoInternetActivity;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.adapters.CartBasketItemsAdapter;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.common.Validators;
import com.tiffintom.interfaces.DialogDismissListener;
import com.tiffintom.interfaces.MoneyTextWatcher;
import com.tiffintom.models.BusinessRestaurant;
import com.tiffintom.models.Cart;
import com.tiffintom.models.CartSummary;
import com.tiffintom.models.DayOffer;
import com.tiffintom.models.DayPriceOffer;
import com.tiffintom.models.DayProductOffer;
import com.tiffintom.models.DineinCartItem;
import com.tiffintom.models.DineinModels.CreateOrderAddonParmsItem;
import com.tiffintom.models.DineinModels.CreateOrderIngredientParamsItem;
import com.tiffintom.models.DineinModels.CreateOrderParamsItem;
import com.tiffintom.models.DineinModels.CreatedOrder;
import com.tiffintom.models.DineinModels.CustomerParams;
import com.tiffintom.models.DineinModels.DineinPaymentMethods;
import com.tiffintom.models.DineinModels.DineinSiteSettings;
import com.tiffintom.models.DineinModels.DineinVoucherList;
import com.tiffintom.models.DineinModels.Discount;
import com.tiffintom.models.DineinModels.OrderItem;
import com.tiffintom.models.DineinModels.OrderItemAddon;
import com.tiffintom.models.DineinModels.OrderItemIngredient;
import com.tiffintom.models.DineinModels.TablesStatuses;
import com.tiffintom.models.Menu;
import com.tiffintom.models.MultiplePriceOffer;
import com.tiffintom.models.Offer;
import com.tiffintom.models.OfferProduct;
import com.tiffintom.models.OfferSimplify;
import com.tiffintom.models.PaymentMethod;
import com.tiffintom.models.Postcode;
import com.tiffintom.models.PriceOffer;
import com.tiffintom.models.ProductOffer;
import com.tiffintom.models.RestaurantVoucher;
import com.tiffintom.models.User;
import com.tiffintom.models.Variant;
import com.tiffintom.network.ApiEndPoints;
import com.tiffintom.network.ApiUtils;
import com.tiffintom.utils.LogUtils;
import com.tiffintom.utils.ToastUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.lang.reflect.Type;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.Callable;

/**
 * Created by Amrish on 24-09-2020.
 */
public class DineinCartCheckoutFragment extends BaseFragment {

    public static DineinCartCheckoutFragment getInstance() {
        return new DineinCartCheckoutFragment();
    }

    private User loggedInUser;
    private RecyclerView rvCartItems;
    private ArrayList<Object> feed = new ArrayList<>();
    private ArrayList<DineinCartItem> cartItems = new ArrayList<>();
    private ArrayList<DineinCartItem> freeItems = new ArrayList<>();
    private ArrayList<Menu> suggestedMenuItems = new ArrayList<>();
    private CartBasketItemsAdapter cartBasketItemsAdapter;
    private PaymentMethod paymentMethod;
    private CartSummary cartSummary;
    private BusinessRestaurant restaurant;
    private ArrayList<OfferSimplify> offers = new ArrayList<>();
    private RestaurantVoucher appliedVoucher;
    private String currency = myApp.getCurrencySymbol();
    private ArrayList<Menu> restaurant_menu = new ArrayList<>();
    private ArrayList<Menu> restaurant_dinein_menu = new ArrayList<>();
    private ArrayList<Cart> cartArray = new ArrayList<>();
    Postcode defaultPostCode = myApp.getMyPreferences().getCurrentPostcode();

    private TextView tvTableNumber, tvNumberOfGuests, tvAddressUsername, tvCharityAmount;
    private TextView tvSubTotal, tvServicesFee, tvDiscount, tvDiscountTitle, tvTotal, tvOrderTotal, tvPayOrder;
    private TextView tvPaymentMethodName, tvWalletSplitName, tvWalletSplitInfo, tvVoucherList;
    private LinearLayout llPromocode, llCharity, llTip, llServiceCharge, llDiscount, llSubTotal;
    private LinearLayout llPaymentMethod, llWalletSplit;
    private LinearLayout llLoading, llPlaceOrder, llSelectProducts;
    private TextView tvSelectProducts;
    private ImageView ivSelectProducts;

    private EditText etPromocode;
    private EditText etOrderInstruction;
    private Button btnPromoApply;

    private CheckBox cbCharity;
    private RadioGroup rgGratuity;
    private RadioButton rb1, rb2, rbNo, rbCustom, rbEdit;
    private LinearLayout llCharityTitle, llTipTitle;
    private TextView tvCharityMessageTitle, tvCharityAmountTitle, tvTipAmount;

    private float cartSubtotal = 0, cartServiceFee = 0, cartDeliveryFee = 0, cartDiscount = 0, cartTotal = 0, voucherDiscount, cartGratuity = 0, cartCharity = 0, cartOffer = 0, offerAmount, offerPercentage;
    private boolean voucherApplied = false;

    private ImageView ivPaymentMethod;
    private ImageView ivBackArrow, ivCloseSplit;
    private ImageView ivRestaurantLogo;

    private LinearLayout llData;
    private String qrCode;
    private RelativeLayout rlNoData;

    private ProgressBar pbLoading;
    private LottieAnimationView animationCartItemLoading;
    private String tableNumber, tableId;
    private int totalGuests;

    boolean paidFull = true, split = false;

    private ArrayList<OrderItemAddon> orderItemAddons = new ArrayList<>();
    private ArrayList<OrderItemIngredient> orderItemIngredients = new ArrayList<>();
    private ArrayList<OrderItem> orderItems = new ArrayList<>();
    private ArrayList<DineinPaymentMethods> prefrencePaymentMethod = new ArrayList<>();
    private DineinSiteSettings gratuitySettings, serviceChargeEnableSetting, serviceChargeSetting, serviceChargeOptionSetting, serviceChargeTypeSetting, orderCompleteSetting;
    private DineinPaymentMethods cashPayment, cardPayment, voucherPayment;
    private ArrayList<Discount> discounts = new ArrayList<>();
    private boolean serviceChargeAutoMode = true, serviceChargeVisible = false,
            serviceChargeEnabled = false, voucherPaymentsEnabled = false,
            discountEnabled = true, gratuityEnabled = true, autoDiscountApplied = false;

    private int table_status_id;
    private String business_id;
    private CreatedOrder createdOrder;
    private ArrayList<TablesStatuses> tablesStatuses = new ArrayList<>();

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        qrCode = getArguments().getString("qr_code");
        totalGuests = getArguments().getInt("guests");
        tableNumber = getArguments().getString("table_number");
        tableId = getArguments().getString("table_id");
        business_id = getArguments().getString("business_id");
        createdOrder = new Gson().fromJson(getArguments().getString("created_order"), CreatedOrder.class);

        firstMethod();
        return inflater.inflate(R.layout.fragment_dine_in_checkout, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        updateViews();
        setListeners();
    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);
        loggedInUser = myApp.getMyPreferences().getLoggedInUser();
        prefrencePaymentMethod.addAll(myApp.getMyPreferences().getDineinPaymentMethods());
        llLoading = view.findViewById(R.id.llLoading);
        llData = view.findViewById(R.id.llData);
        rlNoData = view.findViewById(R.id.llNoData);
        tvVoucherList = view.findViewById(R.id.tvVoucherLists);
        tvAddressUsername = view.findViewById(R.id.tvAddressUsername);
        tvTableNumber = view.findViewById(R.id.tvTableNumber);
        tvNumberOfGuests = view.findViewById(R.id.tvNumberOfGuests);
        ivRestaurantLogo = view.findViewById(R.id.ivRestaurantLogo);
        tvSelectProducts = view.findViewById(R.id.tvSelectProducts);
        llSelectProducts = view.findViewById(R.id.llSelectProducts);
        llSelectProducts.setEnabled(false);
        llSelectProducts.setVisibility(View.GONE);
        ivSelectProducts = view.findViewById(R.id.ivSelectProducts);
        llTip = view.findViewById(R.id.llTip);
        rgGratuity = view.findViewById(R.id.rgTip);
        rbNo = view.findViewById(R.id.rbNo);
        rb1 = view.findViewById(R.id.rb1);
        rb2 = view.findViewById(R.id.rb2);
        rbEdit = view.findViewById(R.id.rbEdit);
        rbCustom = view.findViewById(R.id.rbCustom);

        rvCartItems = view.findViewById(R.id.rvCartItems);
        rvCartItems.setNestedScrollingEnabled(false);
        rvCartItems.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));

        llPromocode = view.findViewById(R.id.llPromocode);
        etPromocode = view.findViewById(R.id.etPromocode);
        btnPromoApply = view.findViewById(R.id.btnPromoApply);

        llCharity = view.findViewById(R.id.llCharity);
        cbCharity = view.findViewById(R.id.cbCharity);
        tvCharityAmount = view.findViewById(R.id.tvCharityAmount);

        tvSubTotal = view.findViewById(R.id.tvSubtotal);
        tvServicesFee = view.findViewById(R.id.tvServiceFee);
        tvTotal = view.findViewById(R.id.tvTotal);
        tvDiscount = view.findViewById(R.id.tvDiscount);
        tvDiscountTitle = view.findViewById(R.id.tvDiscountTitle);

        llDiscount = view.findViewById(R.id.ll_Discount);
        llSubTotal = view.findViewById(R.id.ll_SubTotal);
        llServiceCharge = view.findViewById(R.id.ll_ServiceCharge);
        tvWalletSplitName = view.findViewById(R.id.tvWalletSplitName);
        tvWalletSplitInfo = view.findViewById(R.id.tvWalletSplitInfo);
        llWalletSplit = view.findViewById(R.id.llWalletSplit);
        ivCloseSplit = view.findViewById(R.id.ivCloseSplit);

        llPaymentMethod = view.findViewById(R.id.llPaymentMethod);
        ivPaymentMethod = view.findViewById(R.id.ivPaymentMethod);
        tvPaymentMethodName = view.findViewById(R.id.tvPaymentMethodName);

        etOrderInstruction = view.findViewById(R.id.etOrderInstruction);
        tvPayOrder = view.findViewById(R.id.tvPayOrder);

        llPlaceOrder = view.findViewById(R.id.llPlaceOrder);
        tvOrderTotal = view.findViewById(R.id.tvOrderTotal);
        llPaymentMethod.setVisibility(View.GONE);

        llCharityTitle = view.findViewById(R.id.ll_CharityTitle);
        tvCharityMessageTitle = view.findViewById(R.id.tvCharityMessageTitle);
        tvCharityAmountTitle = view.findViewById(R.id.tvCharityAmountTitle);

        llTipTitle = view.findViewById(R.id.ll_TipTitle);
        tvTipAmount = view.findViewById(R.id.tvTipAmountTitle);
        animationCartItemLoading = view.findViewById(R.id.animationCartItemLoading);

        llPromocode.setVisibility(View.GONE);
        loadSettings();
        //getCustomerDetails();
        cartBasketItemsAdapter = new CartBasketItemsAdapter(getActivity(), feed, true, (position, data) -> {
            if (data instanceof DineinCartItem) {
                incrementQuantity(position, data);
            } else if (data instanceof Menu) {
                if (((Menu) data).price_option.equalsIgnoreCase("multiple") || ((Menu) data).menu_addon.equalsIgnoreCase("yes")) {
                    MenuItemDetailBottomsheetFragment menuItemDetailBottomsheetFragment = MenuItemDetailBottomsheetFragment.getInstance((Menu) data, true);
                    menuItemDetailBottomsheetFragment.show(getChildFragmentManager(), "addon");
                    menuItemDetailBottomsheetFragment.setDialogDismissListener(addItemCartDialogListener);
                } else {
                    addItemToCart((Menu) data, position);
                }
            }
        }, (position, data) -> {
            if (data instanceof DineinCartItem) {
                decrementQuantity(position, data);
            }
        });
        rvCartItems.setAdapter(cartBasketItemsAdapter);
        LottieAnimationView loadingView = view.findViewById(R.id.lodingView);
        loadingView.addValueCallback(
                new KeyPath("**"),
                LottieProperty.COLOR_FILTER,
                frameInfo -> new PorterDuffColorFilter(ContextCompat.getColor(getActivity(), R.color.colorPrimary), PorterDuff.Mode.SRC_ATOP)
        );

        animationCartItemLoading.addValueCallback(
                new KeyPath("**"),
                LottieProperty.COLOR_FILTER,
                frameInfo -> new PorterDuffColorFilter(ContextCompat.getColor(getActivity(), R.color.colorPrimary), PorterDuff.Mode.SRC_ATOP)
        );
    }

    private void loadSettings() {
        gratuitySettings = myApp.findSetting("gratuity");

        serviceChargeEnableSetting = myApp.findSetting("is_service_charge");
        serviceChargeSetting = myApp.findSetting("service_charge");
        serviceChargeOptionSetting = myApp.findSetting("service_charge_type_option");
        serviceChargeTypeSetting = myApp.findSetting("service_charge_type");

        cashPayment = myApp.findPaymentEnabled("Cash");
        cardPayment = myApp.findPaymentEnabled("Credit Card Manual");//or may b others
        voucherPayment = myApp.findPaymentEnabled("Voucher");
        orderCompleteSetting = myApp.findSetting("order_complete_mode");
        if (serviceChargeEnableSetting != null && (serviceChargeEnableSetting.value.equalsIgnoreCase("true") || serviceChargeEnableSetting.value.equalsIgnoreCase("1"))) {
            serviceChargeEnabled = true;
            serviceChargeVisible = true;
        }
        if (serviceChargeEnabled && serviceChargeOptionSetting != null && serviceChargeOptionSetting.value.equalsIgnoreCase("manual")) {
            serviceChargeAutoMode = false;
        }

        if (cashPayment != null && cardPayment != null) {
            if (cashPayment.disabled.equalsIgnoreCase("false") && cardPayment.disabled.equalsIgnoreCase("false")) {
                //pay btn show
                tvPayOrder.setVisibility(View.VISIBLE);
            } else {
                //pay btn hide
                tvPayOrder.setVisibility(View.GONE);
            }
        }

        if (voucherPayment != null && voucherPayment.disabled.equalsIgnoreCase("false")) {
            //apply voucher option show
            llPromocode.setVisibility(View.VISIBLE);
        } else {
            //apply voucher option hide
            llPromocode.setVisibility(View.GONE);
        }
        tablesStatuses.clear();
        tablesStatuses.addAll(myApp.getMyPreferences().getDineinTablesStatus());
    }

    private void fetchAutoDiscount() {
        AndroidNetworking.get(ApiEndPoints.dinein_discount)
                .addHeaders("business-id", restaurant.business.id)
                .addQueryParameter("nopaginate", "1")
                .build()
                .getAsJSONArray(new JSONArrayRequestListener() {
                    @Override
                    public void onResponse(JSONArray response) {

                        Type type = new TypeToken<List<Discount>>() {
                        }.getType();
                        discounts.clear();
                        discounts = new Gson().fromJson(response.toString(), type);
                        if (discounts.size() > 0) {
                            Discount appliedDiscount = discounts.get(0);
                            autoDiscountApplied = false;
                            if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("flat")) {
                                if (cartSubtotal > 0)
                                    cartDiscount = appliedDiscount.discount;
                                else cartDiscount = 0;
                                autoDiscountApplied = true;
                            }
                            if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("percentage")) {
                                if (cartSubtotal > 0)
                                    cartDiscount = cartSubtotal * appliedDiscount.discount / 100;
                                else cartDiscount = 0;
                                autoDiscountApplied = true;
                            }
                        }
                        showCalculatedAmountsAndMoveNext();
                    }

                    @Override
                    public void onError(ANError anError) {
                        LogUtils.e("Discount error::" + new Gson().toJson(anError.getErrorBody()));
                        showCalculatedAmountsAndMoveNext();
                        if (discounts.size() == 0) {
                            if (autoDiscountApplied) cartDiscount = 0;
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }

    private void setListeners() {
        btnPromoApply.setOnClickListener(view -> {
            if (voucherApplied) {
                voucherApplied = false;
                appliedVoucher = null;
                validateVoucher(false);
                ToastUtils.makeToast(getActivity(), "Promo code removed");
                etPromocode.setHint("Enter promo code");
            } else {
                if (!Validators.isNullOrEmpty(etPromocode.getText().toString())) {
                    new Thread(() -> applyPromocode()).start();
                } else {
                    ToastUtils.makeToast(getActivity(), "Please enter promo code first");
                }
            }
        });
        tvVoucherList.setOnClickListener(view -> {
            DineinVoucherListBottomsheetFragment voucherListBottomsheetFragment = DineinVoucherListBottomsheetFragment.getInstance(restaurant, 0);
            voucherListBottomsheetFragment.show(getActivity().getSupportFragmentManager(), "vouchers");
            voucherListBottomsheetFragment.setDialogDismissListener((data) -> {
                if (data instanceof DineinVoucherList) {
                    etPromocode.setText(((DineinVoucherList) data).voucher_code);
                    applyPromocode();
                }
            });
        });
        ivCloseSplit.setOnClickListener(view -> {
            updateCartTotal();
            llWalletSplit.setVisibility(View.GONE);
            split = false;
            paidFull = true;
        });
        rgGratuity.setOnCheckedChangeListener((radioGroup, i) -> {
            if (i == R.id.rbNo) {
                cartGratuity = 0;
            } else if (i == R.id.rb1) {
                cartGratuity = 1;
            } else if (i == R.id.rb2) {
                cartGratuity = 2;
            } else if (i == R.id.rbCustom) {
                cartGratuity = customerTipAmount;
            } else if (i == R.id.rbEdit) {
                showEditGratuity();
            }
            updateCartTotal();
        });
        cbCharity.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) cartCharity = myApp.getMyPreferences().getSiteSettings().charity_amount;
            else cartCharity = 0;
            updateCartTotal();
        });
        tvPayOrder.setOnClickListener(view -> {
            if (isValidOrder()) {
                showPaymentMethod();
            }
        });
        llPlaceOrder.setOnClickListener(view -> {
            if (createdOrder == null) {
                if (isValidOrder())
                    createOrder(true);
            } else {
                updateOrderItem(true);
            }
        });
        llSelectProducts.setOnClickListener(view -> {
            MultipleFreeItemsOfferBottomFragment multipleFreeItemsOfferBottomFragment = MultipleFreeItemsOfferBottomFragment.getInstance(appliedPriceOffer, appliedPriceOffer.getProducts());
            multipleFreeItemsOfferBottomFragment.show(getChildFragmentManager(), "multiple_product_offers");
            multipleFreeItemsOfferBottomFragment.setDialogDismissListener((o) -> {
                new RemoveFreeItemAsync(() -> {
                    if (o instanceof MultiplePriceOffer) {
                        appliedPriceOffer = (MultiplePriceOffer) o;
                        tvSelectProducts.setText("Free product(s) selected, Click to view/change");
                        ArrayList<OfferProduct> products = appliedPriceOffer.getProducts();
                        for (OfferProduct offerProduct : products) {
                            if (offerProduct.checked && offerProduct.quantity > 0) {
                                DineinCartItem toBeSave = new DineinCartItem();
                                toBeSave.Menu_price = 0;
                                toBeSave.menu_id = 0;
                                toBeSave.id = 0;
                                toBeSave.menu_name = offerProduct.name;
                                toBeSave.menu_size = "";
                                toBeSave.res_id = restaurant.id;
                                toBeSave.menu_type = "";
                                toBeSave.quantity = offerProduct.quantity;
                                toBeSave.Addon_name = "Offer";
                                toBeSave.Addon_price = 0;
                                toBeSave.Total = 0;
                                freeItems.add(toBeSave);
                                offerApplied = true;
                            }
                        }
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                feed.addAll(freeItems);
                                cartBasketItemsAdapter.notifyDataSetChanged();

                            });
                        }
                    }

                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            });

        });
    }

    private void showPaymentMethod() {
        PaymentMethodsBottomSheetFragment paymentMethodsFragment = PaymentMethodsBottomSheetFragment.getInstance(true, restaurant.payment_methods, restaurant.wallet_payment, restaurant.dinein_wallet_payment, ((paymentMethod != null) ? paymentMethod : new PaymentMethod()));
        paymentMethodsFragment.show(getChildFragmentManager(), "select_payment_method");
        paymentMethodsFragment.setDialogDismissListener(paymentMethodSelectListener);
    }

    DialogDismissListener paymentMethodSelectListener = new DialogDismissListener() {
        @Override
        public void onDialogDismiss(Object o) {
            if (o instanceof PaymentMethod) {
                paymentMethod = (PaymentMethod) o;
                validatePaymentMethod();
                //check if payment is split or not
                if (createdOrder != null) {
                    selectPaymentMethod();
                } else {
                    createOrder(false);
                }
            }
        }
    };

    private void selectPaymentMethod() {
        if (paymentMethod.type.equalsIgnoreCase("stripe")) {
            createPaymentIntent();
        } else if (paymentMethod.type.equalsIgnoreCase("cod")) {
            if (isValidOrder()) payOrder("1", String.valueOf(getCartTotal()));
        }
    }

    String voucher_id, cc_number, txn_id;

    private void payOrder(String payment_method_id, String amount) {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> progressDialog.show());
        }
        HashMap<String, String> hashMap = new HashMap<>();
        hashMap.put("order_id", String.valueOf(createdOrder.id));
        hashMap.put("payment_method_id", payment_method_id);
        hashMap.put("amount", amount);
        hashMap.put("updater_id", String.valueOf(myApp.getMyPreferences().getDineinUser().id));
        if (!Validators.isNullOrEmpty(voucher_id))
            hashMap.put("voucher_id", voucher_id);
        if (!Validators.isNullOrEmpty(cc_number))
            hashMap.put("cc_number", cc_number);
        if (!Validators.isNullOrEmpty(txn_id))
            hashMap.put("txn_id", txn_id);

        AndroidNetworking.post(ApiEndPoints.dinein_payment)
                .addBodyParameter(hashMap)
                .addHeaders("business-id", restaurant.business.id)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.hide());
                        }

                        LogUtils.e("payment successfull" + new Gson().toJson(response));
                        try {
                            if (orderCompleteSetting.value.equalsIgnoreCase("auto")) {
                                changeTableStatus("vacant", true, response.getString("id"));
                            } else {
                                changeTableStatus("served and paid", true, response.getString("id"));
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        }


                    }

                    @Override
                    public void onError(ANError anError) {
                        LogUtils.e("error" + anError.getErrorBody());
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.hide());
                        }
                    }
                });
    }

    boolean isPaidFull;

    private void showDineinOrderPlacedDialog(String orderId) {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View dialogView = inflater.inflate(R.layout.dialog_order_placed, null);

        LottieAnimationView lottieAnimationView = dialogView.findViewById(R.id.animation_view);

        lottieAnimationView.addAnimatorListener(new Animator.AnimatorListener() {
            @Override
            public void onAnimationStart(Animator animator) {

            }

            @Override
            public void onAnimationEnd(Animator animator) {
                new Handler(Looper.myLooper()).postDelayed(() -> {
                    alertDialog.dismiss();
                    new Thread(() -> {
                        myApp.getAppDatabase().dineinCartItemDao().nukeTable();
                        myApp.getAppDatabase().dineinOrderItemDao().nukeTable();
                        TransportActivity.isOrderPlaced = true;
                        startActivity(new Intent(getActivity(), MainActivity.class).setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP));
                        if (getActivity() != null) getActivity().finish();

                        //pending when voucher is used and some amount is paid via voucher then isPaidFull will false else true
//                        if (isPaidFull) {
//                            //GO to dinein home
//                            Intent intent = getActivity().getIntent();
//                            intent.putExtra("order_id", orderId);
//                            //  setReul
//                        } else {
//                            //Go to res home
//
//                        }
                    }).start();
                }, 10);

            }

            @Override
            public void onAnimationCancel(Animator animator) {

            }

            @Override
            public void onAnimationRepeat(Animator animator) {

            }
        });
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();
    }

    private HashMap<String, String> generatePaymentIntentParams() {
        HashMap<String, String> params = new HashMap<>();
        params.put("restaurant_id", String.valueOf(restaurant.id));
        params.put("customer_id", String.valueOf(loggedInUser.id));
        params.put("stripe_token_id", paymentMethod.stripe_token_id);
        params.put("stripe_customer_id", paymentMethod.stripe_customer_id);
        if (restaurant.business.connect_service) {
            params.put("service_type", "connect");
        } else {
            params.put("service_type", "normal");
        }
        if (split)
            params.put("amount", MyApp.df.format(getCartTotal() - loggedInUser.wallet_amount));
        else
            params.put("amount", MyApp.df.format(getCartTotal()));

        LogUtils.e("Payment Params: ", new Gson().toJson(params));
        return params;
    }

    private void createPaymentIntent() {
        LogUtils.e("INTENT CREATE KARO BHAI");
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                progressDialog.show();
                llPlaceOrder.setEnabled(false);
            });
        }
        AndroidNetworking.post(payment_intent)
                .addBodyParameter(generatePaymentIntentParams())
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        LogUtils.e(new Gson().toJson(response));
                        try {
                            String paymentSecret = response.getString("payment_intent_id");
                            performStripePayment(paymentSecret);
                        } catch (JSONException e) {
                            e.printStackTrace();
                            ToastUtils.makeSnackToast(getActivity(), "Something went wrong!");
                        }

                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("GENERATE PAYMENT INTENT ERROR" + anError.getErrorBody());
                        ToastUtils.makeSnackToast(getActivity(), "Something went wrong!");
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                progressDialog.dismiss();
                                llPlaceOrder.setEnabled(true);
                            });
                        }

                        if (!CommonFunctions.isConnected(getActivity())) {
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                        }
                    }
                });
    }

    private Stripe stripe;
    private String transactionId;

    private void performStripePayment(String paymentSecret) {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> progressDialog.show());
        }
        ConfirmPaymentIntentParams confirmParams = ConfirmPaymentIntentParams
                .createWithPaymentMethodId(paymentMethod.stripe_token_id, paymentSecret);
        if (restaurant.business.connect_service) {
            stripe = new Stripe(getContext(), restaurant.business.connect_stripe_public_key);
        } else {
            stripe = new Stripe(getContext(), myApp.getStripePublishKey());
        }

        stripe.confirmPayment(this, confirmParams);
    }

    private boolean isValidOrder() {
        if (multiplePriceOfferApplied && !multiplPriceOfferApplicable && appliedPriceOffer != null) {
            int checkedQty = 0;
            for (OfferProduct offerProduct : appliedPriceOffer.getProducts()) {
                checkedQty = checkedQty + offerProduct.quantity;
            }
            if (checkedQty != appliedPriceOffer.offer_qty) {
                llSelectProducts.performClick();
                return false;
            }
        }
        return true;
    }

    @SuppressLint("DefaultLocale")
    private void updateViews() {
        if (loggedInUser != null) {
            tvAddressUsername.setText(String.format("%s %s", loggedInUser.first_name, loggedInUser.last_name));
        }
        tvTableNumber.setText(String.format("Table #%s", tableNumber));
        if (totalGuests > 1) {
            tvNumberOfGuests.setText(String.format("%d Guest", totalGuests));
        } else {
            tvNumberOfGuests.setText(String.format("%d Guests", totalGuests));
        }
        rb1.setText(currency + "1.00");
        rb2.setText(currency + "2.00");
    }

    private void firstMethod() {
        new Handler().postDelayed(() -> {
            if (loggedInUser == null) {
                startActivity(new Intent(getActivity(), AuthActivity.class));
                getActivity().finish();
            } else {
                fetchDineInRestaurant();

            }
        }, 100);

    }


    private void fetchDineInRestaurant() {
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> {
                llLoading.setVisibility(View.VISIBLE);
                llData.setVisibility(View.GONE);
            });
        AndroidNetworking.get(ApiEndPoints.business_restaurant_detail_dinein)
                .addQueryParameter("customer_id", String.valueOf(loggedInUser.id))
                .addQueryParameter("qr_code", qrCode)
                .addQueryParameter("table_id", (!Validators.isNullOrEmpty(tableNumber) ? tableNumber : ""))
                .addHeaders("business-id", business_id)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        restaurant = new Gson().fromJson(response.toString(), BusinessRestaurant.class);
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                llLoading.setVisibility(View.GONE);
                                llData.setVisibility(View.VISIBLE);
                                checkIsDineinOpenAndContinue();
                            });
                        }
/*
                        if (createdOrder != null) {
                            fetchCreatedOrder();
                        }
*/

                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                llLoading.setVisibility(View.GONE);
                                llData.setVisibility(View.VISIBLE);
                            });
                        }

                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }

    private void checkIsDineinOpenAndContinue() {
        if (restaurant.dine_in) {
            continueCheckoutScreen();
        } else {
            //ToDo show not providing dinein
        }

    }

    private void continueCheckoutScreen() {
        setUpAdapters(true);
        setDynamicVisibility();
        fetchCartSummary();
        displayPaymentMethod();
    }

    private void applyPromocode() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                progressDialog.show();
                CommonFunctions.hideKeyboard(getActivity(), etPromocode);
            });
        }
        ApiUtils.applyDineinPromoCode(restaurant.business.id, "", String.valueOf(restaurant.id), etPromocode.getText().toString())
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        appliedVoucher = new Gson().fromJson(response.toString(), RestaurantVoucher.class);
                        validateVoucher(true);
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                etPromocode.setText("");
                                progressDialog.dismiss();
                            });
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("APPLY PROMO ANERROR");
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                progressDialog.dismiss();
                                etPromocode.setText("");
                            });
                        }

                    }
                });
    }


    private void showEmptyCartUi() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                llData.setVisibility(View.GONE);
                llLoading.setVisibility(View.GONE);
                rlNoData.setVisibility(View.VISIBLE);
            });
        }
    }

    private void setDynamicVisibility() {
        if (myApp.getMyPreferences().getSiteSettings().charity_amount > 0) {
            tvCharityAmount.setText(currency + MyApp.df.format(myApp.getMyPreferences().getSiteSettings().charity_amount));
            cbCharity.setText(myApp.getMyPreferences().getSiteSettings().charity_message);
            llCharity.setVisibility(View.VISIBLE);
        } else {
            llCharity.setVisibility(View.GONE);
        }
        if (restaurant.gratuity) {
            llTip.setVisibility(View.VISIBLE);
        } else {
            llTip.setVisibility(View.GONE);
        }
    }

    private void displayPaymentMethod() {
        Glide.with(getActivity())
                .load(restaurant.restaurant_logo)
                .placeholder(R.drawable.restaurant_logo_placeholder)
                .error(R.drawable.restaurant_logo_placeholder)
                .into(ivRestaurantLogo);
        paymentMethod = myApp.getMyPreferences().getDefaultPaymentMethod();
        if (paymentMethod != null) {
            if (!Validators.isNullOrEmpty(restaurant.wallet_payment)) {
                boolean canBeAdd = false;
                if (restaurant.dinein_wallet_payment.equalsIgnoreCase("yes")) {
                    canBeAdd = true;
                }
                if (canBeAdd && (paymentMethod.type.equalsIgnoreCase("wallet") || canBeAdd && paymentMethod.type.equalsIgnoreCase("credit"))) {
                    displayDefaultPayment();
                    return;
                } else {
                    displaySelectPaymentMethod();
                }
            }
            for (PaymentMethod restaurantPaymentMethod : restaurant.payment_methods) {
                if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("cod")) {
                    boolean canBeAdd = false;
                    if (restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd && paymentMethod.type.equalsIgnoreCase("cod")) {
                        displayDefaultPayment();
                        return;
                    } else {
                        displaySelectPaymentMethod();
                    }
                } else if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("stripe")) {
                    boolean canBeAdd = false;
                    if (restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd && paymentMethod.type.equalsIgnoreCase("stripe")) {
                        displayDefaultPayment();
                        return;
                    } else {
                        displaySelectPaymentMethod();
                    }
                } else if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("paypal")) {
                    boolean canBeAdd = false;
                    if (restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd && paymentMethod.type.equalsIgnoreCase("paypal")) {
                        displayDefaultPayment();
                        return;
                    } else {
                        displaySelectPaymentMethod();
                    }
                }

            }
        } else {
            displaySelectPaymentMethod();
        }
    }

    private void displaySelectPaymentMethod() {
        ivPaymentMethod.setVisibility(View.GONE);
        tvPaymentMethodName.setText(null);
        tvPaymentMethodName.setHint("Please select payment method");
    }

    private void displayDefaultPayment() {
        ivPaymentMethod.setVisibility(View.VISIBLE);
        tvPaymentMethodName.setHint(null);
        int logo = myApp.paymentMethodLogo(paymentMethod);
        if (logo != -1) {
            ivPaymentMethod.setImageResource(logo);
            ivPaymentMethod.setVisibility(View.VISIBLE);
        } else {
            ivPaymentMethod.setVisibility(View.GONE);
        }
        tvPaymentMethodName.setText(paymentMethod.title);
    }


    private void setUpAdapters(boolean fetchCartSummary) {
        llData.setVisibility(View.VISIBLE);
        new Thread(() -> {
            feed.clear();
            cartItems.clear();
            orderItemAddons.clear();
            orderItemIngredients.clear();
            cartItems.addAll(myApp.getAppDatabase().dineinCartItemDao().getAll());

            if (cartItems.size() == 0) {
                showEmptyCartUi();
            } else {
                feed.addAll(cartItems);
                // setUpCartArray();
            }
            fetchCartSummary();
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> {
                    animationCartItemLoading.setVisibility(View.GONE);
                    cartBasketItemsAdapter.notifyDataSetChanged();
                });
            }
        }).start();

    }

//    private void setUpCartArray() {
//        cartArray.clear();
//        if (cartItems != null && cartItems.size() > 0) {
//            for (DineinCartItem cartItem : cartItems) {
//                Cart cart = new Cart();
//                // cart.customer_id = String.valueOf(loggedInUser.id);
//                cart.restaurant_id = String.valueOf(cartItem.res_id);
//                cart.menu_id = String.valueOf(cartItem.menu_id);
//                cart.menu_name = cartItem.menu_name;
//                cart.menu_price = String.valueOf(cartItem.Menu_price);
//                cart.total_price = String.valueOf(cartItem.Total);
//                cart.quantity = String.valueOf(cartItem.quantity);
//                cart.menu_description = cartItem.instruction;
//                cart.subaddons_name = cartItem.Addon_name;
//                cartArray.add(cart);
//
//            }
//            LogUtils.e("dine in cartArray:" + new Gson().toJson(cartArray));
//        }
//    }

    private void addItemToCart(Menu menuItem, int position) {
        new Thread(() -> {
            String variantName = null;
            float discount = 0;
            if (menuItem.variants != null && menuItem.variants.size() > 0) {
                variantName = menuItem.variants.get(0).sub_name;
                discount = menuItem.variants.get(0).orginal_price * menuItem.getProductPercentage() / 100;
            }
            DineinCartItem dbDineInCartItem = myApp.getAppDatabase().dineinCartItemDao().getCartMenuItem(menuItem.id, variantName);
            if (dbDineInCartItem == null) {
                DineinCartItem cartItem = new DineinCartItem();
                if (menuItem.variants != null && menuItem.variants.size() > 0) {
                    Variant selectedVariant = menuItem.variants.get(0);
                    cartItem.quantity = 1;
                    cartItem.Menu_price = selectedVariant.orginal_price - discount;
                    cartItem.menu_id = selectedVariant.menu_id;
                    cartItem.id = selectedVariant.id;
                    cartItem.menu_name = menuItem.menu_name;
                    cartItem.menu_size = selectedVariant.sub_name;
                    cartItem.res_id = menuItem.restaurant_id;
                    cartItem.menu_type = menuItem.menu_type;

                    cartItem.Addon_name = "";
                    cartItem.Addon_price = 0;
                    cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                    myApp.getAppDatabase().dineinCartItemDao().insertAll(cartItem);
                    if (getActivity() != null)
                        getActivity().runOnUiThread(() -> setUpAdapters(false));
                }
            } else {
                if (menuItem.variants != null && menuItem.variants.size() > 0) {
                    Variant selectedVariant = menuItem.variants.get(0);
                    dbDineInCartItem.quantity++;
                    dbDineInCartItem.Menu_price = +(selectedVariant.orginal_price - discount);
                    dbDineInCartItem.Total = dbDineInCartItem.quantity * (dbDineInCartItem.Menu_price + dbDineInCartItem.Addon_price);
                    myApp.getAppDatabase().dineinCartItemDao().update(dbDineInCartItem);
                }

            }
            if (getActivity() != null) {
                getActivity().runOnUiThread(this::fetchCartSummary);
            }
        }).start();
    }

    private void incrementQuantity(int i, Object o) {
        try {
            DineinCartItem cartItem = (DineinCartItem) o;
            new Thread(() -> {
                DineinCartItem c = MyApp.getInstance().getAppDatabase().dineinCartItemDao().getDineinCartItemFromOrderItemId(cartItem.id);

                boolean removed = false;
                if (c == null) {
                    ToastUtils.makeToast(getActivity(), "Item already removed");
                    removed = true;
                } else {
                    cartItem.quantity++;
                    cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                    MyApp.getInstance().getAppDatabase().dineinCartItemDao().update(cartItem);
                }

                if (getActivity() != null) {
                    boolean finalRemoved = removed;
                    getActivity().runOnUiThread(() -> {
                        if (finalRemoved) {
                            feed.remove(i);
                            cartBasketItemsAdapter.notifyItemRemoved(i);
                            if (feed.size() == 0) {
                                ToastUtils.makeToast(getActivity(), "Cart is empty");
                                showEmptyCartUi();
                            }
                        }
                        fetchCartSummary();

                        if (createdOrder != null) {
                            TIME_TO_WAIT = 20000;
                            handler.removeCallbacks(runnable);
                            // handler.postDelayed(runnable, TIME_TO_WAIT);
                            //handler.removeCallbacks(runnable);
                            if (countDownTimer != null) {
                                countDownTimer.cancel();
                            }

                            startTimer();
                        }


                    });
                }
            }).start();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void decrementQuantity(int i, Object o) {
        try {
            DineinCartItem cartItem = (DineinCartItem) o;
            new Thread(() -> {
                DineinCartItem c = MyApp.getInstance().getAppDatabase().dineinCartItemDao().getDineinCartItemFromOrderItemId(cartItem.id);

                boolean removed = false;
                if (c == null) {
                    ToastUtils.makeToast(getActivity(), "Item already removed");
                    removed = true;
                } else {
                    if (cartItem.quantity <= 1) {
                        MyApp.getInstance().getAppDatabase().dineinCartItemDao().delete(cartItem);
                        ToastUtils.makeToast(getActivity(), "Item removed");
                        removed = true;
                    } else {
                        cartItem.quantity--;
                        cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                        MyApp.getInstance().getAppDatabase().dineinCartItemDao().update(cartItem);
                    }
                }
                if (getActivity() != null) {
                    boolean finalRemoved = removed;
                    getActivity().runOnUiThread(() -> {
                        if (finalRemoved) {
                            setUpAdapters(false);
                        }
                        fetchCartSummary();
                        if (createdOrder != null) {
                            TIME_TO_WAIT = 20000;
                            handler.removeCallbacks(runnable);
                            // handler.postDelayed(runnable, TIME_TO_WAIT);
                            //handler.removeCallbacks(runnable);
                            if (countDownTimer != null) {
                                countDownTimer.cancel();
                            }

                            startTimer();
                        }
                    });
                }
            }).start();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void fetchCartSummary() {
        new Thread(() -> {
            cartSummary = myApp.getAppDatabase().dineinCartItemDao().getCartSummary();
            cartSubtotal = cartSummary.total;

            validateVoucher(false);
            LogUtils.e("fetch cart summary!!");
        }).start();
    }

    private void validateVoucher(boolean showToast) {
        String message = "";
        if (appliedVoucher != null) {
            voucherDiscount = 0;
            if ((!appliedVoucher.dinein_type.equalsIgnoreCase("true") || !appliedVoucher.dinein_type.equalsIgnoreCase("1"))) {
                message = "Promo code is not application for dine-in orders";
            } else {
                if (appliedVoucher.minimum_value <= cartSubtotal) {

                    if (appliedVoucher.offer_mode.equalsIgnoreCase("price")) {
                        voucherApplied = true;
                        message = "Promo code applied successfully";
                        voucherDiscount = appliedVoucher.offer_value;
                        updateCartTotal();
                    } else if (appliedVoucher.offer_mode.equalsIgnoreCase("percentage")) {
                        voucherApplied = true;
                        voucherDiscount = cartTotal * (appliedVoucher.offer_value / 100);
                        message = "Promo code applied successfully";
                        updateCartTotal();
                    } else {
                        voucherDiscount = 0;
                        cartDeliveryFee = 0;
                        updateCartTotal();
                        message = "Promo code could not applied";
                        voucherApplied = false;
                    }
                } else {
                    message = "Minimum order value is " + currency + appliedVoucher.minimum_value;
                    appliedVoucher = null;
                    voucherApplied = false;
                    updateCartTotal();
                }
            }
        } else {
            LogUtils.e("PROMOCODE IS NULL");
            voucherApplied = false;
            voucherDiscount = 0;
            updateCartTotal();
        }
        if (showToast) {
            ToastUtils.makeToast(getActivity(), message);
        }
    }

    private void updateCartTotal() {
        cartCalculations();
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                if (cartServiceFee > 0) {
                    llServiceCharge.setVisibility(View.VISIBLE);
                } else {
                    llServiceCharge.setVisibility(View.GONE);
                }
                if (cartDiscount > 0) {
                    llDiscount.setVisibility(View.VISIBLE);
                    tvDiscount.setText("-" + currency + MyApp.df.format(cartDiscount));
                    if (voucherApplied) {
                        tvDiscountTitle.setText(String.format("Voucher Discount (%s%%)", (appliedVoucher.offer_mode.equals("percentage") ? String.valueOf(appliedVoucher.offer_value) : "")));
                    } else {
                        tvDiscountTitle.setText(String.format("Discount", offerPercentage));
                    }
                } else {
                    llDiscount.setVisibility(View.GONE);
                    tvDiscount.setText(currency + MyApp.df.format(cartDiscount));
                }

                tvSubTotal.setText(currency + MyApp.df.format(cartSubtotal));
                tvServicesFee.setText(currency + MyApp.df.format(cartServiceFee));
                tvTotal.setText(currency + MyApp.df.format(cartTotal));
                tvOrderTotal.setText("Total: " + currency + MyApp.df.format(getCartTotal()));
                if (voucherApplied) {
                    etPromocode.setEnabled(false);
                    btnPromoApply.setBackground(ContextCompat.getDrawable(getActivity(), R.drawable.rounded_button_red_filled));
                    btnPromoApply.setTextColor(ContextCompat.getColor(getActivity(), R.color.white));
                    btnPromoApply.setText("Remove");
                    etPromocode.setHint(appliedVoucher.voucher_code);
                    if (isValidOrder() && appliedVoucher != null && cartDiscount > 0) {
                        payOrder("5", String.valueOf(cartDiscount));
                    }
                } else {
                    etPromocode.setEnabled(true);
                    etPromocode.setText("");
                    btnPromoApply.setBackground(ContextCompat.getDrawable(getActivity(), R.drawable.rounded_button_white_filled));
                    btnPromoApply.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
                    btnPromoApply.setText("Apply");
                    etPromocode.setHint("Promo code... ");
                }
            });
        }

    }

    private void cartCalculations() {
//        if (!restaurant.dinein_service_charge_type) {
//            // charges in percentage
//            cartServiceFee = cartSubtotal * (restaurant.dinein_service_charge / 100);
//        } else {
//            // flat charges
//            cartServiceFee = restaurant.dinein_service_charge;
//        }
        if (!voucherApplied) {
            new ApplyOfferAsync(() -> {
                feed.addAll(freeItems);
                updateDiscountAndService();
                cartBasketItemsAdapter.notifyDataSetChanged();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        } else {
            offerApplied = true;
            multiplePriceOfferApplied = true;
            multiplPriceOfferApplicable = false;

            new RemoveFreeItemAsync(() -> {
                if (getActivity() != null)
                    getActivity().runOnUiThread(() -> {
                        llSelectProducts.setVisibility(View.GONE);
                    });
                cartOffer = 0;
                etPromocode.setHint("Promo code applied");
                updateDiscountAndService();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);

        }

    }

    private void updateDiscountAndService() {
        if (serviceChargeEnabled) {
            if (serviceChargeAutoMode) {
                float serviceChargeValue = Float.parseFloat(serviceChargeSetting.value);
                if (serviceChargeTypeSetting.value.equalsIgnoreCase("flat")) {
                    cartServiceFee = serviceChargeValue;
                } else {
                    if (serviceChargeValue > 0) {
                        cartServiceFee = cartSubtotal * serviceChargeValue / 100;
                    } else {
                        cartServiceFee = 0;
                    }
                }
            }
        } else {
            cartServiceFee = 0;
        }
        fetchAutoDiscount();
    }

    private void showCalculatedAmountsAndMoveNext() {
        //   cartDiscount = voucherDiscount + cartOffer;//may be this should change
        cartTotal = cartSubtotal + cartServiceFee + cartGratuity - cartDiscount + cartCharity;
        if (loggedInUser.wallet_amount < cartTotal && paymentMethod != null && (paymentMethod.type.equalsIgnoreCase("credit") || paymentMethod.type.equalsIgnoreCase("wallet"))) {
            paymentMethod = null;
        }
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                if (cartServiceFee > 0) {
                    llServiceCharge.setVisibility(View.VISIBLE);
                } else {
                    llServiceCharge.setVisibility(View.GONE);
                }
                if (cartDiscount > 0) {
                    llDiscount.setVisibility(View.VISIBLE);
                    tvDiscount.setText("-" + currency + MyApp.df.format(cartDiscount));
                    if (voucherApplied) {
                        tvDiscountTitle.setText(String.format("Voucher Discount (%s%%)", (appliedVoucher.offer_mode.equals("percentage") ? String.valueOf(appliedVoucher.offer_value) : "")));
                    } else {
                        tvDiscountTitle.setText(String.format("Discount", offerPercentage));
                    }
                } else {
                    llDiscount.setVisibility(View.GONE);
                    tvDiscount.setText(currency + MyApp.df.format(cartDiscount));
                }
                if (cartCharity > 0 && cbCharity.isChecked()) {
                    llCharityTitle.setVisibility(View.VISIBLE);
                    tvCharityMessageTitle.setText(cbCharity.getText().toString());
                    tvCharityAmountTitle.setText(currency + MyApp.df.format(cartCharity));

                } else {
                    llCharityTitle.setVisibility(View.GONE);
                }

                if (cartGratuity > 0) {
                    llTipTitle.setVisibility(View.VISIBLE);
                    tvTipAmount.setText(currency + MyApp.df.format(cartGratuity));
                } else
                    llTipTitle.setVisibility(View.GONE);
                tvSubTotal.setText(currency + MyApp.df.format(cartSubtotal));
                tvServicesFee.setText(currency + MyApp.df.format(cartServiceFee));
                tvTotal.setText(currency + MyApp.df.format(cartTotal));
                if (cartTotal > 0) {
                    llPlaceOrder.setVisibility(View.VISIBLE);
                } else {
                    llPlaceOrder.setVisibility(View.GONE);
                }
                tvOrderTotal.setText("Total: " + currency + MyApp.df.format(getCartTotal()));
                if (voucherApplied) {
                    etPromocode.setEnabled(false);
                    btnPromoApply.setBackground(ContextCompat.getDrawable(getActivity(), R.drawable.rounded_button_red_filled));
                    btnPromoApply.setTextColor(ContextCompat.getColor(getActivity(), R.color.white));
                    btnPromoApply.setText("Remove");
                    etPromocode.setHint(appliedVoucher.voucher_code);
                } else {
                    etPromocode.setEnabled(true);
                    etPromocode.setText("");
                    btnPromoApply.setBackground(ContextCompat.getDrawable(getActivity(), R.drawable.rounded_button_white_filled));
                    btnPromoApply.setTextColor(ContextCompat.getColor(getActivity(), R.color.black));
                    btnPromoApply.setText("Apply");
                    etPromocode.setHint("Promo code... ");
                }
            });
        }

        validatePaymentMethod();
    }

    private boolean offerApplied = false;
    private boolean multiplePriceOfferApplied = false, multiplPriceOfferApplicable;
    private MultiplePriceOffer appliedPriceOffer;

    private class ApplyOfferAsync extends AsyncTask<String, String, String> {
        Callable<Void> nextThing;

        public ApplyOfferAsync(Callable<Void> nextThing) {
            this.nextThing = nextThing;
        }

        @Override
        protected String doInBackground(String... strings) {
            cartOffer = 0;
            if (offerApplied) {
                freeItems.clear();
                Iterator<Object> iterator = feed.iterator();
                while (iterator.hasNext()) {
                    Object object = iterator.next();
                    if (object instanceof DineinCartItem) {
                        DineinCartItem c = (DineinCartItem) object;
                        if (c.Addon_name.equalsIgnoreCase("offer")) {
                            iterator.remove();
                        }
                    }
                }
                offerApplied = false;
            }
            SimpleDateFormat sdf = new SimpleDateFormat("EEEE");
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date d = new Date();
            String dayOfTheWeek = sdf.format(d);
            Date today = null;
            try {
                today = dateFormat.parse(dateFormat.format(new Date()));
            } catch (ParseException e) {
                e.printStackTrace();
            }
            if (restaurant.multiple_price_offers != null && restaurant.multiple_price_offers.size() > 0) {
                multiplePriceOfferApplied = false;
                for (MultiplePriceOffer multiplePriceOffer : restaurant.multiple_price_offers) {
                    boolean canApply = false;
                    if (multiplePriceOffer.dinein_type) {
                        canApply = true;
                    }
                    if (canApply && cartSubtotal > multiplePriceOffer.purchase_price) {
                        offerApplied = true;
                        multiplePriceOfferApplied = true;
                        multiplPriceOfferApplicable = false;
                        if (appliedPriceOffer == null) {
                            appliedPriceOffer = multiplePriceOffer;
                        } else {
                            if (!appliedPriceOffer.id.equalsIgnoreCase(multiplePriceOffer.id)) {
                                appliedPriceOffer = multiplePriceOffer;
                            }
                        }
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                ivSelectProducts.setVisibility(View.VISIBLE);
                                llSelectProducts.setVisibility(View.VISIBLE);
                                tvSelectProducts.setText("Claim free product(s)");
                                llSelectProducts.setEnabled(true);
                            });
                        offerAmount = 0;
                        offerPercentage = 0;
                        cartOffer = 0;

                        ArrayList<OfferProduct> products = appliedPriceOffer.getProducts();
                        for (OfferProduct offerProduct : products) {
                            if (offerProduct.checked && offerProduct.quantity > 0) {
                                DineinCartItem toBeSave = new DineinCartItem();
                                toBeSave.Menu_price = 0;
                                toBeSave.menu_id = 0;
                                toBeSave.id = 0;
                                toBeSave.menu_name = offerProduct.name;
                                toBeSave.menu_size = "";
                                toBeSave.res_id = restaurant.id;
                                toBeSave.menu_type = "";
                                toBeSave.quantity = offerProduct.quantity;
                                toBeSave.Addon_name = "Offer";
                                toBeSave.Addon_price = 0;
                                toBeSave.Total = 0;
                                freeItems.add(toBeSave);
                            }
                        }

                        return null;
                    }
                    if (canApply) {
                        offerApplied = true;
                        multiplePriceOfferApplied = true;
                        multiplPriceOfferApplicable = true;
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                llSelectProducts.setVisibility(View.VISIBLE);
                                ivSelectProducts.setVisibility(View.INVISIBLE);
                                tvSelectProducts.setText(String.format("Spend %s%s to claim free product(s)", myApp.getCurrencySymbol(), MyApp.df.format(multiplePriceOffer.purchase_price)));
                                llSelectProducts.setEnabled(false);
                            });

                        return null;
                    }
                }
            }
            multiplePriceOfferApplied = false;
            appliedPriceOffer = null;
            llSelectProducts.setVisibility(View.GONE);
            llSelectProducts.setEnabled(false);
            // Set up day offers
            if (restaurant.day_offers != null)
                for (DayOffer offer : restaurant.day_offers) {

                    if (!dayOfTheWeek.equalsIgnoreCase(offer.day)) {
                        break;
                    }
                    if (!offer.status) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    offerTitle.append("Earn ");
                    if (offer.day_offer_type.equalsIgnoreCase("1")) {
                        offerTitle.append(offer.offer_amount).append("%");
                    } else {
                        offerTitle.append("Flat ").append(myApp.getCurrencySymbol()).append(offer.offer_amount);
                    }
                    offerTitle.append(" OFF on your next purchase");
                    boolean canApply = false;
                    if (cartSubtotal >= offer.purchase_price) {
                        if (offer.dinein_type) {
                            canApply = true;
                        }

                    }

                    if (canApply) {
                        offerApplied = true;
                        if (offer.day_offer_type.equalsIgnoreCase("1")) {
                            cartOffer = cartSubtotal * offer.offer_amount / 100;
                            offerPercentage = offer.offer_amount;
                        } else {
                            cartOffer = offer.offer_amount;
                            offerAmount = offer.offer_amount;
                        }

                        return null;
                    }

                }

            if (restaurant.day_product_offers != null)
                for (DayProductOffer offer : restaurant.day_product_offers) {

                    if (!dayOfTheWeek.equalsIgnoreCase(offer.day_product)) {
                        break;
                    }
                    if (!offer.status) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(offer.product_qty).append(" ").append(findMenuItemById(offer.menu_id).menu_name);
                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);
                    DineinCartItem cartItem = findDineInItemByMenuId(offer.menu_id);
                    if (cartItem != null) {
                        if (cartItem.quantity >= offer.product_qty) {
                            if (offer.dinein_type) {
                                canApply = true;
                            }

                        }
                    }
                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {

                            Variant selectedVariant = freeItem.variants.get(0);
                            DineinCartItem toBeSave = new DineinCartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;
                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            offerApplied = true;
                            offerAmount = 0;
                            offerPercentage = 0;
                            cartOffer = 0;
                        }
                        return null;
                    }
                }
            if (restaurant.day_price_offers != null)
                for (DayPriceOffer offer : restaurant.day_price_offers) {

                    if (!dayOfTheWeek.equalsIgnoreCase(offer.day)) {
                        break;
                    }
                    if (!offer.status) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.purchase_price));
                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);

                    if (cartSubtotal >= offer.purchase_price) {
                        if (offer.dinein_type) {
                            canApply = true;
                        }

                    }
                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                            Variant selectedVariant = freeItem.variants.get(0);
                            DineinCartItem toBeSave = new DineinCartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;
                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            offerAmount = 0;
                            offerPercentage = 0;
                            cartOffer = 0;
                            offerApplied = true;
                        }
                        return null;
                    }
                }

            if (restaurant.offers != null)
                for (Offer offer : restaurant.offers) {
                    Date startDate = null, endDate = null;
                    try {
                        startDate = dateFormat.parse(offer.offer_from);
                        endDate = dateFormat.parse(offer.offer_to);

                        if (today.after(endDate)) break;
                        if (today.before(startDate)) break;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    boolean canApply = false;

                    if (loggedInUser.first_user != null && loggedInUser.first_user.equalsIgnoreCase("yes")) {
                        if (offer.first_user.equalsIgnoreCase("y")) {
                            offerTitle.append("Get ").append(MyApp.df.format(offer.free_percentage)).append("%").append(" OFF ").append(" on your next purchase");
                            offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.free_price));
                            if (cartSubtotal >= offer.free_price) {
                                if (offer.dinein_type) {
                                    canApply = true;
                                }
                            }
                            if (canApply) {
                                cartOffer = cartSubtotal * (offer.free_percentage / 100);
                                offerPercentage = (offer.free_percentage);
                                offerAmount = 0;
                                offerApplied = true;
                                return null;
                            }

                        }
                    } else {
                        if (offer.normal.equalsIgnoreCase("y")) {
                            offerTitle.append("Get ").append(MyApp.df.format(offer.normal_percentage)).append("%").append(" OFF ").append(" on your next purchase");
                            offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.normal_price));
                            if (cartSubtotal >= offer.normal_price) {
                                if (offer.dinein_type) {
                                    canApply = true;
                                }

                            }
                            if (canApply) {
                                offerApplied = true;
                                cartOffer = cartSubtotal * (offer.normal_percentage / 100);
                                offerPercentage = (offer.free_percentage);
                                offerAmount = 0;
                                return null;
                            }


                        }
                    }

                }

            if (restaurant.product_offers != null)
                for (ProductOffer offer : restaurant.product_offers) {
                    Date startDate = null, endDate = null;
                    try {
                        startDate = dateFormat.parse(offer.offer_from);
                        endDate = dateFormat.parse(offer.offer_to);

                        if (today.after(endDate)) break;
                        if (today.before(startDate)) break;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }

                    if (!offer.status) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(offer.product_qty).append(" ").append(findMenuItemById(offer.menu_id).menu_name);
                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);
                    DineinCartItem cartItem = findDineInItemByMenuId(offer.menu_id);

                    if (cartItem != null) {
                        if (cartItem.quantity >= offer.product_qty) {
                            if (offer.dinein_type) {
                                canApply = true;
                            }

                        }
                    }

                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {
                            Variant selectedVariant = freeItem.variants.get(0);
                            DineinCartItem toBeSave = new DineinCartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;

                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            cartOffer = 0;
                            offerAmount = 0;
                            offerPercentage = 0;
                            offerApplied = true;
                        }
                        return null;
                    }

                }
            if (restaurant.price_offers != null)
                for (PriceOffer offer : restaurant.price_offers) {
                    Date startDate = null, endDate = null;
                    try {
                        startDate = dateFormat.parse(offer.offer_from);
                        endDate = dateFormat.parse(offer.offer_to);

                        if (today.after(endDate)) break;
                        if (today.before(startDate)) break;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                    if (!offer.status) {
                        break;
                    }
                    StringBuilder offerTitle = new StringBuilder();
                    StringBuilder offerSubTitle = new StringBuilder();
                    offerTitle.append("Get ").append(offer.offer_qty).append(" FREE ").append(findMenuItemById(offer.offer_id).menu_name);

                    offerSubTitle.append("Offer applicable on minimum purchase of ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(offer.purchase_price));
                    boolean canApply = false;
                    Menu freeItem = findMenuItemById(offer.offer_id);

                    if (cartSubtotal >= offer.purchase_price) {
                        if (offer.dinein_type) {
                            canApply = true;
                        }

                    }
                    if (canApply) {
                        if (freeItem != null && freeItem.variants != null && freeItem.variants.size() > 0) {

                            Variant selectedVariant = freeItem.variants.get(0);
                            DineinCartItem toBeSave = new DineinCartItem();
                            toBeSave.Menu_price = 0;
                            toBeSave.menu_id = selectedVariant.menu_id;
                            toBeSave.id = selectedVariant.id;
                            toBeSave.menu_name = freeItem.menu_name;
                            toBeSave.menu_size = selectedVariant.sub_name;
                            toBeSave.res_id = freeItem.restaurant_id;
                            toBeSave.menu_type = freeItem.menu_type;
                            toBeSave.quantity = offer.offer_qty;
                            toBeSave.Addon_name = "Offer";
                            toBeSave.Addon_price = 0;
                            toBeSave.Total = 0;
                            freeItems.add(toBeSave);
                            cartOffer = 0;
                            offerAmount = 0;
                            offerPercentage = 0;
                            offerApplied = true;
                        }
                        return null;
                    }
                }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (nextThing != null) {
                try {
                    nextThing.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

        }
    }

    private class RemoveFreeItemAsync extends AsyncTask<String, String, String> {
        Callable<Void> nextThing;

        public RemoveFreeItemAsync(Callable<Void> nextThing) {
            this.nextThing = nextThing;
        }

        @Override
        protected String doInBackground(String... strings) {
            freeItems.clear();
            Iterator<Object> iterator = feed.iterator();
            while (iterator.hasNext()) {
                Object object = iterator.next();
                if (object instanceof DineinCartItem) {
                    DineinCartItem c = (DineinCartItem) object;
                    if (c.Addon_name.equalsIgnoreCase("offer")) {
                        iterator.remove();
                    }
                }

            }
            offerApplied = false;
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (nextThing != null) {
                try {
                    nextThing.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }


    private Menu findMenuItemById(int id) {
        if (id != -1) {
            Menu toBeFineMenu = new Menu();
            toBeFineMenu.id = id;
            if (restaurant_menu != null && restaurant_menu.size() > 0) {
                int menuIndex = restaurant_menu.indexOf(toBeFineMenu);
                if (menuIndex != -1) {
                    return restaurant_menu.get(menuIndex);
                } else {
                    return null;
                }
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    private DineinCartItem findDineInItemByMenuId(int id) {
        if (id != -1) {
            DineinCartItem toBeFineMenu = new DineinCartItem();
            toBeFineMenu.menu_id = id;
            int menuIndex = cartItems.indexOf(toBeFineMenu);
            if (menuIndex != -1) {
                return cartItems.get(menuIndex);
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    private float customerTipAmount = 0;

    private void showEditGratuity() {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View dialogView = inflater.inflate(R.layout.dialog_edit_fund, null);

        TextView tvHeading = dialogView.findViewById(R.id.tvHeading);
        TextView tvInfo = dialogView.findViewById(R.id.tvInfo);
        TextView tvCancel = dialogView.findViewById(R.id.tvCancel);
        TextView tvConfirm = dialogView.findViewById(R.id.tvConfirm);
        EditText etAmount = dialogView.findViewById(R.id.etFundAmount);
        etAmount.addTextChangedListener(new MoneyTextWatcher(etAmount));
        tvHeading.setText("Leave a gratuity");
        tvInfo.setVisibility(View.GONE);

        etAmount.setHint("Enter gratuity amount");
        if (customerTipAmount > 0) {
            etAmount.setText(String.valueOf(customerTipAmount));
            etAmount.setSelection(etAmount.getText().toString().length());
        }
        tvConfirm.setOnClickListener(view -> {
            if (!etAmount.getText().toString().isEmpty() && Float.parseFloat(etAmount.getText().toString()) > 0) {
                CommonFunctions.hideKeyboard(getActivity(), etAmount);
                customerTipAmount = Float.parseFloat(etAmount.getText().toString());
                cartGratuity = customerTipAmount;
                rbCustom.setText(myApp.getCurrencySymbol() + MyApp.df.format(customerTipAmount));
                rbCustom.setChecked(true);
                rbCustom.setVisibility(View.VISIBLE);
                alertDialog.dismiss();
                updateCartTotal();
            } else {
                ToastUtils.makeToast(getActivity(), "Please enter valid amount");
            }
        });
        tvCancel.setOnClickListener(view -> {
            if (cartGratuity == 0) {
                rbNo.setChecked(true);
            } else if (cartGratuity == 1) {
                rb1.setChecked(true);
            } else if (cartGratuity == 2) {
                rb2.setChecked(true);
            } else if (customerTipAmount > 0) {
                rbCustom.setChecked(true);
            }
            alertDialog.dismiss();
        });
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();
    }

    private void placeOrderData() {
        Bundle formBody = new Bundle();

        formBody.putBoolean("dineIn", true);
        formBody.putString("restaurant", new Gson().toJson(restaurant));
        formBody.putString("wallet_payment", restaurant.wallet_payment);
        formBody.putString("dinein_wallet_payment", restaurant.dinein_wallet_payment);
        formBody.putString("restaurant_payment_methods", new Gson().toJson(restaurant.payment_methods));
        formBody.putString("wallet_payment", restaurant.wallet_payment);
        formBody.putString("customer_id", String.valueOf(loggedInUser.id));
        formBody.putString("restaurant_id", String.valueOf(restaurant.id));
        formBody.putString("customer_email", loggedInUser.username);
        formBody.putString("customer_phone", loggedInUser.phone_number);
        formBody.putString("customer_name", loggedInUser.first_name + " " + loggedInUser.last_name);

        formBody.putString("source_latitude", restaurant.sourcelatitude);
        formBody.putString("source_longitude", restaurant.sourcelongitude);

        formBody.putString("destination_latitude", "");
        formBody.putString("destination_longitude", "");
        formBody.putString("flat_no", "");
        formBody.putString("address", "");


        formBody.putString("order_type", "dinein");
        formBody.putString("delivery_charge", "");
        formBody.putString("driver_tip", "");
        formBody.putString("delivery_instruction", "");

        formBody.putString("assoonas", "");
        formBody.putString("delivery_time", "");

        formBody.putString("order_description", etOrderInstruction.getText().toString());


        formBody.putString("delivery_date", "");

        if (offerApplied) {
            formBody.putString("offer_amount", MyApp.df.format(cartOffer));
            formBody.putString("offer_percentage", MyApp.df.format(offerPercentage));
        } else {
            formBody.putString("offer_amount", "0");
            formBody.putString("offer_percentage", "0");
        }

        formBody.putString("day_offer", "");
        formBody.putString("tax_percentage", "0");
        formBody.putString("tax_amount", "0");
        formBody.putString("service_charge", MyApp.df.format(cartServiceFee));


        if (voucherApplied) {
            formBody.putString("voucher_code", appliedVoucher.voucher_code);
            formBody.putString("voucher_amount", String.valueOf(voucherDiscount));
            formBody.putString("voucher_percentage", (appliedVoucher.offer_mode.equals("percentage")) ? String.valueOf(appliedVoucher.offer_value) : "0");
        } else {
            formBody.putString("voucher_code", "");
            formBody.putString("voucher_amount", "0.0");
            formBody.putString("voucher_percentage", "0.0");
        }

        formBody.putString("order_sub_total", MyApp.df.format(cartSubtotal));

        formBody.putString("table_no", tableNumber);
        formBody.putString("no_of_guest", String.valueOf(totalGuests));

        formBody.putString("order_point", "");
        formBody.putString("reward_used", "N");
        formBody.putString("spent_point", "");
        formBody.putString("reward_offer", "");
        formBody.putString("reward_offer_percentage", "");

        formBody.putString("failed_reason", "");
        formBody.putString("status", "Pending");
        formBody.putString("type", "Android");

        formBody.putString("preparation", "");
        formBody.putString("dont_bell", "0");
        formBody.putString("dont_cutlery", "0");

        formBody.putString("is_favourite", "0");
        if (cbCharity.isChecked()) {
            formBody.putString("charity_message", cbCharity.getText().toString());
            formBody.putString("charity_amount", MyApp.df.format(cartCharity));
            formBody.putString("order_grand_total", MyApp.df.format(getCartTotal() - cartCharity));
        } else {
            formBody.putString("order_grand_total", MyApp.df.format(getCartTotal()));
            formBody.putString("charity_message", "");
            formBody.putString("charity_amount", "0");
        }
        formBody.putFloat("paypal_minimum_order", restaurant.paypal_minimum_order);
        cartArray.clear();
        if (feed.size() > 0)
            for (Object o : feed) {
                if (o instanceof DineinCartItem) {
                    DineinCartItem cartItem = (DineinCartItem) o;
                    Cart cart = new Cart();
                    cart.restaurant_id = String.valueOf(cartItem.res_id);
                    cart.menu_id = String.valueOf(cartItem.menu_id);
                    cart.menu_name = cartItem.menu_name;
                    cart.menu_price = String.valueOf(cartItem.Menu_price);
                    cart.total_price = String.valueOf(cartItem.Total);
                    cart.quantity = String.valueOf(cartItem.quantity);
                    cart.menu_description = cartItem.instruction;
                    cart.subaddons_name = cartItem.Addon_name;
                    cartArray.add(cart);
                }
            }
        formBody.putString("carts", new Gson().toJson(cartArray));
        startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "payment_method").putExtra("name", "Payment").putExtra("order_total", getCartTotal()).putExtra("split", split).putExtras(formBody));

    }

    private Object genrateOrderCreateParams(boolean onlyCreateOrder) {
        HashMap<String, String> hashMap = new HashMap<>();
        hashMap.put("device_id", myApp.getMyPreferences().getDeviceId());
        hashMap.put("delivery_charge", String.valueOf(cartDeliveryFee));
        hashMap.put("total", String.valueOf(cartTotal));
        hashMap.put("sub_total", String.valueOf(cartSubtotal));
        hashMap.put("tax", "0");
        hashMap.put("service_charge", String.valueOf(cartServiceFee));
        hashMap.put("order_action_id", "1");
        hashMap.put("no_guest", String.valueOf(totalGuests));
        hashMap.put("updater_id", String.valueOf(myApp.getMyPreferences().getDineinUser().id));//??
        hashMap.put("discount", String.valueOf(cartDiscount));
        hashMap.put("distance", "0");//??

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.getDefault());

        hashMap.put("delivery_date", sdf.format(new Date()));
        hashMap.put("table_id", tableId);
        hashMap.put("order_type_id", "1");

        if (onlyCreateOrder) {
            hashMap.put("order_status_id", "12");
        } else {
            if (orderCompleteSetting.value.equalsIgnoreCase("auto")) {
                hashMap.put("order_status_id", "5");
            } else {
                hashMap.put("order_status_id", "4");
            }
        }

        hashMap.put("customer_id", restaurant.epos_customer.id);
        hashMap.put("order_type", "Dine in");
        hashMap.put("gratuity", String.valueOf(cartGratuity));
        hashMap.put("comment", etOrderInstruction.getText().toString());
        hashMap.put("is_archived", "0");
        hashMap.put("print", "1");
        ArrayList<CreateOrderParamsItem> orderItemArray = new ArrayList<>();
        if (cartItems.size() > 0) {
            for (DineinCartItem oit : cartItems) {
                CreateOrderParamsItem orderItem = new CreateOrderParamsItem();
                orderItem.id = String.valueOf(oit.id);
                orderItem.updater_id = oit.updater_id;
                orderItem.product_id = String.valueOf(oit.menu_id);
                orderItem.product_name = oit.menu_name;
                orderItem.addons_price = oit.Addon_price;
                orderItem.sent_to_kitchen = oit.sent_to_kitchen;
                orderItem.instruction_price = oit.instruction_price;
                orderItem.ingredients_price = oit.ingredients_price;
                orderItem.special_instruction = oit.instruction;
                orderItem.price = oit.Menu_price;
                orderItem.quantity = oit.quantity;
                for (OrderItemAddon oia : oit.order_item_addons) {
                    CreateOrderAddonParmsItem addon = new CreateOrderAddonParmsItem();
                    addon.addon_id = oia.addon_id;
                    addon.updater_id = oia.updater_id;
                    addon.price = oia.price;
                    addon.quantity = oia.quantity;
                    addon.id = oia.id;
                    addon.total = oia.total;
                    orderItem.order_item_addons.add(addon);
                }
                for (OrderItemIngredient oi : oit.order_item_ingredients) {
                    CreateOrderIngredientParamsItem ingredient = new CreateOrderIngredientParamsItem();
                    ingredient.id = oi.id;
                    ingredient.product_ingredient_id = oi.product_ingredient_id;
                    ingredient.updater_id = oi.updater_id;
                    ingredient.quantity = oi.quantity;
                    ingredient.with = oi.with;
                    ingredient.without = oi.without;
                    ingredient.price = oi.price;
                    ingredient.total = oi.total;
                    orderItem.order_item_ingredients.add(ingredient);
                }
                orderItemArray.add(orderItem);
            }
        }
        hashMap.put("order_items", new Gson().toJson(orderItemArray));

        CustomerParams customer = new CustomerParams();
        if (restaurant.epos_customer != null) {
            customer.id = restaurant.epos_customer.id;
            customer.mobile = restaurant.epos_customer.mobile;
            customer.name = restaurant.epos_customer.name;
            customer.email = restaurant.epos_customer.email;
            customer.street = !Validators.isNullOrEmpty(restaurant.epos_customer.street) ? restaurant.epos_customer.street : "";
            customer.postcode = !Validators.isNullOrEmpty(restaurant.epos_customer.postcode) ? restaurant.epos_customer.postcode : "";
            customer.house_no = !Validators.isNullOrEmpty(restaurant.epos_customer.house_no) ? restaurant.epos_customer.house_no : "";
            customer.city = !Validators.isNullOrEmpty(restaurant.epos_customer.city) ? restaurant.epos_customer.city : "";
            customer.distance = !Validators.isNullOrEmpty(restaurant.epos_customer.distance) ? restaurant.epos_customer.distance : "";
            customer.news_letter = !Validators.isNullOrEmpty(restaurant.epos_customer.news_letter) ? restaurant.epos_customer.news_letter : "";
        }

        hashMap.put("customer", new Gson().toJson(customer));
        LogUtils.e("orderitems_params::" + new Gson().toJson(hashMap));
        return hashMap;
    }

    String orderId = null;

    private void createOrder(boolean onlyCreateOrder) {
        getActivity().runOnUiThread(() -> {
            progressDialog.show();
        });
        AndroidNetworking.post(ApiEndPoints.dinein_create_order)
                .addBodyParameter(genrateOrderCreateParams(onlyCreateOrder))
                .addHeaders("business-id", myApp.getMyPreferences().getCurrentDineInRestaurantDetail().business.id)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        getActivity().runOnUiThread(() -> {
                            progressDialog.dismiss();
                        });

                        try {
                            orderId = response.getString("id");

                            createdOrder = new CreatedOrder();
                            createdOrder = new Gson().fromJson(response.toString(), CreatedOrder.class);
                            ToastUtils.makeToast(getActivity(), "Order Created!");

                            if (!onlyCreateOrder) {
                                selectPaymentMethod();
                            } else {
                                changeTableStatus("order taken", false, null);

                            }

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }

                    @Override
                    public void onError(ANError anError) {
                        LogUtils.e("create error" + anError.getErrorBody());
                        getActivity().runOnUiThread(() -> {
                            progressDialog.dismiss();
                        });
                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }

    Handler handler = new Handler();
    private static int TIME_TO_WAIT = 60000;

    Runnable runnable = new Runnable() {
        @Override
        public void run() {
            handler.postDelayed(runnable, TIME_TO_WAIT);
            if (createdOrder != null)
                fetchCreatedOrder();
        }
    };
    CountDownTimer countDownTimer;

    private void startTimer() {
        try {
            new Handler(Looper.getMainLooper()).post(() -> countDownTimer = new CountDownTimer(20000, 1000) {
                @Override
                public void onTick(long millisUntilFinished) {
                    // LogUtils.e("COUNT TIMER::" + count);
                }

                @Override
                public void onFinish() {
                    handler.removeCallbacks(runnable);
                    updateOrderItem(false);

                }
            }.start());
        } catch (Exception e) {
            e.printStackTrace();
        }

    }


    private Object genrateOrderUpdateParams() {
        HashMap<String, String> hashMap = new HashMap<>();
        hashMap.put("device_id", myApp.getMyPreferences().getDeviceId());
        hashMap.put("delivery_charge", "0");
        hashMap.put("total", String.valueOf(cartTotal));
        hashMap.put("sub_total", String.valueOf(cartSubtotal));
        hashMap.put("tax", "0");
        hashMap.put("service_charge", String.valueOf(cartServiceFee));
        hashMap.put("order_action_id", "1");
        hashMap.put("no_guest", String.valueOf(totalGuests));
        hashMap.put("updater_id", String.valueOf(myApp.getMyPreferences().getDineinUser().id));//??
        hashMap.put("discount", String.valueOf(cartDiscount));
        hashMap.put("distance", "0");//??
        hashMap.put("delivery_date", createdOrder.delivery_date);
        hashMap.put("table_id", String.valueOf(createdOrder.table_id));
        hashMap.put("order_type_id", "1");

        if (orderCompleteSetting.value.equalsIgnoreCase("auto")) {
            hashMap.put("order_status_id", "5");
        } else {
            hashMap.put("order_status_id", "4");
        }

        hashMap.put("customer_id", createdOrder.customer_id);
        hashMap.put("order_type", "Dine in");
        hashMap.put("gratuity", String.valueOf(cartGratuity));
        hashMap.put("comment", etOrderInstruction.getText().toString());
        hashMap.put("is_archived", "0");
        hashMap.put("print", "1");
        ArrayList<CreateOrderParamsItem> orderItemArray = new ArrayList<>();
        if (cartItems.size() > 0) {
            for (DineinCartItem oit : cartItems) {
                CreateOrderParamsItem orderItem = new CreateOrderParamsItem();
                orderItem.addons_price = oit.Addon_price;
                orderItem.instruction_price = oit.instruction_price;
                orderItem.ingredients_price = oit.ingredients_price;
                orderItem.price = oit.Menu_price;
                orderItem.product_id = String.valueOf(oit.menu_id);
                orderItem.product_name = oit.menu_name;
                orderItem.preparation_location_id = "";
                orderItem.quantity = oit.quantity;
                orderItem.sent_to_kitchen = oit.sent_to_kitchen;
                orderItem.updater_id = String.valueOf(myApp.getMyPreferences().getDineinUser().id);
                orderItem.order_spilt_id = "";
                orderItem.total = oit.Total;
                orderItem.special_instruction = "";
                orderItem.sub_total = oit.Total;
                orderItem.order_id = String.valueOf(createdOrder.id);
                for (OrderItem order : createdOrder.order_items) {
                    if (Integer.parseInt(order.product_id) == (oit.menu_id)) {
                        orderItem.id = order.id;//created order_item id
                    }
                }
                float addonTotal=0;
                for (OrderItemAddon oia : oit.order_item_addons) {
                    CreateOrderAddonParmsItem addon = new CreateOrderAddonParmsItem();
                    addon.addon_id = oia.addon_id;
                    addon.updater_id = oia.updater_id;
                    addon.price = oia.price;
                    addon.quantity = oia.quantity;
                    addon.id = oia.id;
                    addon.total = oia.total;
                    addonTotal=+oia.total;
                    orderItem.order_item_addons.add(addon);
                }
                float ingredientTotal=0;
                for (OrderItemIngredient oi : oit.order_item_ingredients) {
                    CreateOrderIngredientParamsItem ingredient = new CreateOrderIngredientParamsItem();
                    ingredient.id = oi.id;
                    ingredient.product_ingredient_id = oi.product_ingredient_id;
                    ingredient.updater_id = oi.updater_id;
                    ingredient.quantity = oi.quantity;
                    ingredient.with = oi.with;
                    ingredient.without = oi.without;
                    ingredient.price = oi.price;
                    ingredient.total = oi.total;
                    ingredientTotal=+oi.total;
                    orderItem.order_item_ingredients.add(ingredient);
                }
               // orderItem.total = oit.Total+addonTotal+ingredientTotal+(oit.instruction_price*oit.quantity);
                orderItemArray.add(orderItem);
            }
        }
        hashMap.put("order_items", new Gson().toJson(orderItemArray));

        CustomerParams customer = new CustomerParams();
        if (restaurant.epos_customer != null) {
            customer.id = restaurant.epos_customer.id;
            customer.mobile = restaurant.epos_customer.mobile;
            customer.name = restaurant.epos_customer.name;
            customer.email = restaurant.epos_customer.email;
            customer.street = !Validators.isNullOrEmpty(restaurant.epos_customer.street) ? restaurant.epos_customer.street : "";
            customer.postcode = !Validators.isNullOrEmpty(restaurant.epos_customer.postcode) ? restaurant.epos_customer.postcode : "";
            customer.house_no = !Validators.isNullOrEmpty(restaurant.epos_customer.house_no) ? restaurant.epos_customer.house_no : "";
            customer.city = !Validators.isNullOrEmpty(restaurant.epos_customer.city) ? restaurant.epos_customer.city : "";
            customer.distance = !Validators.isNullOrEmpty(restaurant.epos_customer.distance) ? restaurant.epos_customer.distance : "";
            customer.news_letter = !Validators.isNullOrEmpty(restaurant.epos_customer.news_letter) ? restaurant.epos_customer.news_letter : "";
        }

        hashMap.put("customer", new Gson().toJson(customer));
        LogUtils.e("orderitems_params::" + new Gson().toJson(hashMap));
        return hashMap;
    }

    private void updateOrderItem(boolean isBack) {
        try {
            getActivity().runOnUiThread(() -> {
                progressDialog.show();
            });

            AndroidNetworking.post(ApiEndPoints.dinein_create_order + createdOrder.id)
                    .addBodyParameter(genrateOrderUpdateParams())
                    .addHeaders("business-id", myApp.getMyPreferences().getCurrentDineInRestaurantDetail().business.id)
                    .build()
                    .getAsJSONObject(new JSONObjectRequestListener() {
                        @Override
                        public void onResponse(JSONObject response) {
                            try {
                                getActivity().runOnUiThread(() -> {
                                    progressDialog.dismiss();
                                });

                                ToastUtils.makeToast(getActivity(), "Order Updated!");
                            /*fetchCreatedOrder();
                            TIME_TO_WAIT = 60000;
                            handler.postDelayed(runnable, TIME_TO_WAIT);*/

                                if (isBack) {
                                    if (getActivity() != null) {
                                        Intent i = getActivity().getIntent();
                                        i.putExtra("order_created", true);
                                        i.putExtra("created_order", new Gson().toJson(createdOrder));
                                        getActivity().setResult(CODE_REFRESH, i);
                                        getActivity().finish();
                                    }
                                } else {
                                    TIME_TO_WAIT = 60000;
                                    handler.postDelayed(runnable, TIME_TO_WAIT);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                        @Override
                        public void onError(ANError anError) {
                            try {
                                getActivity().runOnUiThread(() -> {
                                    progressDialog.dismiss();
                                });
                                LogUtils.e("update error" + anError.getErrorBody());
                                if (!CommonFunctions.isConnected(getActivity()))
                                    myApp.noInternet(getActivity());
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    private void fetchCreatedOrder() {
        AndroidNetworking.get(ApiEndPoints.dinein_create_order + createdOrder.id)
                .addHeaders("business-id", restaurant.business.id)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        //    LogUtils.e("order params" + new Gson().toJson(response));
                        createdOrder = new Gson().fromJson(response.toString(), CreatedOrder.class);
                        addOrupdateItemToDineInCart(createdOrder);

                    }

                    @Override
                    public void onError(ANError anError) {
                        LogUtils.e("order error::" + anError.getErrorBody());
                        if (!CommonFunctions.isConnected(getActivity())) {
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                        }
                    }
                });

    }

    private void addOrupdateItemToDineInCart(CreatedOrder createdOrder) {
        ArrayList<DineinCartItem> cartItems = new ArrayList<>();
        ArrayList<OrderItemAddon> orderAddon = new ArrayList<>();
        ArrayList<OrderItemIngredient> orderIngredinet = new ArrayList<>();
        new Thread(() -> {
           // myApp.getAppDatabase().dineinCartItemDao().nukeTable();
            for (OrderItem historyCart : createdOrder.order_items) {
                DineinCartItem cartItem = new DineinCartItem();
                cartItem.quantity = historyCart.quantity;
                cartItem.Menu_price = historyCart.price;
                cartItem.menu_id = Integer.parseInt(historyCart.product_id);
                cartItem.id = Integer.parseInt(historyCart.id);
                cartItem.menu_name = historyCart.product_name;
                cartItem.menu_size = (historyCart.product_name.equalsIgnoreCase(historyCart.product_short_name)) ? "" : historyCart.product_short_name;
                cartItem.res_id = myApp.getMyPreferences().getCurrentRestaurantDetail().id;

                StringBuilder selectedProductAddons = new StringBuilder();
                float total_amount = 0;
                if ((historyCart.order_item_addons != null) && (historyCart.order_item_addons.size() > 0)) {
                    orderAddon.addAll(historyCart.order_item_addons);
                }
                if ((historyCart.order_item_ingredients != null) && (historyCart.order_item_ingredients.size() > 0)) {
                    orderIngredinet.addAll(historyCart.order_item_ingredients);
                }

                if (orderAddon.size() > 0) {
                    selectedProductAddons.append("(");
                    for (OrderItemAddon orderItemAddon : orderAddon) {
                        if (selectedProductAddons.length() > 0) {
                            selectedProductAddons.append("(");
                        }
                        selectedProductAddons.append(orderItemAddon.addon_name).append(": ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(orderItemAddon.price));
                        if (selectedProductAddons.length() > 0) {
                            selectedProductAddons.append(")");
                        }
                        total_amount = total_amount + orderItemAddon.total;
                    }
                    selectedProductAddons.append(")");
                }

                if (orderIngredinet.size() > 0) {
                    if (orderAddon.size() > 0) {
                        selectedProductAddons.append(",");
                    }
                    selectedProductAddons.append("(");
                    for (OrderItemIngredient orderItemIngredient : orderIngredinet) {
                        if (selectedProductAddons.length() > 0) {
                            selectedProductAddons.append("(");
                        }
                        if (orderItemIngredient.with) {
                            selectedProductAddons.append("Extra ");
                            selectedProductAddons.append(orderItemIngredient.quantity).append(" ");
                        }
                        if (orderItemIngredient.without) {
                            selectedProductAddons.append("No ");
                        }
                        selectedProductAddons.append(orderItemIngredient.ingredient_name).append(": ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(orderItemIngredient.total));
                        if (selectedProductAddons.length() > 0) {
                            selectedProductAddons.append(")");
                        }
                        total_amount = total_amount + orderItemIngredient.total;
                    }
                    selectedProductAddons.append(")");
                }
                if (!(Validators.isNullOrEmpty(historyCart.special_instruction)) && (historyCart.instruction_price > 0)) {
                    if (selectedProductAddons.length() > 0) {
                        selectedProductAddons.append(",(");
                    } else {
                        selectedProductAddons.append("(");
                    }
                    selectedProductAddons.append(historyCart.special_instruction).append(": ").append(myApp.getCurrencySymbol()).append(MyApp.df.format(historyCart.instruction_price));
                    if (selectedProductAddons.length() > 0) {
                        selectedProductAddons.append(")");
                    }
                    total_amount = total_amount + historyCart.instruction_price;
                }

                cartItem.Addon_name = selectedProductAddons.toString();
                cartItem.Addon_price = total_amount;
                cartItem.Total = cartItem.quantity * (cartItem.Menu_price + cartItem.Addon_price);
                cartItem.order_item_addons.addAll(historyCart.order_item_addons);
                cartItem.order_item_ingredients.addAll(historyCart.order_item_ingredients);
                cartItems.add(cartItem);

                DineinCartItem dbDineInCartItemExist = myApp.getAppDatabase().dineinCartItemDao().getDineinCartItemFromOrderItemId(Integer.parseInt(historyCart.id));
                if (dbDineInCartItemExist != null) {
                    myApp.getAppDatabase().dineinCartItemDao().updateAndReplace(cartItem);
                } else {
                    myApp.getAppDatabase().dineinCartItemDao().insertAll(cartItem);
                }

                fetchCartSummary();
                if (getActivity() != null) {
                    getActivity().runOnUiThread(() -> {
                        animationCartItemLoading.setVisibility(View.GONE);
                        cartBasketItemsAdapter.notifyDataSetChanged();
                    });
                }
            }

        }).start();
    }

    private void changeTableStatus(String order_status, boolean afterPayment, String id) {
        table_status_id = 0;
        for (TablesStatuses statuses : tablesStatuses) {
            if (order_status.equalsIgnoreCase(statuses.status)) {
                table_status_id = statuses.id;
            }
        }
        AndroidNetworking.post(ApiEndPoints.tables + tableId)
                .addHeaders("business-id", restaurant.business.id)
                .addBodyParameter("table_status_id", String.valueOf(table_status_id))
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        LogUtils.e("table change status" + new Gson().toJson(response));
                        if (afterPayment) {
                            showDineinOrderPlacedDialog(id);
                        } else {
                            //Attempt to invoke virtual method 'android.content.Intent androidx.fragment.app.FragmentActivity.getIntent()' on a null object reference
                            if (getActivity() != null) {
                                Intent i = getActivity().getIntent();
                                i.putExtra("order_created", true);
                                i.putExtra("created_order", new Gson().toJson(createdOrder));
                                getActivity().setResult(CODE_REFRESH, i);
                                getActivity().finish();
                            }
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        LogUtils.e("status change error::" + anError.getErrorBody());
                    }
                });
    }

    private void validatePaymentMethod() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                if (paymentMethod != null) {

                    if (paymentMethod.type.equalsIgnoreCase("wallet") || paymentMethod.type.equalsIgnoreCase("credit")) {
                        split = true;
                        if (loggedInUser.wallet_amount < getCartTotal()) {
                            paymentMethod = null;
                            paidFull = false;
                            llWalletSplit.setVisibility(View.VISIBLE);
                            tvOrderTotal.setText(String.format("Total: %s%s", currency, MyApp.df.format(getCartTotal())));
                            tvWalletSplitInfo.setText(String.format("To pay remaining %s%s, Please select another payment method", currency, MyApp.df.format(getCartTotal() - loggedInUser.wallet_amount)));
                            tvWalletSplitName.setText(String.format("Tiffintom Credit (%s%s)", currency, MyApp.df.format(loggedInUser.wallet_amount)));
                            displayPaymentMethod();
                        } else {
                            paidFull = true;
                            llWalletSplit.setVisibility(View.GONE);
                        }
                        if (paidFull) {
                            tvPaymentMethodName.setText(paymentMethod.title);
                            int logo = myApp.paymentMethodLogo(paymentMethod);
                            if (logo != -1) {
                                ivPaymentMethod.setImageResource(logo);
                                ivPaymentMethod.setVisibility(View.VISIBLE);
                            } else {
                                ivPaymentMethod.setVisibility(View.GONE);
                            }
                        }
                    } else {
                        tvPaymentMethodName.setText(paymentMethod.title);
                        int logo = myApp.paymentMethodLogo(paymentMethod);
                        if (logo != -1) {
                            ivPaymentMethod.setImageResource(logo);
                            ivPaymentMethod.setVisibility(View.VISIBLE);
                        } else {
                            ivPaymentMethod.setVisibility(View.GONE);
                        }
                    }
                } else {
                    llWalletSplit.setVisibility(View.GONE);
                    displayPaymentMethod();
                }
            });
        }
    }

    private float getCartTotal() {
        return cartSubtotal + cartServiceFee + cartGratuity - cartDiscount + cartCharity;
    }

    private DialogDismissListener addItemCartDialogListener = o -> {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                setUpAdapters(true);
                fetchCartSummary();
            });
        }
    };

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == CODE_PAYPAL) {
            LogUtils.e("PAYPAL RETURN");
            //  managePaypalRespone(data);
        } else if (requestCode == CODE_REFRESH) {
            LogUtils.e("REFRESH");
        } else {
            if (data != null) {
                stripe.onPaymentResult(requestCode, data, new PaymentResultCallback(this));
            }
        }
    }

    private static final class PaymentResultCallback
            implements ApiResultCallback<PaymentIntentResult> {

        @NonNull
        private final WeakReference<DineinCartCheckoutFragment> activityRef;

        PaymentResultCallback(DineinCartCheckoutFragment activity) {
            activityRef = new WeakReference<DineinCartCheckoutFragment>(activity);
            final DineinCartCheckoutFragment a = activityRef.get();
            if (activity.getActivity() != null && !activity.getActivity().isFinishing())
                a.progressDialog.show();
        }


        @Override
        public void onSuccess(@NonNull PaymentIntentResult result) {
            final DineinCartCheckoutFragment activity = activityRef.get();
            if (activity == null) {
                return;
            }
            PaymentIntent paymentIntent = result.getIntent();
            activity.managePaymentResponse(paymentIntent);
        }

        @Override
        public void onError(@NonNull Exception e) {
            final DineinCartCheckoutFragment activity = activityRef.get();
            if (activity == null) {
                return;
            }

            if (activity.getActivity() != null && !activity.getActivity().isFinishing())
                activity.progressDialog.dismiss();
            // Payment request failed – allow retrying using the same payment method
            ToastUtils.makeSnackToast(activity.getActivity(), "Payment request failed");
        }
    }

    private void managePaymentResponse(PaymentIntent paymentIntent) {
        PaymentIntent.Status status = paymentIntent.getStatus();
        if (status == PaymentIntent.Status.Succeeded) {
            // Payment completed successfully
            ToastUtils.makeSnackToast(getActivity(), "Payment successful");
            transactionId = paymentIntent.getId();
            if (isValidOrder())
                payOrder("10", String.valueOf(getCartTotal()));
        } else if (status == PaymentIntent.Status.RequiresPaymentMethod) {
            // Payment failed
            if (getActivity() != null && !getActivity().isFinishing())
                progressDialog.dismiss();
            ToastUtils.makeSnackToast(getActivity(), "Card authentication failed, Please retry");
        }
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    @Override
    public void onPause() {
        super.onPause();
        try {
            if (progressDialog != null) progressDialog.dismiss();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onStop() {
        super.onStop();
        try {
            if (progressDialog != null) progressDialog.dismiss();
            if (handler!=null&&runnable!=null) {
                handler.removeCallbacks(runnable);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        try {
            if (progressDialog != null) progressDialog.dismiss();
            if (handler!=null&&runnable!=null) {
                handler.removeCallbacks(runnable);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}
