package com.tiffintom.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.SwitchCompat;

import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONObjectRequestListener;
import com.tiffintom.R;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.models.User;
import com.tiffintom.network.ApiEndPoints;
import com.tiffintom.utils.ToastUtils;

import org.json.JSONObject;

public class NotificationFragment extends BaseFragment {
    private SwitchCompat switchPush, switchSms, switchEmail;
    private CheckBox cbPush1, cbPush2, cbPush3, cbPush4, cbPush5, cbPush6, cbPush7;
    private CheckBox cbSms1, cbSms2, cbSms3, cbSms4, cbSms5, cbSms6, cbSms7;
    private CheckBox cbEmail1, cbEmail2, cbEmail3, cbEmail4, cbEmail5, cbEmail6, cbEmail7;
    private User loggedInUser = myApp.getMyPreferences().getLoggedInUser();
    String order_place, order_accept, order_reject, order_delivered, book_table, book_status, important_update;
    private Button btnUpdate;

    public static NotificationFragment getInstance() {
        return new NotificationFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_notification, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        setListner();
        updateViews();
    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);
        progressDialog = CommonFunctions.customProgressDialog(getActivity(), "Updating...");
        cbPush1 = view.findViewById(R.id.cbPushPlaced);
        cbPush2 = view.findViewById(R.id.cbPushAccepted);
        cbPush3 = view.findViewById(R.id.cbPushRejected);
        cbPush4 = view.findViewById(R.id.cbPushDelivered);
        cbPush5 = view.findViewById(R.id.cbPushBooked);
        cbPush6 = view.findViewById(R.id.cbPushReservation);
        cbPush7 = view.findViewById(R.id.cbPushUpdate);
        switchPush = view.findViewById(R.id.switchPush);

        cbSms1 = view.findViewById(R.id.cbSmsPlaced);
        cbSms2 = view.findViewById(R.id.cbSmsAccepted);
        cbSms3 = view.findViewById(R.id.cbSmsRejected);
        cbSms4 = view.findViewById(R.id.cbSmsDeliverd);
        cbSms5 = view.findViewById(R.id.cbSmsBooked);
        cbSms6 = view.findViewById(R.id.cbSmsResevration);
        cbSms7 = view.findViewById(R.id.cbSmsUpdate);
        switchSms = view.findViewById(R.id.switchSms);

        cbEmail1 = view.findViewById(R.id.cbEmailplaced);
        cbEmail2 = view.findViewById(R.id.cbEmailAccepted);
        cbEmail3 = view.findViewById(R.id.cbEmailRejected);
        cbEmail4 = view.findViewById(R.id.cbEmailDelivered);
        cbEmail5 = view.findViewById(R.id.cbEmailBooked);
        cbEmail6 = view.findViewById(R.id.cbEmailReservation);
        cbEmail7 = view.findViewById(R.id.cbEmailUpdate);
        switchEmail = view.findViewById(R.id.switchEmail);

        btnUpdate = view.findViewById(R.id.btnUpdate);
    }

    private void updateViews() {
        switch (loggedInUser.order_place) {
            case "0":
                cbPush1.setChecked(false);
                cbSms1.setChecked(false);
                cbEmail1.setChecked(false);
                break;

            case "1":
                cbPush1.setChecked(true);
                cbSms1.setChecked(false);
                cbEmail1.setChecked(false);
                break;

            case "2":
                cbPush1.setChecked(false);
                cbSms1.setChecked(true);
                cbEmail1.setChecked(false);
                break;

            case "3":
                cbPush1.setChecked(true);
                cbSms1.setChecked(true);
                cbEmail1.setChecked(false);
                break;

            case "4":
                cbPush1.setChecked(false);
                cbSms1.setChecked(false);
                cbEmail1.setChecked(true);
                break;

            case "5":
                cbPush1.setChecked(true);
                cbSms1.setChecked(false);
                cbEmail1.setChecked(true);
                break;

            case "6":
                cbPush1.setChecked(false);
                cbSms1.setChecked(true);
                cbEmail1.setChecked(true);
                break;

            case "7":
                cbPush1.setChecked(true);
                cbSms1.setChecked(true);
                cbEmail1.setChecked(true);
                break;
        }

        switch (loggedInUser.order_accept) {
            case "0":
                cbPush2.setChecked(false);
                cbSms2.setChecked(false);
                cbEmail2.setChecked(false);
                break;

            case "1":
                cbPush2.setChecked(true);
                cbSms2.setChecked(false);
                cbEmail2.setChecked(false);
                break;

            case "2":
                cbPush2.setChecked(false);
                cbSms2.setChecked(true);
                cbEmail2.setChecked(false);
                break;

            case "3":
                cbPush2.setChecked(true);
                cbSms2.setChecked(true);
                cbEmail2.setChecked(false);
                break;

            case "4":
                cbPush2.setChecked(false);
                cbSms2.setChecked(false);
                cbEmail2.setChecked(true);
                break;

            case "5":
                cbPush2.setChecked(true);
                cbSms2.setChecked(false);
                cbEmail2.setChecked(true);
                break;

            case "6":
                cbPush2.setChecked(false);
                cbSms2.setChecked(true);
                cbEmail2.setChecked(true);
                break;

            case "7":
                cbPush2.setChecked(true);
                cbSms2.setChecked(true);
                cbEmail2.setChecked(true);
                break;
        }

        switch (loggedInUser.order_reject) {
            case "0":
                cbPush3.setChecked(false);
                cbSms3.setChecked(false);
                cbEmail3.setChecked(false);
                break;

            case "1":
                cbPush3.setChecked(true);
                cbSms3.setChecked(false);
                cbEmail3.setChecked(false);
                break;

            case "2":
                cbPush3.setChecked(false);
                cbSms3.setChecked(true);
                cbEmail3.setChecked(false);
                break;

            case "3":
                cbPush3.setChecked(true);
                cbSms3.setChecked(true);
                cbEmail3.setChecked(false);
                break;

            case "4":
                cbPush3.setChecked(false);
                cbSms3.setChecked(false);
                cbEmail3.setChecked(true);
                break;

            case "5":
                cbPush3.setChecked(true);
                cbSms3.setChecked(false);
                cbEmail3.setChecked(true);
                break;

            case "6":
                cbPush3.setChecked(false);
                cbSms3.setChecked(true);
                cbEmail3.setChecked(true);
                break;

            case "7":
                cbPush3.setChecked(true);
                cbSms3.setChecked(true);
                cbEmail3.setChecked(true);
                break;
        }

        switch (loggedInUser.order_delivered) {
            case "0":
                cbPush4.setChecked(false);
                cbSms4.setChecked(false);
                cbEmail4.setChecked(false);
                break;

            case "1":
                cbPush4.setChecked(true);
                cbSms4.setChecked(false);
                cbEmail4.setChecked(false);
                break;

            case "2":
                cbPush4.setChecked(false);
                cbSms4.setChecked(true);
                cbEmail4.setChecked(false);
                break;

            case "3":
                cbPush4.setChecked(true);
                cbSms4.setChecked(true);
                cbEmail4.setChecked(false);
                break;

            case "4":
                cbPush4.setChecked(false);
                cbSms4.setChecked(false);
                cbEmail4.setChecked(true);
                break;

            case "5":
                cbPush4.setChecked(true);
                cbSms4.setChecked(false);
                cbEmail4.setChecked(true);
                break;

            case "6":
                cbPush4.setChecked(false);
                cbSms4.setChecked(true);
                cbEmail4.setChecked(true);
                break;

            case "7":
                cbPush4.setChecked(true);
                cbSms4.setChecked(true);
                cbEmail4.setChecked(true);
                break;
        }

        switch (loggedInUser.book_table) {
            case "0":
                cbPush5.setChecked(false);
                cbSms5.setChecked(false);
                cbEmail5.setChecked(false);
                break;

            case "1":
                cbPush5.setChecked(true);
                cbSms5.setChecked(false);
                cbEmail5.setChecked(false);
                break;

            case "2":
                cbPush5.setChecked(false);
                cbSms5.setChecked(true);
                cbEmail5.setChecked(false);
                break;

            case "3":
                cbPush5.setChecked(true);
                cbSms5.setChecked(true);
                cbEmail5.setChecked(false);
                break;

            case "4":
                cbPush5.setChecked(false);
                cbSms5.setChecked(false);
                cbEmail5.setChecked(true);
                break;

            case "5":
                cbPush5.setChecked(true);
                cbSms5.setChecked(false);
                cbEmail5.setChecked(true);
                break;

            case "6":
                cbPush5.setChecked(false);
                cbSms5.setChecked(true);
                cbEmail5.setChecked(true);
                break;

            case "7":
                cbPush5.setChecked(true);
                cbSms5.setChecked(true);
                cbEmail5.setChecked(true);
                break;
        }

        switch (loggedInUser.book_status) {
            case "0":
                cbPush6.setChecked(false);
                cbSms6.setChecked(false);
                cbEmail6.setChecked(false);
                break;

            case "1":
                cbPush6.setChecked(true);
                cbSms6.setChecked(false);
                cbEmail6.setChecked(false);
                break;

            case "2":
                cbPush6.setChecked(false);
                cbSms6.setChecked(true);
                cbEmail6.setChecked(false);
                break;

            case "3":
                cbPush6.setChecked(true);
                cbSms6.setChecked(true);
                cbEmail6.setChecked(false);
                break;

            case "4":
                cbPush6.setChecked(false);
                cbSms6.setChecked(false);
                cbEmail6.setChecked(true);
                break;

            case "5":
                cbPush6.setChecked(true);
                cbSms6.setChecked(false);
                cbEmail6.setChecked(true);
                break;

            case "6":
                cbPush6.setChecked(false);
                cbSms6.setChecked(true);
                cbEmail6.setChecked(true);
                break;

            case "7":
                cbPush6.setChecked(true);
                cbSms6.setChecked(true);
                cbEmail6.setChecked(true);
                break;
        }

        switch (loggedInUser.important_update) {
            case "0":
                cbPush7.setChecked(false);
                cbSms7.setChecked(false);
                cbEmail7.setChecked(false);
                break;

            case "1":
                cbPush7.setChecked(true);
                cbSms7.setChecked(false);
                cbEmail7.setChecked(false);
                break;

            case "2":
                cbPush7.setChecked(false);
                cbSms7.setChecked(true);
                cbEmail7.setChecked(false);
                break;

            case "3":
                cbPush7.setChecked(true);
                cbSms7.setChecked(true);
                cbEmail7.setChecked(false);
                break;

            case "4":
                cbPush7.setChecked(false);
                cbSms7.setChecked(false);
                cbEmail7.setChecked(true);
                break;

            case "5":
                cbPush7.setChecked(true);
                cbSms7.setChecked(false);
                cbEmail7.setChecked(true);
                break;

            case "6":
                cbPush7.setChecked(false);
                cbSms7.setChecked(true);
                cbEmail7.setChecked(true);
                break;

            case "7":
                cbPush7.setChecked(true);
                cbSms7.setChecked(true);
                cbEmail7.setChecked(true);
                break;
        }

    }

    private boolean pushManual = false;

    private boolean smsManual = false;
    private boolean emailManual = false;

    private void setListner() {

        switchPushListner();
        switchSmsListner();
        switchEmailListner();
        btnUpdate.setOnClickListener(view -> {
            updateSettings();
        });
    }

    private void switchEmailListner() {
        cbEmail1.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });
        cbEmail2.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });
        cbEmail3.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });
        cbEmail4.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });
        cbEmail5.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });
        cbEmail6.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });
        cbEmail7.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbEmail1.isChecked() && cbEmail2.isChecked() && cbEmail3.isChecked() && cbEmail4.isChecked() && cbEmail5.isChecked() && cbEmail6.isChecked() && cbEmail7.isChecked()) {
                emailManual = true;
                switchEmail.setChecked(true);
            } else {
                if (switchEmail.isChecked()) {
                    emailManual = true;
                    switchEmail.setChecked(false);
                }
            }
        });

        switchEmail.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) {
                cbEmail1.setChecked(true);
                cbEmail2.setChecked(true);
                cbEmail3.setChecked(true);
                cbEmail4.setChecked(true);
                cbEmail5.setChecked(true);
                cbEmail6.setChecked(true);
                cbEmail7.setChecked(true);
            } else if (!emailManual) {
                cbEmail1.setChecked(false);
                cbEmail2.setChecked(false);
                cbEmail3.setChecked(false);
                cbEmail4.setChecked(false);
                cbEmail5.setChecked(false);
                cbEmail6.setChecked(false);
                cbEmail7.setChecked(false);
            }
            emailManual = false;
        });


    }

    private void switchPushListner() {
        cbPush1.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        cbPush2.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        cbPush3.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        cbPush4.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        cbPush5.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        cbPush6.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        cbPush7.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbPush1.isChecked() && cbPush2.isChecked() && cbPush3.isChecked() && cbPush4.isChecked() && cbPush5.isChecked() && cbPush6.isChecked() && cbPush7.isChecked()) {
                pushManual = true;
                switchPush.setChecked(true);
            } else {
                if (switchPush.isChecked()) {
                    pushManual = true;
                    switchPush.setChecked(false);
                }
            }
        });
        switchPush.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) {
                cbPush1.setChecked(true);
                cbPush2.setChecked(true);
                cbPush3.setChecked(true);
                cbPush4.setChecked(true);
                cbPush5.setChecked(true);
                cbPush6.setChecked(true);
                cbPush7.setChecked(true);
            } else if (!pushManual) {
                cbPush1.setChecked(false);
                cbPush2.setChecked(false);
                cbPush3.setChecked(false);
                cbPush4.setChecked(false);
                cbPush5.setChecked(false);
                cbPush6.setChecked(false);
                cbPush7.setChecked(false);
            }
            pushManual = false;
        });

    }

    private void switchSmsListner() {
        cbSms1.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        cbSms2.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        cbSms3.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        cbSms4.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        cbSms5.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        cbSms6.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        cbSms7.setOnCheckedChangeListener((compoundButton, b) -> {
            if (cbSms1.isChecked() && cbSms2.isChecked() && cbSms3.isChecked() && cbSms4.isChecked() && cbSms5.isChecked() && cbSms6.isChecked() && cbSms7.isChecked()) {
                smsManual = true;
                switchSms.setChecked(true);
            } else {
                if (switchSms.isChecked()) {
                    smsManual = true;
                    switchSms.setChecked(false);
                }
            }
        });
        switchSms.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) {
                cbSms1.setChecked(true);
                cbSms2.setChecked(true);
                cbSms3.setChecked(true);
                cbSms4.setChecked(true);
                cbSms5.setChecked(true);
                cbSms6.setChecked(true);
                cbSms7.setChecked(true);
            } else if (!smsManual) {
                cbSms1.setChecked(false);
                cbSms2.setChecked(false);
                cbSms3.setChecked(false);
                cbSms4.setChecked(false);
                cbSms5.setChecked(false);
                cbSms6.setChecked(false);
                cbSms7.setChecked(false);
            }
            smsManual = false;
        });

    }

    private void updateSettings() {
        if (getActivity() != null) getActivity().runOnUiThread(() -> progressDialog.show());
        getSettingsValues();
        AndroidNetworking.post(ApiEndPoints.UPDATE_ACCOUNT+loggedInUser.id)
                .addBodyParameter("order_place",order_place)
                .addBodyParameter("order_accept",order_accept)
                .addBodyParameter("order_reject",order_reject)
                .addBodyParameter("order_delivered",order_delivered)
                .addBodyParameter("book_table",book_table)
                .addBodyParameter("book_status",book_status)
                .addBodyParameter("important_update",important_update)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                            ToastUtils.makeToast(getActivity(), "Notification settings updated successfully");
                            loggedInUser.order_place = order_place;
                            loggedInUser.order_accept = order_accept;
                            loggedInUser.order_reject = order_reject;
                            loggedInUser.order_delivered = order_delivered;
                            loggedInUser.book_table = book_table;
                            loggedInUser.book_status = book_status;
                            loggedInUser.important_update = important_update;
                            myApp.getMyPreferences().saveLoggedInUser(loggedInUser);
                            if (getActivity() != null) {
                                getActivity().finish();
                            }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        ToastUtils.makeToast(getActivity(), "Something went wrong!!");

                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }

    private void getSettingsValues() {
        if (cbPush1.isChecked() && cbSms1.isChecked() && cbEmail1.isChecked()) {
            order_place = "7";
        } else {

            if (cbPush1.isChecked() && !cbSms1.isChecked() && !cbEmail1.isChecked()) {
                order_place = "1";
            } else if (!cbPush1.isChecked() && cbSms1.isChecked() && !cbEmail1.isChecked()) {
                order_place = "2";
            } else if (cbPush1.isChecked() && cbSms1.isChecked() && !cbEmail1.isChecked()) {
                order_place = "3";
            } else if (!cbPush1.isChecked() && !cbSms1.isChecked() && cbEmail1.isChecked()) {
                order_place = "4";
            } else if (cbPush1.isChecked() && !cbSms1.isChecked() && cbEmail1.isChecked()) {
                order_place = "5";
            } else if (!cbPush1.isChecked() && cbSms1.isChecked() && cbEmail1.isChecked()) {
                order_place = "6";
            } else {
                order_place = "0";
            }
        }

        if (cbPush2.isChecked() && cbSms2.isChecked() && cbEmail2.isChecked()) {
            order_accept = "7";
        } else {
            if (cbPush2.isChecked() && !cbSms2.isChecked() && !cbEmail2.isChecked()) {
                order_accept = "1";
            } else if (!cbPush2.isChecked() && cbSms2.isChecked() && !cbEmail2.isChecked()) {
                order_accept = "2";
            } else if (cbPush2.isChecked() && cbSms2.isChecked() && !cbEmail2.isChecked()) {
                order_accept = "3";
            } else if (!cbPush2.isChecked() && !cbSms2.isChecked() && cbEmail2.isChecked()) {
                order_accept = "4";
            } else if (cbPush2.isChecked() && !cbSms2.isChecked() && cbEmail2.isChecked()) {
                order_accept = "5";
            } else if (!cbPush2.isChecked() && cbSms2.isChecked() && cbEmail2.isChecked()) {
                order_accept = "6";
            } else {
                order_accept = "0";
            }
        }

        if (cbPush3.isChecked() && cbSms3.isChecked() && cbEmail3.isChecked()) {
            order_reject = "7";
        } else {
            if (cbPush3.isChecked() && !cbSms3.isChecked() && !cbEmail3.isChecked()) {
                order_reject = "1";
            } else if (!cbPush3.isChecked() && cbSms3.isChecked() && !cbEmail3.isChecked()) {
                order_reject = "2";
            } else if (cbPush3.isChecked() && cbSms3.isChecked() && !cbEmail3.isChecked()) {
                order_reject = "3";
            } else if (!cbPush3.isChecked() && !cbSms3.isChecked() && cbEmail3.isChecked()) {
                order_reject = "4";
            } else if (cbPush3.isChecked() && !cbSms3.isChecked() && cbEmail3.isChecked()) {
                order_reject = "5";
            } else if (!cbPush3.isChecked() && cbSms3.isChecked() && cbEmail3.isChecked()) {
                order_reject = "6";
            } else {
                order_reject = "0";
            }
        }

        if (cbPush4.isChecked() && cbSms4.isChecked() && cbEmail4.isChecked()) {
            order_delivered = "7";
        } else {
            if (cbPush4.isChecked() && !cbSms4.isChecked() && !cbEmail4.isChecked()) {
                order_delivered = "1";
            } else if (!cbPush4.isChecked() && cbSms4.isChecked() && !cbEmail4.isChecked()) {
                order_delivered = "2";
            } else if (cbPush4.isChecked() && cbSms4.isChecked() && !cbEmail4.isChecked()) {
                order_delivered = "3";
            } else if (!cbPush4.isChecked() && !cbSms4.isChecked() && cbEmail4.isChecked()) {
                order_delivered = "4";
            } else if (cbPush4.isChecked() && !cbSms4.isChecked() && cbEmail4.isChecked()) {
                order_delivered = "5";
            } else if (!cbPush4.isChecked() && cbSms4.isChecked() && cbEmail4.isChecked()) {
                order_delivered = "6";
            } else {
                order_delivered = "0";
            }
        }

        if (cbPush5.isChecked() && cbSms5.isChecked() && cbEmail5.isChecked()) {
            book_table = "7";
        } else {
            if (cbPush5.isChecked() && !cbSms5.isChecked() && !cbEmail5.isChecked()) {
                book_table = "1";
            } else if (!cbPush5.isChecked() && cbSms5.isChecked() && !cbEmail5.isChecked()) {
                book_table = "2";
            } else if (cbPush5.isChecked() && cbSms5.isChecked() && !cbEmail5.isChecked()) {
                book_table = "3";
            } else if (!cbPush5.isChecked() && !cbSms5.isChecked() && cbEmail5.isChecked()) {
                book_table = "4";
            } else if (cbPush5.isChecked() && !cbSms5.isChecked() && cbEmail5.isChecked()) {
                book_table = "5";
            } else if (!cbPush5.isChecked() && cbSms5.isChecked() && cbEmail5.isChecked()) {
                book_table = "6";
            } else {
                book_table = "0";
            }
        }

        if (cbPush6.isChecked() && cbSms6.isChecked() && cbEmail6.isChecked()) {
            book_status = "7";
        } else {
            if (cbPush6.isChecked() && !cbSms6.isChecked() && !cbEmail6.isChecked()) {
                book_status = "1";
            } else if (!cbPush6.isChecked() && cbSms6.isChecked() && !cbEmail6.isChecked()) {
                book_status = "2";
            } else if (cbPush6.isChecked() && cbSms6.isChecked() && !cbEmail6.isChecked()) {
                book_status = "3";
            } else if (!cbPush6.isChecked() && !cbSms6.isChecked() && cbEmail6.isChecked()) {
                book_status = "4";
            } else if (cbPush6.isChecked() && !cbSms6.isChecked() && cbEmail6.isChecked()) {
                book_status = "5";
            } else if (!cbPush6.isChecked() && cbSms6.isChecked() && cbEmail6.isChecked()) {
                book_status = "6";
            } else {
                book_status = "0";
            }
        }

        if (cbPush7.isChecked() && cbSms7.isChecked() && cbEmail7.isChecked()) {
            important_update = "7";
        } else {
            if (cbPush7.isChecked() && !cbSms7.isChecked() && !cbEmail7.isChecked()) {
                important_update = "1";
            } else if (!cbPush7.isChecked() && cbSms7.isChecked() && !cbEmail7.isChecked()) {
                important_update = "2";
            } else if (cbPush7.isChecked() && cbSms7.isChecked() && !cbEmail7.isChecked()) {
                important_update = "3";
            } else if (!cbPush7.isChecked() && !cbSms7.isChecked() && cbEmail7.isChecked()) {
                important_update = "4";
            } else if (cbPush7.isChecked() && !cbSms7.isChecked() && cbEmail7.isChecked()) {
                important_update = "5";
            } else if (!cbPush7.isChecked() && cbSms7.isChecked() && cbEmail7.isChecked()) {
                important_update = "6";
            } else {
                important_update = "0";
            }
        }
    }
}
