package com.tiffintom.fragment;

import static com.tiffintom.network.ApiEndPoints.NEW_ORDERS;
import static com.tiffintom.utils.Constants.CODE_NO_INTERNET;
import static com.tiffintom.utils.Constants.CODE_PAYPAL;
import static com.tiffintom.utils.Constants.CODE_REFRESH;

import android.animation.Animator;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.airbnb.lottie.LottieAnimationView;
import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONArrayRequestListener;
import com.androidnetworking.interfaces.JSONObjectRequestListener;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.stripe.android.ApiResultCallback;
import com.stripe.android.PaymentIntentResult;
import com.stripe.android.Stripe;
import com.stripe.android.model.ConfirmPaymentIntentParams;
import com.stripe.android.model.PaymentIntent;
import com.tiffintom.MyApp;
import com.tiffintom.R;
import com.tiffintom.activity.NoInternetActivity;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.activity.WebViewActivity;
import com.tiffintom.adapters.PaymentMethodsAdapter;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.common.Validators;
import com.tiffintom.interfaces.DialogDismissListener;
import com.tiffintom.models.PaymentMethod;
import com.tiffintom.models.PlaceOrder;
import com.tiffintom.models.Restaurant;
import com.tiffintom.models.RestaurantPaymentMethod;
import com.tiffintom.models.SavedCard;
import com.tiffintom.models.User;
import com.tiffintom.network.ApiEndPoints;
import com.tiffintom.network.ApiUtils;
import com.tiffintom.utils.LogUtils;
import com.tiffintom.utils.ToastUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created by Amrish on 19-08-2020.
 */
public class PaymentMethodsFragmentNew extends BaseFragment {
    public static PaymentMethodsFragmentNew getInstance() {
        return new PaymentMethodsFragmentNew();
    }

    private Stripe stripe;
    private String transactionId;
    protected AlertDialog progressDialog;
    private RecyclerView rvMethods;
    private PaymentMethodsAdapter paymentMethodsAdapter;
    private ArrayList<PaymentMethod> paymentMethods = new ArrayList<>();
    private ArrayList<SavedCard> savedCards = new ArrayList<>();
    private ProgressBar pbLoading;
    private User loggedInUser;
    private MyApp myApp = MyApp.getInstance();
    private DialogDismissListener dialogDismissListener;
    private ArrayList<RestaurantPaymentMethod> restaurantPaymentMethods = new ArrayList<>();
    private PaymentMethod paymentMethod;
    private Restaurant restaurant;
    private boolean dineIn;
    private TextView tvOrderTotal;
    LinearLayout llPlaceOrder;
    private String wallet_payment, dinein_wallet_payment, restaurant_id;
    private LottieAnimationView lodingView;
    private PlaceOrder placeOrder;
    private LinearLayout llSplitWalletMethod;
    private TextView tvSplitWalletInfo, tvWalletSplitName;
    private ImageView ivCloseSplit;
    private String currency = myApp.getCurrencySymbol();
    ArrayList<SavedCard> CardArraylist = new ArrayList<>();

    public static PaymentMethodsFragment getInstance(boolean onlyCards) {
        PaymentMethodsFragment fragment = new PaymentMethodsFragment();
        Bundle bundle = new Bundle();
        bundle.putBoolean("onlyCards", onlyCards);
        fragment.setArguments(bundle);
        return fragment;
    }

    private boolean onlyCards = false;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if (getActivity() != null)
            getActivity().getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE);
        if (getArguments() != null) {
            onlyCards = getArguments().getBoolean("onlyCards");
            dineIn = getArguments().getBoolean("dineIn");
            wallet_payment = getArguments().getString("wallet_payment");
            dinein_wallet_payment = getArguments().getString("dinein_wallet_payment");
            placeOrder = new Gson().fromJson(getArguments().getString("place_order"), PlaceOrder.class);
            restaurant_id = getArguments().getString("restaurant_id");
          /*  Type type = new TypeToken<List<RestaurantPaymentMethod>>() {
            }.getType();
            if (getArguments().getString("restaurant_payment_methods") != null)
                restaurantPaymentMethods.addAll(new Gson().fromJson(getArguments().getString("restaurant_payment_methods"), type));*/
        }

        return inflater.inflate(R.layout.fragment_payment_methods_new, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initViews(view);
        setListeners();
        fetchRestaurantDetails();
       /* if (onlyCards) {
            fetchCards();
        } else {
            fetchProfile(false);
        }*/
    }

    private void fetchRestaurantDetails() {
        ApiUtils.getRestaurantDetails(String.valueOf(restaurant_id), String.valueOf(loggedInUser.id), myApp.getMyPreferences().getCurrentPostcode().post_code)
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        Type type = new TypeToken<List<RestaurantPaymentMethod>>() {
                        }.getType();
                        try {
                            restaurantPaymentMethods.clear();
                            restaurant = new Gson().fromJson(response.toString(), Restaurant.class);
                            ArrayList<RestaurantPaymentMethod> RestaurantPaymentMethods = new ArrayList<>(new Gson().fromJson(String.valueOf(response.getJSONArray("payment_methods").toString()), type));
                            restaurantPaymentMethods.addAll(RestaurantPaymentMethods);
                            if (onlyCards) {
                                fetchCards();
                            } else {
                                fetchProfile(false);
                            }
                        } catch (JSONException exception) {
                            exception.printStackTrace();
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("FETCH RESTAURANT FROM CART:::::", anError.getErrorBody());
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void fetchProfile(boolean isPhoneVerify) {
        AndroidNetworking.get(ApiEndPoints.NEW_ACCOUNT)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        User user1 = new Gson().fromJson(response.toString(), User.class);
                        myApp.getMyPreferences().saveLoggedInUser(user1);
                        myApp.profileChanged();
                        fetchCards();
                        if(isPhoneVerify) if (isValidOrder())createOrder();

                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> lodingView.setVisibility(View.GONE));
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());

                    }
                });
    }


    private void fetchCards() {
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> lodingView.setVisibility(View.VISIBLE));

        AndroidNetworking.get(ApiEndPoints.NEW_CARDS).addQueryParameter("customer_id", String.valueOf(loggedInUser.id)).addQueryParameter("nopaginate", "1").build()
                .getAsJSONArray(new JSONArrayRequestListener() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Type type = new TypeToken<List<SavedCard>>() {
                        }.getType();
                        savedCards.clear();
                        CardArraylist.clear();
                        savedCards.addAll(new Gson().fromJson(response.toString(), type));
                        if (restaurant != null && restaurant.business != null) {
                            for (SavedCard savedCard : savedCards) {
                                if (restaurant.business.connect_service) {
                                    if (savedCard.service_type.equalsIgnoreCase("connect")) {
                                        CardArraylist.add(savedCard);
                                    }
                                }else {
                                    if (savedCard.service_type.equalsIgnoreCase("normal")) {
                                        CardArraylist.add(savedCard);
                                    }
                                }
                            }
                        }

                        showMethods();
                        paymentMethodsAdapter.notifyDataSetChanged();
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> lodingView.setVisibility(View.GONE));
                    }

                    @Override
                    public void onError(ANError anError) {
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> lodingView.setVisibility(View.GONE));
                        anError.printStackTrace();
                        if (anError.getErrorCode() == 400) {
                            showMethods();
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }

    private void showMethods() {
        if (restaurantPaymentMethods.size() > 0) {
            for (RestaurantPaymentMethod restaurantPaymentMethod : restaurantPaymentMethods) {
                if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("cod")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd) {
                        paymentMethod = new PaymentMethod();
                        paymentMethod.type = "cod";
                        if (dineIn)
                            paymentMethod.title = "Pay at restaurant";
                        else
                            paymentMethod.title = "Cash on delivery";
                        paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);
                        paymentMethods.add(paymentMethod);
                    }
                } else if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("Stripe")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd) {
                        for (SavedCard card : CardArraylist) {
                            paymentMethod = new PaymentMethod();
                            paymentMethod.type = "Stripe";
                            paymentMethod.title = "**** " + card.card_number;
                            paymentMethod.card_number = card.card_number;
                            paymentMethod.card_id = card.id;
                            paymentMethod.stripe_customer_id = card.stripe_customer_id;
                            paymentMethod.stripe_token_id = card.stripe_token_id;
                            paymentMethod.card_brand = card.card_brand;
                            paymentMethod.exp_month = card.exp_month;
                            paymentMethod.exp_year = card.exp_year;
                            paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);

                            paymentMethods.add(paymentMethod);
                        }
                        paymentMethod = new PaymentMethod();
                        paymentMethod.type = "add";
                        paymentMethod.title = "Add payment type";
                        paymentMethods.add(paymentMethod);


                    }
                } else if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("paypal")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd) {
                        paymentMethod = new PaymentMethod();
                        paymentMethod.type = "paypal";
                        paymentMethod.title = "PayPal";
                        paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);
                        paymentMethods.add(paymentMethod);
                    }
                } else if (restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("wallet") || restaurantPaymentMethod.payment_method_name.equalsIgnoreCase("credit")) {
                    boolean canBeAdd = false;
                    if (dineIn && restaurantPaymentMethod.dinein_android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (restaurantPaymentMethod.android_status.equalsIgnoreCase("y")) {
                        canBeAdd = true;
                    }
                    if (canBeAdd) {
                        paymentMethod = new PaymentMethod();
                        paymentMethod.type = "wallet";
                        paymentMethod.title = "Tiffintom Credit";
                        paymentMethod.subtitle = "Balance " + myApp.getCurrencySymbol() + MyApp.df.format(loggedInUser.wallet_amount);
                        paymentMethod.balance = loggedInUser.wallet_amount;
                        paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);
                        paymentMethods.add(paymentMethod);
                    }
                }

            }

            if (!Validators.isNullOrEmpty(wallet_payment)) {
                boolean canBeAdd = false;
                if (dineIn && dinein_wallet_payment.equalsIgnoreCase("yes") && myApp.getMyPreferences().getSiteSettings().wallet_available.equalsIgnoreCase("yes")) {
                    canBeAdd = true;
                }
                if (!dineIn && wallet_payment.equalsIgnoreCase("yes") && myApp.getMyPreferences().getSiteSettings().wallet_available.equalsIgnoreCase("yes")) {
                    canBeAdd = true;
                }
                if (canBeAdd) {
                    paymentMethod = new PaymentMethod();
                    paymentMethod.type = "wallet";
                    paymentMethod.title = "Tiffintom Credit";
                    paymentMethod.subtitle = "Balance " + myApp.getCurrencySymbol() + MyApp.df.format(loggedInUser.wallet_amount);
                    paymentMethod.balance = loggedInUser.wallet_amount;
                    paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);
                    paymentMethods.add(paymentMethod);
                }
            }
        } else {
            if (onlyCards == true) {
                paymentMethod = new PaymentMethod();
                paymentMethod.type = "cod";
                if (dineIn)
                    paymentMethod.title = "Pay at restaurant";
                else
                    paymentMethod.title = "Cash on delivery";
                paymentMethod.method_logo = R.drawable.icon_cod;
                paymentMethods.add(paymentMethod);
            }
            for (SavedCard card : CardArraylist) {
                paymentMethod = new PaymentMethod();
                paymentMethod.type = "Stripe";
                paymentMethod.title = "**** " + card.card_number;
                paymentMethod.card_number = card.card_number;
                paymentMethod.card_id = card.id;
                paymentMethod.stripe_customer_id = card.stripe_customer_id;
                paymentMethod.stripe_token_id = card.stripe_token_id;
                paymentMethod.card_brand = card.card_brand;
                paymentMethod.exp_month = card.exp_month;
                paymentMethod.exp_year = card.exp_year;
                paymentMethod.service_type = card.service_type;
                paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);
                paymentMethods.add(paymentMethod);
            }
            if (onlyCards == true) {
                paymentMethod = new PaymentMethod();
                paymentMethod.type = "paypal";
                paymentMethod.title = "PayPal";
                paymentMethod.method_logo = myApp.paymentMethodLogo(paymentMethod);
                paymentMethods.add(paymentMethod);
            }
            if (onlyCards == true) {
                paymentMethod = new PaymentMethod();
                paymentMethod.type = "wallet";
                paymentMethod.title = "Tiffintom Credit";
                paymentMethod.subtitle = "Balance " + myApp.getCurrencySymbol() + MyApp.df.format(loggedInUser.wallet_amount);
                paymentMethod.balance = loggedInUser.wallet_amount;
                paymentMethod.method_logo = R.drawable.ic_tiffin;
                paymentMethods.add(paymentMethod);
            }


        }

        PaymentMethod defaultPaymentMethod = MyApp.getInstance().getMyPreferences().getDefaultPaymentMethod();

        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                if (defaultPaymentMethod != null) {
                    paymentMethodsAdapter.selectedPaymentMethod = defaultPaymentMethod;
                    placeorderViewEnable(false);
                    for (PaymentMethod pm : paymentMethods) {
                        if (pm.type.equalsIgnoreCase(defaultPaymentMethod.type))
                            placeorderViewEnable(true);
                    }
                } else {
                    paymentMethodsAdapter.selectedPaymentMethod = null;
                    placeorderViewEnable(false);
                }


            });

        }
        paymentMethodsAdapter.notifyDataSetChanged();
    }

    private void methodClick(int position, Object data) {
        if (data instanceof PaymentMethod) {

            if (((PaymentMethod) data).type.equalsIgnoreCase("add")) {
                AddCardFragment addCardFragment = AddCardFragment.getInstance(onlyCards, restaurant);
                addCardFragment.show(getChildFragmentManager(), "onlycards");
                addCardFragment.setDialogDismissListener(addCardDialogListener);


            } else {
                if (((PaymentMethod) data).type.equalsIgnoreCase("wallet") || ((PaymentMethod) data).type.equalsIgnoreCase("credit")) {
                    if (((PaymentMethod) data).balance > 0) {
                        if (((PaymentMethod) data).type.equalsIgnoreCase("paypal") && restaurant.paypal_minimum_order > Float.parseFloat(placeOrder.order_sub_total)) {
                            ToastUtils.makeSnackToast(getActivity(), "Paypal minimum order value is " + myApp.getCurrencySymbol() + MyApp.df.format(restaurant.paypal_minimum_order));
                            paymentMethod = null;
                        }

                        MyApp.getInstance().getMyPreferences().saveDefaultPaymentMethod((PaymentMethod) data);
                        paymentMethodsAdapter.selectedPaymentMethod = (PaymentMethod) data;
                        placeorderViewEnable(true);
                        paymentMethodsAdapter.notifyDataSetChanged();
                    } else {
                        ToastUtils.makeToast(getActivity(), "Insufficient balance, Please select other payment method");
                        paymentMethodsAdapter.notifyDataSetChanged();
                    }
                } else {
                    paymentMethodsAdapter.selectedPaymentMethod = (PaymentMethod) data;
                    MyApp.getInstance().getMyPreferences().saveDefaultPaymentMethod((PaymentMethod) data);
                    placeorderViewEnable(true);
                    paymentMethodsAdapter.notifyDataSetChanged();

                }
            }
        }

    }

    DialogDismissListener addCardDialogListener = new DialogDismissListener() {
        @Override
        public void onDialogDismiss(Object o) {
            paymentMethods.clear();
            savedCards.clear();
            CardArraylist.clear();
            fetchCards();
        }
    };

    private void placeorderViewEnable(boolean yes) {
        if (yes) {
            llPlaceOrder.setBackgroundResource(R.color.black);
            llPlaceOrder.setEnabled(true);
        } else {
            llPlaceOrder.setBackgroundResource(R.color.disabled_color);
            llPlaceOrder.setEnabled(false);
        }
    }

    protected void initViews(View view) {
        progressDialog = customProgressDialog(getActivity(), "Please wait...");
        loggedInUser = myApp.getMyPreferences().getLoggedInUser();
        rvMethods = view.findViewById(R.id.rvPaymentMethods);
        pbLoading = view.findViewById(R.id.pbLoading);
        lodingView = view.findViewById(R.id.lodingView);
        paymentMethodsAdapter = new PaymentMethodsAdapter(getActivity(), paymentMethods, onlyCards, this::methodClick);
        rvMethods.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));
        rvMethods.setAdapter(paymentMethodsAdapter);
        llPlaceOrder = view.findViewById(R.id.llPlaceOrder);
        tvOrderTotal = view.findViewById(R.id.tvOrderTotal);
        tvOrderTotal.setText("Total: " + currency + placeOrder.order_grand_total);
        tvWalletSplitName = view.findViewById(R.id.tvWalletSplitName);
        llSplitWalletMethod = view.findViewById(R.id.llWalletSplit);
        tvSplitWalletInfo = view.findViewById(R.id.tvWalletSplitInfo);
        ivCloseSplit = view.findViewById(R.id.ivCloseSplit);
        loggedInUser = myApp.getMyPreferences().getLoggedInUser();
    }

    public static AlertDialog customProgressDialog(Context context, String title) {
        AlertDialog alertDialog;
        AlertDialog.Builder builder = new AlertDialog.Builder(context);
        LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View dialogView = inflater.inflate(R.layout.progress_dialog_layout, null);
        TextView tvMessage = dialogView.findViewById(R.id.tvMessage);
        tvMessage.setVisibility(View.VISIBLE);
        if (!Validators.isNullOrEmpty(title)) {
            tvMessage.setText(title);
        }

        builder.setView(dialogView);
        builder.setCancelable(false);
        alertDialog = builder.create();
        alertDialog.getWindow().getDecorView().setBackgroundResource(android.R.color.transparent);
        alertDialog.getWindow().setDimAmount(0.0f);
        return alertDialog;
    }

    private void setListeners() {
        llPlaceOrder.setOnClickListener(view -> {
            validatePaymentMethod();
            if (isValidOrder())createOrder();
        });

        ivCloseSplit.setOnClickListener(view -> {
//            cartCalculations();
            llSplitWalletMethod.setVisibility(View.GONE);
            split = false;
            paidFull = true;
        });
    }

    boolean paidFull = true, split = false;

    private void createOrder() {
        if (paymentMethodsAdapter.selectedPaymentMethod !=null)
        if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("Stripe")) {
            createPaymentIntent();
        } else if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("paypal")) {
            Intent intent = new Intent(getActivity(), WebViewActivity.class);
            intent.putExtra("res_id", String.valueOf(restaurant_id));
            intent.putExtra("customer_id", String.valueOf(loggedInUser.id));
            if (split)
                intent.putExtra("amount", ""+(Float.parseFloat(placeOrder.order_grand_total) - loggedInUser.wallet_amount));
            else intent.putExtra("amount", placeOrder.order_grand_total);
            startActivityForResult(intent, CODE_PAYPAL);
        } else if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("wallet")) {
            if (loggedInUser.wallet_amount >= Float.parseFloat(placeOrder.order_grand_total)) {
                placeOrder();
            } else {
                ToastUtils.makeSnackToast(getActivity(), "Insufficient credit in wallet");
            }
        } else if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("cod")) {
            placeOrder();
        }
    }

    private HashMap<String, String> generatePaymentIntentParams() {
        HashMap<String, String> params = new HashMap<>();
        params.put("customer_id", String.valueOf(loggedInUser.id));
        if (split)
            params.put("amount", String.valueOf(Float.parseFloat(placeOrder.order_grand_total) - loggedInUser.wallet_amount));
        else
            params.put("amount", placeOrder.order_grand_total);
        params.put("stripe_token_id", paymentMethodsAdapter.selectedPaymentMethod.stripe_token_id);
        params.put("stripe_customer_id", paymentMethodsAdapter.selectedPaymentMethod.stripe_customer_id);
        params.put("restaurant_id", restaurant_id);
        if (restaurant.business.connect_service)
            params.put("service_type", "connect");
        else
            params.put("service_type", "normal");
        params.put("card_id", String.valueOf(paymentMethodsAdapter.selectedPaymentMethod.card_id));
        LogUtils.e("Payment Params: ", new Gson().toJson(params));
        return params;
    }

    private void createPaymentIntent() {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> progressDialog.show());
        }
        AndroidNetworking.post(ApiEndPoints.NEW_CARDS + "payment-intent").addBodyParameter(generatePaymentIntentParams())
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        LogUtils.e(new Gson().toJson(response));
                        try {
                            String paymentSecret = response.getString("payment_intent_id");
                            performStripePayment(paymentSecret);
                        } catch (JSONException e) {
                            e.printStackTrace();
                            if (restaurant.business.connect_service) {
                                ToastUtils.makeSnackToast(getActivity(), "Please select connect card");
                            } else {
                                ToastUtils.makeSnackToast(getActivity(), "Please select normal card");
                            }

                        }

                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("GENERATE PAYMENT INTENT ERROR");
                        if (restaurant.business.connect_service) {
                            ToastUtils.makeSnackToast(getActivity(), "Please select connect card");
                        } else {
                            ToastUtils.makeSnackToast(getActivity(), "Please select normal card");
                        }
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        }
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void performStripePayment(String paymentSecret) {
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> progressDialog.show());
        }
        ConfirmPaymentIntentParams confirmParams = ConfirmPaymentIntentParams
                .createWithPaymentMethodId(paymentMethodsAdapter.selectedPaymentMethod.stripe_token_id, paymentSecret);
        if (restaurant.business.connect_service) {
            stripe = new Stripe(getContext(), restaurant.business.connect_stripe_public_key);
        } else {
            stripe = new Stripe(getContext(), myApp.getStripePublishKey());
        }
        stripe.confirmPayment(this, confirmParams);
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == CODE_PAYPAL) {
            LogUtils.e("PAYPAL RETURN");
            managePaypalRespone(data);
        } else if (requestCode == CODE_REFRESH) {
            LogUtils.e("REFRESH");
        } else {
            if (data != null) {
                stripe.onPaymentResult(requestCode, data, new PaymentResultCallback(this));
            }
        }
    }

    private void managePaypalRespone(Intent data) {
        if (data != null) {
            Uri uri = Uri.parse(data.getStringExtra("url"));
            boolean success = data.getBooleanExtra("success", false);
            if (success) {
                LogUtils.e("LAST::", uri.getLastPathSegment());
                ToastUtils.makeSnackToast(getActivity(), "Payment successful");
                transactionId = uri.getLastPathSegment();
                placeOrder.transaction_id = transactionId;
                placeOrder();
            } else {
                LogUtils.e(uri.toString());
                ToastUtils.makeSnackToast(getActivity(), "Payment failed");
            }

        } else {
            LogUtils.e("DATA NULL");
            ToastUtils.makeSnackToast(getActivity(), "Payment cancelled");
        }
    }

    private static final class PaymentResultCallback
            implements ApiResultCallback<PaymentIntentResult> {

        @NonNull
        private final WeakReference<PaymentMethodsFragmentNew> activityRef;

        PaymentResultCallback(PaymentMethodsFragmentNew activity) {
            activityRef = new WeakReference<PaymentMethodsFragmentNew>(activity);
            final PaymentMethodsFragmentNew a = activityRef.get();
            if (activity.getActivity() != null && !activity.getActivity().isFinishing())
                a.progressDialog.show();
        }


        @Override
        public void onSuccess(@NonNull PaymentIntentResult result) {
            final PaymentMethodsFragmentNew activity = activityRef.get();
            if (activity == null) {
                return;
            }
            PaymentIntent paymentIntent = result.getIntent();
            activity.managePaymentResponse(paymentIntent);
        }

        @Override
        public void onError(@NonNull Exception e) {
            final PaymentMethodsFragmentNew activity = activityRef.get();
            if (activity == null) {
                return;
            }

            if (activity.getActivity() != null && !activity.getActivity().isFinishing())
                activity.progressDialog.dismiss();
            // Payment request failed – allow retrying using the same payment method
            ToastUtils.makeSnackToast(activity.getActivity(), "Payment request failed");
        }

    }

    private void managePaymentResponse(PaymentIntent paymentIntent) {
        PaymentIntent.Status status = paymentIntent.getStatus();
        if (status == PaymentIntent.Status.Succeeded) {
            // Payment completed successfully
            ToastUtils.makeSnackToast(getActivity(), "Payment successful");
            transactionId = paymentIntent.getId();
            placeOrder.transaction_id = transactionId;
            placeOrder();
        } else if (status == PaymentIntent.Status.RequiresPaymentMethod) {
            // Payment failed
            if (getActivity() != null && !getActivity().isFinishing())
                progressDialog.dismiss();
            ToastUtils.makeSnackToast(getActivity(), "Card authentication failed, Please retry");
        }
    }

    private void validatePaymentMethod() {
        loggedInUser = myApp.getMyPreferences().getLoggedInUser();
        if (getActivity() != null) {
            getActivity().runOnUiThread(() -> {
                if (paymentMethodsAdapter.selectedPaymentMethod != null) {
                    if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("wallet") || paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("credit")) {
                        split = true;
                        if (loggedInUser.wallet_amount < Float.parseFloat(placeOrder.order_grand_total)) {
                            paymentMethod = null;
                            paidFull = false;
                            llSplitWalletMethod.setVisibility(View.VISIBLE);
                            tvOrderTotal.setText(String.format("Total: %s%s", currency, placeOrder.order_grand_total));
                            tvSplitWalletInfo.setText(String.format("To pay remaining %s%s, Please select another payment method", currency, MyApp.df.format(Float.parseFloat(placeOrder.order_grand_total) - loggedInUser.wallet_amount)));
                            tvWalletSplitName.setText(String.format("Tiffintom Credit (%s%s)", currency, MyApp.df.format(loggedInUser.wallet_amount)));
                            paymentMethodsAdapter.selectedPaymentMethod=null;
                            MyApp.getInstance().getMyPreferences().saveDefaultPaymentMethod(null);
                            placeorderViewEnable(false);
                            paymentMethodsAdapter.notifyDataSetChanged();
                        } else {
                            paidFull = true;
                            llSplitWalletMethod.setVisibility(View.GONE);
                        }

                    } else {
                        llSplitWalletMethod.setVisibility(View.GONE);
                    }

                } else {
                    llSplitWalletMethod.setVisibility(View.GONE);
                }
            });
        }
    }

    private void setPaymentParams() {
        placeOrder.payment_method = paymentMethodsAdapter.selectedPaymentMethod.type;
        if (split) { // Here split means first time wallet was selected;
            placeOrder.split_payment = "Yes";
            placeOrder.payment_wallet = "Yes";
            placeOrder.wallet_amount = MyApp.df.format(loggedInUser.wallet_amount);
        } else {
            placeOrder.payment_wallet = "No";
            placeOrder.split_payment = "No";
        }
        if (paidFull)
            placeOrder.paid_full = "Yes";
        else placeOrder.paid_full = "No";

        if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("stripe")) {
            placeOrder.card_id = String.valueOf(paymentMethodsAdapter.selectedPaymentMethod.card_id);
        }
        if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("stripe") || paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("paypal")) {

            placeOrder.transaction_id = transactionId;
            if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("cod"))
                placeOrder.payment_status = "NP";
            placeOrder.payment_status = "P";
//            placeOrder.order_grand_total= String.valueOf(Total);
        }
    }

    private void placeOrder() {
        setPaymentParams();
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> progressDialog.show());
        AndroidNetworking.post(NEW_ORDERS)
                .addApplicationJsonBody(placeOrder)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        try {
                            String orderId = response.getString("id");
                            showOrderPlacedDialog(orderId);
                        } catch (JSONException e) {
                            e.printStackTrace();
                            ToastUtils.makeSnackToast(getActivity(), "You order placed successfully");
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("PLACE ORDER ERROR");
                        ToastUtils.makeSnackToast(getActivity(), "Something went wrong!");
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> progressDialog.dismiss());
                        if (!CommonFunctions.isConnected(getActivity()))
                            startActivityForResult(new Intent(getActivity(), NoInternetActivity.class), CODE_NO_INTERNET);
                    }
                });
    }

    private void showOrderPlacedDialog(String orderId) {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View dialogView = inflater.inflate(R.layout.dialog_order_placed, null);

        LottieAnimationView lottieAnimationView = dialogView.findViewById(R.id.animation_view);

        lottieAnimationView.addAnimatorListener(new Animator.AnimatorListener() {
            @Override
            public void onAnimationStart(Animator animator) {

            }

            @Override
            public void onAnimationEnd(Animator animator) {
                new Handler(Looper.myLooper()).postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        alertDialog.dismiss();
                        new Thread(() -> {
                            myApp.getMyPreferences().deleteOrderRestaurant();
                            myApp.getAppDatabase().cartDao().nukeTable();
                            CommonFunctions.notifyCartCount(getContext());
                        }).start();
                        startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "trackOrder").putExtra("order_id", orderId).putExtra("hideToolbar", true).putExtra("from", "cart").putExtra("OrderPlace", true));
                        if (getActivity() != null) getActivity().finish();
                        llPlaceOrder.setEnabled(true);
                    }
                }, 10);

            }

            @Override
            public void onAnimationCancel(Animator animator) {

            }

            @Override
            public void onAnimationRepeat(Animator animator) {

            }
        });
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();
    }
    private boolean isValidOrder() {
        if (paymentMethodsAdapter.selectedPaymentMethod !=null)
        {
            if (paymentMethodsAdapter.selectedPaymentMethod.type.equalsIgnoreCase("cod") && (myApp.getMyPreferences().getSiteSettings().signup_verify.equalsIgnoreCase("1") && myApp.getMyPreferences().getLoggedInUser().phone_verify.equalsIgnoreCase("false"))) {
                PhoneOrEmailVerificationBottomsheet phoneOrEmailVerificationBottomsheet = PhoneOrEmailVerificationBottomsheet.getInstance(loggedInUser.phone_number, loggedInUser.id, loggedInUser.username, "phone");
                phoneOrEmailVerificationBottomsheet.show(getChildFragmentManager(), "verify phone");
                phoneOrEmailVerificationBottomsheet.setDialogDismissListener(o ->
                {
                    paymentMethods.clear();
                    savedCards.clear();
                    CardArraylist.clear();
                    fetchProfile(true);
                });
                return false;
            }
        }
        return true;
    }

}
