package com.tiffintom.fragment;

import android.animation.Animator;
import android.animation.ValueAnimator;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.LinearInterpolator;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.cardview.widget.CardView;
import androidx.core.widget.NestedScrollView;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.swiperefreshlayout.widget.SwipeRefreshLayout;

import com.airbnb.lottie.LottieAnimationView;
import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONObjectRequestListener;
import com.google.gson.Gson;
import com.iarcuschin.simpleratingbar.SimpleRatingBar;
import com.tiffintom.MyApp;
import com.tiffintom.R;
import com.tiffintom.activity.MainActivity;
import com.tiffintom.adapters.OrderHistoryCartAdapter;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.common.CommonFunctions;
import com.tiffintom.common.Validators;
import com.tiffintom.indicator.IndicatorView;
import com.tiffintom.models.HistoryCart;
import com.tiffintom.models.OrderDetail;
import com.tiffintom.models.PaymentMethod;
import com.tiffintom.models.Reservation;
import com.tiffintom.models.Review;
import com.tiffintom.models.User;
import com.tiffintom.network.ApiEndPoints;
import com.tiffintom.notification.Config;
import com.tiffintom.utils.LogUtils;
import com.tiffintom.utils.ToastUtils;

import org.json.JSONObject;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;

import static com.tiffintom.network.ApiEndPoints.NEW_BOOKING;
import static com.tiffintom.network.ApiEndPoints.NEW_ORDERS;

/**
 * Created by Amrish on 08-09-2020.
 */
public class TrackOrderFragment extends BaseFragment {
    public static TrackOrderFragment getInstance() {
        return new TrackOrderFragment();
    }

    private TextView tvScreenTitle, tvTitle, tvPaymentMethodName, tvCardDetails, tvTotal, tvInstructions, tvOrderThankyouMessage,tvOrderNo;
    private ImageView ivBackArrow, ivMethod;

    private SwipeRefreshLayout swipeRefreshLayout;
    private NestedScrollView nestedScrollView;
    private ArrayList<HistoryCart> carts = new ArrayList<>();
    private OrderHistoryCartAdapter cartAdapter;
    private User loggedInUser = myApp.getMyPreferences().getLoggedInUser();
    private OrderDetail orderDetails;
    private Reservation reservationDetails;
    private DecimalFormat df = new DecimalFormat("#.##");
    private String orderId,reservation_id,booking_id;
    private RecyclerView rvCartItems;
    private CardView cvHome;
    private IndicatorView stateProgressBar;
    private ImageView ivFirst, ivSecond;
    private FrameLayout flBike;
    private LottieAnimationView order_StatusView;
    private TextView tvReservationPhone,tvReservtionGuest,tvReservationDateTime,tvReservationName,tvReservationEmail,tvSubTotal, tvServiceFee, tvDiscount, tvDeliveryfee, tvCharityAmount, tvTipAmount, tvCharityMessage, tvInstructionTitle, tvWalletAmount, tvRewardDiscount, tvRewardDiscountLabel;
    private LinearLayout ll_Instruction, ll_SubTotal, ll_ServiceFee, ll_DiscountAmount, ll_DeliveryFee, ll_Charity, ll_TipAmount, ll_WalletAmount, llRewardDiscount,ll_OrderCalculation,ll_ReservationDetails;
    private LinearLayout cvInstructions;
    private LinearLayout llBackArrow;
    private BroadcastReceiver broadcastReceiver;
    private boolean firstTime = true;
    private boolean shouldRate;
    private CardView cvAddReview;
    private String from;
    private RelativeLayout rlToolbar;
    private ArrayList<String> stateDescriptionData;
    public boolean OrderPlace=false;
    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if (getArguments() != null) {
            orderId = getArguments().getString("order_id");
            reservation_id = getArguments().getString("reservation_id");
            booking_id = getArguments().getString("booking_id");
            from = getArguments().getString("from");
            shouldRate = getArguments().getBoolean("shouldRate");
            OrderPlace = getArguments().getBoolean("OrderPlace");

        }
        return inflater.inflate(R.layout.fragment_track_order, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        fetchData();
      swipeRefreshLayout.setOnRefreshListener(this::fetchData);
        llBackArrow.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (OrderPlace)
                {
                    startActivity(new Intent(getActivity(), MainActivity.class).setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP));
                }else
                {
                    getActivity().onBackPressed();
                }
            }});
        cvAddReview.setOnClickListener(view1 -> openReviewDialog());
        cvHome.setOnClickListener(view1 -> startActivity(new Intent(getActivity(), MainActivity.class).setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP)));
        broadcastReceiver = new BroadcastReceiver() {
            public void onReceive(Context context, Intent intent) {
                boolean check_update = intent.getBooleanExtra("refresh", false);
                if (check_update) {
                    fetchData();
                }
            }
        };
        if (from != null && from.equalsIgnoreCase("cart")) {
            rlToolbar.setVisibility(View.GONE);
        }
    }
    @Override
    protected void initViews(View view) {
        super.initViews(view);

        view.setFocusableInTouchMode(true);
        view.requestFocus();
        view.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View v, int keyCode, KeyEvent event) {
               if( keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_UP) {
               if (OrderPlace)
               {
                   startActivity(new Intent(getActivity(), MainActivity.class).setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP));
               }else
               {
                   getActivity().onBackPressed();
               }
                    return true;
                }
                return false;
            }
        });
        rlToolbar = view.findViewById(R.id.rlToolbar);
        tvUserName = view.findViewById(R.id.tvUserName);
        tvScreenTitle = view.findViewById(R.id.tvScreenTitle);
        ivBackArrow = view.findViewById(R.id.ivBackArrow);
        llBackArrow = view.findViewById(R.id.llBackArrow);
        swipeRefreshLayout = view.findViewById(R.id.swipeRefreshLayout);
        nestedScrollView = view.findViewById(R.id.nestedScrollView);
        tvTotal = view.findViewById(R.id.tvTotal);
        tvInstructions = view.findViewById(R.id.tvInstructions);

        tvTitle = view.findViewById(R.id.tvTitle);
        tvOrderThankyouMessage = view.findViewById(R.id.tvOrderThankYouMessage);
        tvOrderNo= view.findViewById(R.id.tvOrderNo);
        tvPaymentMethodName = view.findViewById(R.id.tvPaymentMethodName);
        tvCardDetails = view.findViewById(R.id.tvCardDetails);
        ivMethod = view.findViewById(R.id.ivMethod);
        cvHome = view.findViewById(R.id.cvHome);
        cvAddReview = view.findViewById(R.id.cvAddReview);
        stateProgressBar = view.findViewById(R.id.stateProgressBar);
        //  stateProgressBar.setStateDescriptionTypeface("fonts/avenir_normal.otf");
        flBike = view.findViewById(R.id.flBike);
        ivFirst = view.findViewById(R.id.first);
        ivSecond = view.findViewById(R.id.second);
        order_StatusView = view.findViewById(R.id.order_statusView);
        rvCartItems = view.findViewById(R.id.rvCartItems);
        rvCartItems.setNestedScrollingEnabled(false);

        rvCartItems.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));
        cartAdapter = new OrderHistoryCartAdapter(carts, true);
        rvCartItems.setAdapter(cartAdapter);

        tvSubTotal = view.findViewById(R.id.tvSubtotal);
        tvServiceFee = view.findViewById(R.id.tvServiceFee);
        tvDiscount = view.findViewById(R.id.tvDiscount);
        ll_DiscountAmount = view.findViewById(R.id.ll_Discount);
        tvRewardDiscount = view.findViewById(R.id.tvRewardDiscount);
        tvRewardDiscountLabel = view.findViewById(R.id.tvRewardDiscountLabel);
        llRewardDiscount = view.findViewById(R.id.llRewardDiscount);
        tvDeliveryfee = view.findViewById(R.id.tvDeliveryFee);
        tvCharityAmount = view.findViewById(R.id.tvCharityAmount);
        tvCharityMessage = view.findViewById(R.id.tvCharityMessage);
        tvTipAmount = view.findViewById(R.id.tvTipAmount);
        ll_ServiceFee = view.findViewById(R.id.ll_ServiceCharge);
        ll_DeliveryFee = view.findViewById(R.id.ll_Delivery);
        ll_TipAmount = view.findViewById(R.id.ll_TipAmount);
        ll_Charity = view.findViewById(R.id.ll_CharityAmount);
        ll_Instruction= view.findViewById(R.id.ll_Instruction);
        tvInstructionTitle = view.findViewById(R.id.tvInstructionsTitle);
        cvInstructions = view.findViewById(R.id.cvInstruction);
        ll_WalletAmount = view.findViewById(R.id.ll_WalletAmount);
        tvWalletAmount = view.findViewById(R.id.tvWalletAmount);
        ll_OrderCalculation= view.findViewById(R.id.ll_OrderCalculation);
        ll_ReservationDetails= view.findViewById(R.id.ll_ReservationDetails);
        tvReservationName= view.findViewById(R.id.tvReservationName);
        tvReservationEmail= view.findViewById(R.id.tvReservationEmail);
        tvReservationPhone= view.findViewById(R.id.tvReservationPhone);
        tvReservtionGuest= view.findViewById(R.id.tvReservtionGuest);
        tvReservationDateTime= view.findViewById(R.id.tvReservationDateTime);

        tvOrderNo.setPaintFlags(Paint.UNDERLINE_TEXT_FLAG);
    }

    private void fetchData() {
        if (reservation_id==null) new Thread(this::fetchOrder).start();
        else new Thread(this::fetchReservation).start();
    }

    private void fetchOrder() {
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> {
                swipeRefreshLayout.setRefreshing(true);
                nestedScrollView.setVisibility(View.GONE);
            });
        AndroidNetworking.get(NEW_ORDERS+orderId).build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                swipeRefreshLayout.setRefreshing(false);
                                nestedScrollView.setVisibility(View.VISIBLE);
                            });

                        orderDetails = new Gson().fromJson(response.toString(), OrderDetail.class);
                        updateViews();
                        firstTime = false;


                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("ERROR IN ORDER VIEW");
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> swipeRefreshLayout.setRefreshing(false));

                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }

    private void fetchReservation() {
        if (getActivity() != null)
            getActivity().runOnUiThread(() -> {
                swipeRefreshLayout.setRefreshing(true);
                nestedScrollView.setVisibility(View.GONE);
            });
        AndroidNetworking.get(NEW_BOOKING +reservation_id).build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                swipeRefreshLayout.setRefreshing(false);
                                nestedScrollView.setVisibility(View.VISIBLE);
                            });

                        reservationDetails = new Gson().fromJson(response.toString(), Reservation.class);
                        updateBookingViews();
                        firstTime = false;
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        LogUtils.e("ERROR IN ORDER VIEW");
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> swipeRefreshLayout.setRefreshing(false));

                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });
    }


    private void updateViews() {
        if (orderDetails != null) {
            PaymentMethod paymentMethod = new PaymentMethod();
            paymentMethod.type = orderDetails.payment_method;
            tvOrderNo.setText("Order#"+orderDetails.order_number);
            tvCardDetails.setVisibility(View.GONE);
            if (orderDetails.payment_method != null && orderDetails.payment_method.equalsIgnoreCase("stripe")) {
                if (orderDetails.cardDetails != null && !Validators.isNullOrEmpty(orderDetails.cardDetails.card_brand)) {
                    paymentMethod.card_brand = orderDetails.cardDetails.card_brand;
                    tvCardDetails.setText(String.format("**** %s", orderDetails.cardDetails.card_number));
                    tvCardDetails.setVisibility(View.VISIBLE);
                } else {
                    tvCardDetails.setVisibility(View.GONE);
                }
                tvPaymentMethodName.setText(String.format("%s%s Paid via Credit/Debit card", myApp.getCurrencySymbol(), MyApp.df.format((orderDetails.order_grand_total) - orderDetails.wallet_amount)));
            } else if (orderDetails.payment_method.equalsIgnoreCase("paypal")) {
                tvPaymentMethodName.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format((orderDetails.order_grand_total) - orderDetails.wallet_amount) + " Paid via Paypal"));
            } else if (orderDetails.payment_method.equalsIgnoreCase("cod")) {
                tvPaymentMethodName.setText(String.format("%s\n%s","Cash Payment",(orderDetails.payment_status.equalsIgnoreCase("NP")? "Unpaid" :"Paid")));

            } else if (orderDetails.payment_method.equalsIgnoreCase("wallet") || orderDetails.payment_method.equalsIgnoreCase("credit")) {
                tvPaymentMethodName.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format((orderDetails.order_grand_total) - orderDetails.wallet_amount) + " Paid via Tiffintom Credit"));

            }
            tvSubTotal.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.order_sub_total)));
            if (orderDetails.service_charge > 0) {
                tvServiceFee.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.service_charge)));
            }

            if (orderDetails.voucher_amount + orderDetails.offer_amount > 0) {
                ll_DiscountAmount.setVisibility(View.VISIBLE);
            } else {
                ll_DiscountAmount.setVisibility(View.GONE);
            }
            tvDiscount.setText(String.format("-%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.voucher_amount + orderDetails.offer_amount)));
            if (orderDetails.reward_used.equalsIgnoreCase("yes") || orderDetails.reward_used.equalsIgnoreCase("y")) {
                llRewardDiscount.setVisibility(View.VISIBLE);
                tvRewardDiscountLabel.setText(String.format("Reward discount (%s%%)", MyApp.df.format(orderDetails.reward_offer_percentage)));
                tvRewardDiscount.setText(String.format("-%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.reward_offer)));
            } else {
                llRewardDiscount.setVisibility(View.GONE);
            }
            if (orderDetails.order_type.equals("delivery")) {

                if (orderDetails.tip_amount > 0) {
                    tvTipAmount.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.tip_amount)));
                } else
                    ll_TipAmount.setVisibility(View.GONE);

                tvDeliveryfee.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.delivery_charge)));
            } else {
                ll_TipAmount.setVisibility(View.GONE);
                ll_DeliveryFee.setVisibility(View.GONE);
            }

            if (orderDetails.charity_amount > 0) {
                tvCharityAmount.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.charity_amount)));
                tvCharityMessage.setText(orderDetails.charity_message);
            } else {
                ll_Charity.setVisibility(View.GONE);
            }

            if (orderDetails.wallet_amount > 0)
                tvWalletAmount.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.wallet_amount)));
            else
                ll_WalletAmount.setVisibility(View.GONE);


            tvTotal.setText(String.format("%s%s", myApp.getCurrencySymbol(), MyApp.df.format(orderDetails.order_grand_total)));

            if (Validators.isNullOrEmpty(orderDetails.order_description)) {
                tvInstructionTitle.setVisibility(View.GONE);
                cvInstructions.setVisibility(View.GONE);
            } else {
                tvInstructionTitle.setVisibility(View.VISIBLE);
                cvInstructions.setVisibility(View.VISIBLE);
                tvInstructions.setText((orderDetails.order_description));
            }

            ivMethod.setImageResource(myApp.paymentMethodLogo(paymentMethod));
            carts.clear();
            carts.addAll(orderDetails.cart_view);
            cartAdapter.notifyDataSetChanged();
            String message = "";
            if (orderDetails.status.equalsIgnoreCase("pending")) {
                tvTitle.setText("Your order has been placed");
                message = ("Thank you, your order has been successfully placed. Please wait for the restaurant to confirm your order and $order_type time. ");
            } else if (orderDetails.status.equalsIgnoreCase("accepted")) {
                tvTitle.setText("Your order has been accepted");
                message = ("Your order has been accepted, please wait while they prepare your food.");
            } else if (orderDetails.status.equalsIgnoreCase("waiting") || orderDetails.status.equalsIgnoreCase("driver accepted")) {
                tvTitle.setText("Your order is getting prepared");
                message = ("Your meal is being cooked up by the chef.  ");
            } else if (orderDetails.status.equalsIgnoreCase("collected")) {
                tvTitle.setText("Your order is on the way");
                message = ("Sit tight, your meal is on its way to you. ");
            } else if (orderDetails.status.equalsIgnoreCase("delivered")) {
                message = "Enjoy your meal. Remember to leave a review once your finished.";
                if (orderDetails.order_type.equals("delivery")) {
                    tvTitle.setText("Your order has been delivered");
                } else {
                    tvTitle.setText("Your order has been collected");
                }
            } else if (orderDetails.status.equalsIgnoreCase("cancel") || orderDetails.status.equalsIgnoreCase("rejected") || orderDetails.status.equalsIgnoreCase("failed")) {
                tvTitle.setText("We are sorry but, your order has been rejected");
            }
            if (message.isEmpty()) {
                tvOrderThankyouMessage.setVisibility(View.GONE);
            } else {
                tvOrderThankyouMessage.setVisibility(View.VISIBLE);
            }
            tvOrderThankyouMessage.setText(message.replace("$order_type", orderDetails.order_type.equalsIgnoreCase("delivery") ? "delivery" : "pickup"));
            setUpStepperAndAnimation();
            if (firstTime && shouldRate) {
                openReviewDialog();
            }
            if (orderDetails.status.equalsIgnoreCase("delivered")) {
                if (orderDetails.reviews != null ) {
                    Review review = orderDetails.reviews;
                    if (review.customer_id == MyApp.getInstance().getMyPreferences().getLoggedInUser().id) {
                        cvAddReview.setVisibility(View.GONE);
                    } else {
                        cvAddReview.setVisibility(View.VISIBLE);
                    }
                    cvAddReview.setVisibility(View.GONE);
                } else {
                    cvAddReview.setVisibility(View.VISIBLE);
                }
            } else {
                cvAddReview.setVisibility(View.GONE);
            }
        }
    }
    private void updateBookingViews() {
        try {
            if (reservationDetails != null) {
                tvReservationName.setText("Name: " + reservationDetails.customer_name);
                tvReservationEmail.setText("Email: " + reservationDetails.booking_email);
                tvReservationPhone.setText("Phone number: " + reservationDetails.booking_phone);
                tvReservtionGuest.setText("Guest count: " + reservationDetails.guest_count);
                tvReservationDateTime.setText("Date and time: " + CommonFunctions.formatDate(reservationDetails.booking_date, "yyyy-MM-dd", "dd MMM yyyy") + " at " + reservationDetails.booking_time);
                String message = "";
                ll_OrderCalculation.setVisibility(View.GONE);
                ll_ReservationDetails.setVisibility(View.VISIBLE);
                cvAddReview.setVisibility(View.GONE);
                ll_Instruction.setVisibility(View.GONE);

                tvOrderNo.setText(reservationDetails.booking_id);
                if (reservationDetails.status.equalsIgnoreCase("pending")) {
                    tvTitle.setText("Your reservation has been placed");
                    message = ("Thank you, your reservation has been successfully placed. Please wait for the restaurant to confirm your reservation and booking time. ");
                } else if (reservationDetails.status.equalsIgnoreCase("approved")) {
                    tvTitle.setText("Your reservation has been approved");
                    message = "Your reservation from " + reservationDetails.restaurant.restaurant_name + " has been approved";
                } else if (reservationDetails.status.equalsIgnoreCase("cancel") || reservationDetails.status.equalsIgnoreCase("rejected") || reservationDetails.status.equalsIgnoreCase("failed")) {
                    tvTitle.setText("We are sorry but, your reservation from " + reservationDetails.restaurant.restaurant_name + " has been rejected");
                }
                if (message.isEmpty()) {
                    tvOrderThankyouMessage.setVisibility(View.GONE);
                } else {
                    tvOrderThankyouMessage.setVisibility(View.VISIBLE);
                }
                tvOrderThankyouMessage.setText(message);
                setUpStepperAndAnimation();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private void setUpStepperAndAnimation() {
        if (orderDetails != null) {
            stateProgressBar.setVisibility(View.VISIBLE);
            String[] deliveryStatus = {"Order\nPlaced", "Order has\nbeen accepted", "Preparing", "On the way", "Delivered"};
            String[] pickupStatus = {"Order\nPlaced", "Order has\nbeen accepted", "Collected"};
            String[] rejectedStatus={null};
            for (HistoryCart historyCart:carts)
            {
                rejectedStatus = new String[]{"Sorry, but your order from " + historyCart.restaurant.restaurant_name + "\n cannot be accepted at the moment"};

            }

            if (orderDetails.order_type.equalsIgnoreCase("delivery")) {

                if (!Validators.isNullOrEmpty(orderDetails.preparation) && (orderDetails.status.equalsIgnoreCase("pending") || orderDetails.status.equalsIgnoreCase("accepted") || orderDetails.status.equalsIgnoreCase("waiting") || orderDetails.status.equalsIgnoreCase("driver accepted"))) {
                    deliveryStatus[2] = "Preparing \nDue " + orderDetails.preparation;

                } else if (!Validators.isNullOrEmpty(orderDetails.preparation) && (orderDetails.status.equalsIgnoreCase("collected") || orderDetails.status.equalsIgnoreCase("delivered"))) {
                    deliveryStatus[2] = "Prepared";
                }
                stateDescriptionData = new ArrayList<>(Arrays.asList(deliveryStatus));
                stateProgressBar.setTexts(stateDescriptionData);
            } else {
                stateDescriptionData = new ArrayList<>(Arrays.asList(pickupStatus));
                stateProgressBar.setTexts(stateDescriptionData);
                stateProgressBar.setCurrentItem(3);
            }

            if (orderDetails.status.equalsIgnoreCase("pending")) {
                stateProgressBar.setCurrentItem(1);
                order_StatusView.setAnimation(R.raw.order_waiting);
            }
            if (orderDetails.status.equalsIgnoreCase("accepted")) {
                stateProgressBar.setCurrentItem(2);
                order_StatusView.setAnimation(R.raw.order_placed);
            }
            if (orderDetails.status.equalsIgnoreCase("waiting") || orderDetails.status.equalsIgnoreCase("driver accepted")) {
                stateProgressBar.setCurrentItem(3);
                order_StatusView.setAnimation(R.raw.preparing_food);
            }
            if (orderDetails.status.equalsIgnoreCase("collected")) {
                stateProgressBar.setCurrentItem(4);
                order_StatusView.setAnimation(R.raw.on_the_way_order);
            }
            if (orderDetails.status.equalsIgnoreCase("delivered")) {
                if (orderDetails.order_type.equalsIgnoreCase("delivery")) {
                    stateProgressBar.setCurrentItem(5);
                } else {
                    stateProgressBar.setCurrentItem(3);
                }
                order_StatusView.setAnimation(R.raw.food_delivered);
            }
            if (orderDetails.status.equalsIgnoreCase("cancel") || orderDetails.status.equalsIgnoreCase("rejected") || orderDetails.status.equalsIgnoreCase("failed")) {
                order_StatusView.setAnimation(R.raw.order_rejected);
                stateDescriptionData = new ArrayList<>(Arrays.asList(rejectedStatus));
                stateProgressBar.setTexts(stateDescriptionData);
                stateProgressBar.setCurrentItem(1);
            }
            order_StatusView.playAnimation();


            final ValueAnimator animator = ValueAnimator.ofFloat(0.0f, 1.0f);
            animator.setRepeatCount(ValueAnimator.INFINITE);
            animator.setInterpolator(new LinearInterpolator());
            animator.setDuration(9000L);
            animator.addUpdateListener(new ValueAnimator.AnimatorUpdateListener() {
                @Override
                public void onAnimationUpdate(ValueAnimator animation) {
                    final float progress = (float) animation.getAnimatedValue();
                    final float width = ivFirst.getWidth();
                    final float translationX = width * progress;
                    ivFirst.setTranslationX(translationX);
                    ivSecond.setTranslationX(translationX - width);
                }
            });
            animator.start();

        }else if (reservationDetails != null) {
            stateProgressBar.setVisibility(View.VISIBLE);
            String[] reservationStatus = {"Reservation Placed", "Reservation Accepted"};
            String[] rejectedStatus = {"Sorry, but your reservation from " + reservationDetails.restaurant.restaurant_name + "\n cannot be accepted at the moment"};

            stateDescriptionData = new ArrayList<>(Arrays.asList(reservationStatus));
            stateProgressBar.setTexts(stateDescriptionData);
            stateProgressBar.setCurrentItem(2);

            if (reservationDetails.status.equalsIgnoreCase("pending")) {
                stateProgressBar.setCurrentItem(1);
                order_StatusView.setAnimation(R.raw.order_waiting);
            }
            if (reservationDetails.status.equalsIgnoreCase("approved")) {
                stateProgressBar.setCurrentItem(2);
                order_StatusView.setAnimation(R.raw.food_delivered);
            }
            if (reservationDetails.status.equalsIgnoreCase("cancel") || reservationDetails.status.equalsIgnoreCase("rejected") || reservationDetails.status.equalsIgnoreCase("failed")) {
                order_StatusView.setAnimation(R.raw.order_rejected);
                stateDescriptionData = new ArrayList<>(Arrays.asList(rejectedStatus));
                stateProgressBar.setTexts(stateDescriptionData);
                stateProgressBar.setCurrentItem(1);
            }
            order_StatusView.playAnimation();
            final ValueAnimator animator = ValueAnimator.ofFloat(0.0f, 1.0f);
            animator.setRepeatCount(ValueAnimator.INFINITE);
            animator.setInterpolator(new LinearInterpolator());
            animator.setDuration(9000L);
            animator.addUpdateListener(animation -> {
                final float progress = (float) animation.getAnimatedValue();
                final float width = ivFirst.getWidth();
                final float translationX = width * progress;
                ivFirst.setTranslationX(translationX);
                ivSecond.setTranslationX(translationX - width);


            });
            animator.start();
        }
    }

    private void openReviewDialog() {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View dialogView = inflater.inflate(R.layout.dialog_write_review, null);

        SimpleRatingBar ratingBar = dialogView.findViewById(R.id.rating);
        EditText editText = dialogView.findViewById(R.id.et_Reviewtext);
        TextView tv_Cancel = dialogView.findViewById(R.id.tvCancel);
        TextView tv_Confirm = dialogView.findViewById(R.id.tvConfirm);
        TextView tv_Info = dialogView.findViewById(R.id.tvInfo);

        if (orderDetails.cart_view != null && orderDetails.cart_view.size() != 0) {
            {
              for (HistoryCart historyCart:orderDetails.cart_view)
              {
                  if (historyCart.restaurant !=null)
                  {
                      tv_Info.setText(new StringBuilder("How was your meal from ").append(historyCart.restaurant.restaurant_name).append("? \nLeave a review here."));

                  }
              }
            }
        }

        tv_Confirm.setOnClickListener(view -> {
            String review = editText.getText().toString();
            float ratings = ratingBar.getRating();
            if (ratings < 1) {
                ToastUtils.makeToast(getActivity(), "Please enter rating");
            } else {
                sendrating(ratings, review);
                alertDialog.dismiss();
            }

        });
        tv_Cancel.setOnClickListener(view -> alertDialog.dismiss());
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();

    }

    private void sendrating(float ratings, String review) {
        int rating=(int) ratings;
        progressDialog.show();
        AndroidNetworking.post(ApiEndPoints.NEW_REVIEWS)
                .addBodyParameter("order_id", String.valueOf(Integer.parseInt(orderId)))
                .addBodyParameter("customer_id", String.valueOf(loggedInUser.id))
                .addBodyParameter("restaurant_id",String.valueOf(orderDetails.restaurant_id))
                .addBodyParameter("responce", "")
                .addBodyParameter("rating", rating + "")
                .addBodyParameter("message", review)
                .addBodyParameter("order_type",orderDetails.order_type)
                .build()
                .getAsJSONObject(new JSONObjectRequestListener() {
                    @Override
                    public void onResponse(JSONObject response) {
                        if (getActivity() != null)
                            getActivity().runOnUiThread(() -> {
                                progressDialog.hide();
                            });
                              showReviewDone();
                    }

                    @Override
                    public void onError(ANError anError) {
                        anError.printStackTrace();
                        if (getActivity() != null)
                            progressDialog.hide();
                        ToastUtils.makeToast(getActivity(), "Something went wrong");

                        if (!CommonFunctions.isConnected(getActivity()))
                            myApp.noInternet(getActivity());
                    }
                });

    }

    private void showReviewDone() {
        AlertDialog alertDialog = new AlertDialog.Builder(getActivity()).create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        LayoutInflater inflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View dialogView = inflater.inflate(R.layout.dialog_order_placed, null);

        LottieAnimationView lottieAnimationView = dialogView.findViewById(R.id.animation_view);
        TextView tvMessage = dialogView.findViewById(R.id.tvMessage);
        lottieAnimationView.setAnimation(R.raw.review_star);
        tvMessage.setText("Review submitted successfully");
        lottieAnimationView.addAnimatorListener(new Animator.AnimatorListener() {
            @Override
            public void onAnimationStart(Animator animator) {

            }

            @Override
            public void onAnimationEnd(Animator animator) {
                new Handler(Looper.myLooper()).postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        alertDialog.dismiss();
                        new Thread(() -> {
                            fetchData();
                        }).start();

                    }
                }, 10);

            }

            @Override
            public void onAnimationCancel(Animator animator) {

            }

            @Override
            public void onAnimationRepeat(Animator animator) {

            }
        });
        alertDialog.setView(dialogView);
        alertDialog.setCancelable(false);
        alertDialog.show();
    }

    @Override
    public void onResume() {
        super.onResume();
        if (getActivity() != null && broadcastReceiver != null)
            LocalBroadcastManager.getInstance(getActivity()).registerReceiver(broadcastReceiver, new IntentFilter(Config.PUSH_NOTIFICATION));
    }

    @Override
    public void onStop() {
        if (getActivity() != null && broadcastReceiver != null)
            LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(broadcastReceiver);
        super.onStop();
    }
}
