package com.tiffintom.fragment.becompartner;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.viewpager.widget.ViewPager;

import com.make.dots.dotsindicator.DotsIndicator;
import com.tiffintom.R;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.adapters.ViewPagerAdepter;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.models.PostcodeViewPager;

import java.util.ArrayList;

public class BecomePartnerFragment extends BaseFragment {

    private ViewPager viewPager;
    private ViewPagerAdepter viewPagerAdepter;
    private DotsIndicator dotsIndicator;
    private Button btnCntinue;
    private ArrayList<PostcodeViewPager> partnerarraylist = new ArrayList<>();


    public static BecomePartnerFragment getInstance() {
        return new BecomePartnerFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_become_partner, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        setUpListners();
        setViews();
    }

    private void setUpListners() {
        viewPagerAdepter = new ViewPagerAdepter(getActivity(), partnerarraylist);
        viewPagerAdepter.registerDataSetObserver(dotsIndicator.getDataSetObserver());
        viewPager.setAdapter(viewPagerAdepter);

        dotsIndicator.setViewPager(viewPager);

        btnCntinue.setOnClickListener(view1 -> {
            startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "partnerdetail").putExtra("name", "Become a Partner"));
        });
    }

    private void setViews() {
        PostcodeViewPager model = new PostcodeViewPager();
        model.image = R.drawable.partner_icon1;
        model.title = "Get a free website";
        partnerarraylist.add(model);

        model = new PostcodeViewPager();
        model.image = R.drawable.appicon;
        model.title = "Get a free app";
        partnerarraylist.add(model);

        model = new PostcodeViewPager();
        model.image = R.drawable.marketing_icon;
        model.title = "Free marketing";
        partnerarraylist.add(model);

        model = new PostcodeViewPager();
        model.image = R.drawable.partner_icon4;
        model.title = "Free listing on TiffinTom";
        partnerarraylist.add(model);

        model = new PostcodeViewPager();
        model.image = R.drawable.partner_icon5;
        model.title = "No rental. No contract. \nNo commitment.";
        partnerarraylist.add(model);

        model = new PostcodeViewPager();
        model.image = R.drawable.partner_icon6;
        model.title = "Epos system";
        partnerarraylist.add(model);
        viewPagerAdepter.notifyDataSetChanged();
    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);

        viewPager = view.findViewById(R.id.viewPager);
        dotsIndicator = view.findViewById(R.id.dotsIndicator);
        btnCntinue = view.findViewById(R.id.btnContinue);


    }
}
