package com.tiffintom.fragment.becompartner;

import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.google.android.material.bottomsheet.BottomSheetDialogFragment;
import com.tiffintom.R;
import com.tiffintom.interfaces.DialogDismissListener;
import com.tiffintom.models.BecomePartner;

import static com.tiffintom.MyApp.becomePartner;

public class NumberOfLocationBottomSheetFragment extends BottomSheetDialogFragment {

    private ImageView iv_Increase, iv_Decrease;
    private TextView tv_LocationCount;
    private CheckBox cb_Location;
    private int count = 1;
    private String countdata;
    private Button btnConfirm;
    private DialogDismissListener dialogDismissListener;


    public static NumberOfLocationBottomSheetFragment getInstance() {
        return new NumberOfLocationBottomSheetFragment();
    }

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    @Override
    public int getTheme() {
        if (Build.VERSION.SDK_INT > 21) {
            return R.style.BottomSheetDialogTheme;
        } else {
            return super.getTheme();
        }
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_locationcount_bottomsheet, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initViews(view);
        setListners();
    }

    private void setListners() {
        iv_Increase.setOnClickListener(view1 -> {
            if ((count < 5)) {
                count++;
                tv_LocationCount.setText(count + "");
            }
        });

        iv_Decrease.setOnClickListener(view12 -> {
            if (count == 5 && cb_Location.isChecked()) {
                count--;
                tv_LocationCount.setText(count + "");
                cb_Location.setChecked(false);
            } else {
                if ((count > 1)) {
                    count--;
                    tv_LocationCount.setText(count + "");
                }
            }

        });

        cb_Location.setOnCheckedChangeListener((compoundButton, b) -> {
                    if (cb_Location.isChecked()) {
                        count = 5;
                        tv_LocationCount.setText("5");
                    }
                }
        );

        btnConfirm.setOnClickListener(view -> {
            if (becomePartner == null) becomePartner = new BecomePartner();
            if (cb_Location.isChecked()) {
                becomePartner.no_of_location = "5+";
            } else {
                becomePartner.no_of_location = String.valueOf(count);
            }
            if (dialogDismissListener != null) {
                dialogDismissListener.onDialogDismiss(becomePartner.no_of_location);
            }
            dismiss();
        });

    }

    private void initViews(View view) {

        iv_Increase = view.findViewById(R.id.ivIncrease);
        iv_Decrease = view.findViewById(R.id.ivDecrease);
        cb_Location = view.findViewById(R.id.cbLocation);
        tv_LocationCount = view.findViewById(R.id.tvLocation);
        btnConfirm = view.findViewById(R.id.btnConfirm);

        if (becomePartner != null && becomePartner.no_of_location != null) {
            if (becomePartner.no_of_location.equals("5+")) {
                cb_Location.setChecked(true);
                count = 5;
                tv_LocationCount.setText("5");
            } else {
                tv_LocationCount.setText(becomePartner.no_of_location);
                count = Integer.parseInt(becomePartner.no_of_location);
            }
        }
    }
}
