package com.tiffintom.fragment.becompartner;

import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.google.android.material.bottomsheet.BottomSheetDialogFragment;
import com.tiffintom.R;
import com.tiffintom.interfaces.DialogDismissListener;
import com.tiffintom.models.BecomePartner;
import com.tiffintom.utils.ToastUtils;

import static com.tiffintom.MyApp.becomePartner;

public class ProvideDeliveryBottomSheet extends BottomSheetDialogFragment {

    private RadioGroup rbRadio;
    private RadioButton rbDeliveryCollection, rbDelivery, rbCollection;
    private Button btnConfirm;
    private DialogDismissListener dialogDismissListener;

    public static ProvideDeliveryBottomSheet getInstance() {
        return new ProvideDeliveryBottomSheet();
    }

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    @Override
    public int getTheme() {
        if (Build.VERSION.SDK_INT > 21) {
            return R.style.BottomSheetDialogTheme;
        } else {
            return super.getTheme();
        }
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_providedeliver, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initViews(view);

        setListners();
    }

    private void setListners() {

        btnConfirm.setOnClickListener(view -> {
            if (rbDeliveryCollection.isChecked() || rbDelivery.isChecked() || rbCollection.isChecked()) {
                btnConfirm.setClickable(true);
                if (becomePartner == null) becomePartner = new BecomePartner();
                if (rbDeliveryCollection.isChecked())
                    becomePartner.deliver = rbDeliveryCollection.getText().toString();
                else if (rbDelivery.isChecked())
                    becomePartner.deliver = rbDelivery.getText().toString();
                else
                    becomePartner.deliver = rbCollection.getText().toString();

                if (dialogDismissListener != null) {
                    dialogDismissListener.onDialogDismiss(becomePartner.deliver);
                }
                dismiss();
            } else {
                ToastUtils.makeToast(getActivity(), "Please Select one option");
            }

        });
    }

    private void initViews(View view) {
        rbDeliveryCollection = view.findViewById(R.id.rbDeliveryCollection);
        rbDelivery = view.findViewById(R.id.rbDelivery);
        rbCollection = view.findViewById(R.id.rbCollection);
        rbRadio = view.findViewById(R.id.rbDeliveries);
        btnConfirm = view.findViewById(R.id.btnConfirm);

        if (becomePartner != null && becomePartner.deliver != null) {
            if (becomePartner.deliver.equals(rbDeliveryCollection.getText().toString()))
                rbDeliveryCollection.setChecked(true);
            else if (becomePartner.deliver.equals(rbDelivery.getText().toString()))
                rbDelivery.setChecked(true);
            else if (becomePartner.deliver.equals(rbCollection.getText().toString()))
                rbCollection.setChecked(true);

        }
    }


}
