package com.tiffintom.fragment.becompartner;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RadioButton;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.tiffintom.R;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.models.BecomePartner;
import com.tiffintom.utils.ToastUtils;

import static com.tiffintom.MyApp.becomePartner;

public class RecevingOrderFragment extends BaseFragment {

    private LinearLayout ll_Purchase, ll_Download;
    private RadioButton rb_Purchase, rb_Free;
    private Button btnNext, btnback;

    public static RecevingOrderFragment getInstance() {
        return new RecevingOrderFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_receive_order, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        setListner();
        updateView();
    }

    private void updateView() {
        if (becomePartner != null && becomePartner.payment != null) {
            if (becomePartner.payment.equals("paid"))
                rb_Purchase.setChecked(true);
            else
                rb_Free.setChecked(true);
        }
    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);

        ll_Purchase = view.findViewById(R.id.llPurchaseOrder);
        ll_Download = view.findViewById(R.id.llDownloadApp);
        rb_Purchase = view.findViewById(R.id.rbPurchase);
        btnNext = view.findViewById(R.id.btnNext);
        btnback = view.findViewById(R.id.btnBack);
        rb_Free = view.findViewById(R.id.rbFree);

        rb_Purchase.setText(myApp.getCurrencySymbol() + "150");
    }


    private void setListner() {


        ll_Purchase.setOnClickListener(view -> {
            rb_Purchase.setChecked(true);
            rb_Free.setChecked(false);
        });
        ll_Download.setOnClickListener(view -> {
            rb_Purchase.setChecked(false);
            rb_Free.setChecked(true);
        });


        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (isValid()) {
                    new Thread(this::goNext).start();
                } else {
                    ToastUtils.makeToast(getActivity(), "Please select a option");
                }
            }

            private void goNext() {

                if (becomePartner == null) becomePartner = new BecomePartner();
                if (rb_Purchase.isChecked()) {
                    becomePartner.payment = "paid";
                } else {
                    becomePartner.payment = "free";

                }
                startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "companydetail").putExtra("name", "Become a Partner"));
            }

        });

        btnback.setOnClickListener(view -> getActivity().onBackPressed());
    }

    private boolean isValid() {
        if (rb_Purchase.isChecked()) {
            return true;
        }
        if (rb_Free.isChecked()) {
            return true;
        }
        return false;
    }
}
