package com.tiffintom.fragment.becompartner;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.tiffintom.R;
import com.tiffintom.activity.TransportActivity;
import com.tiffintom.base.BaseFragment;
import com.tiffintom.models.BecomePartner;

import static com.tiffintom.MyApp.becomePartner;

public class SummeryFragment extends BaseFragment {

    private Button btnNext, btnBack;
    private TextView tvPayText1, tvPayText2, tvYouGetTitle;

    public static SummeryFragment getInstance() {
        return new SummeryFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_summery, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        setListner();
        updateView();
    }


    private void setListner() {
        if (becomePartner == null) becomePartner = new BecomePartner();

        btnBack.setOnClickListener(view -> getActivity().onBackPressed());
        btnNext.setOnClickListener(view -> {
            startActivity(new Intent(getActivity(), TransportActivity.class).putExtra("destination", "restaurant_agreement").putExtra("name", "Become a Partner"));

        });
    }

    private void updateView() {
        if (becomePartner != null && becomePartner.payment != null) {
            if (becomePartner.payment.equalsIgnoreCase("free")) {
                tvPayText1.setText("Get our app");
                tvPayText2.setText("Free");
                tvYouGetTitle.setText("TiffinTom partner app to manage orders");
            } else {
                tvYouGetTitle.setText("Portable order management device");
                tvPayText1.setText("Device fee");
                tvPayText2.setText(myApp.getCurrencySymbol() + "150");
            }
        }
    }


    @Override
    protected void initViews(View view) {
        super.initViews(view);
        tvYouGetTitle = view.findViewById(R.id.tvYouGetTitle);
        btnNext = view.findViewById(R.id.btnNext);
        btnBack = view.findViewById(R.id.btnBack);
        tvPayText1 = view.findViewById(R.id.tvPayTitle);
        tvPayText2 = view.findViewById(R.id.tvPayOrFree);
    }
}
