package com.tiffintom.indicator;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.RecyclerView;

import com.tiffintom.R;

import java.util.ArrayList;

/**
 * Created by Amrish on 29-10-2020.
 */
public class IndicatorRecyclerAdapter extends RecyclerView.Adapter<IndicatorRecyclerAdapter.IndicatorViewHolder> {

    public int activePosition = 0;
    public boolean showText = false;
    private ArrayList<String> names;

    public IndicatorRecyclerAdapter(ArrayList<String> names) {
        this.names = names;
    }

    @NonNull
    @Override
    public IndicatorViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new IndicatorViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.indicator_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull IndicatorViewHolder holder, int position) {

        String name = names.get(position);
        if (showText && name != null && !name.isEmpty()) {
            holder.tvText.setText(name);
            holder.tvText.setVisibility(View.VISIBLE);
        } else {
            holder.tvText.setVisibility(View.INVISIBLE);
        }
        if (position <= activePosition - 1) {
            holder.tvText.setTextColor(ContextCompat.getColor(holder.itemView.getContext(), R.color.colorPrimary));
            holder.vLine.setBackgroundColor(ContextCompat.getColor(holder.itemView.getContext(), R.color.colorPrimary));
            holder.vDot.setBackgroundResource(R.drawable.indicator_selected);
        } else {
            holder.tvText.setTextColor(ContextCompat.getColor(holder.itemView.getContext(), R.color.dark_grey_color));
            holder.vLine.setBackgroundColor(ContextCompat.getColor(holder.itemView.getContext(), R.color.dark_grey_color));
            holder.vDot.setBackgroundResource(R.drawable.indicator_unselected);
        }
    }

    @Override
    public int getItemCount() {
        return names.size();
    }

    protected static class IndicatorViewHolder extends RecyclerView.ViewHolder {

        private TextView tvText;
        private View vDot, vLine;

        public IndicatorViewHolder(@NonNull View itemView) {
            super(itemView);
            tvText = itemView.findViewById(R.id.tvText);
            vDot = itemView.findViewById(R.id.dot);
            vLine = itemView.findViewById(R.id.line);

        }
    }
}
