package com.tiffintom.models;

import androidx.room.Database;
import androidx.room.RoomDatabase;
import androidx.room.TypeConverters;
import androidx.room.migration.Migration;
import androidx.sqlite.db.SupportSQLiteDatabase;

import com.tiffintom.models.DineinModels.Addon;
import com.tiffintom.models.DineinModels.AddonDao;
import com.tiffintom.models.DineinModels.ArrayConvertersForDB;
import com.tiffintom.models.DineinModels.DineinOrderItem;
import com.tiffintom.models.DineinModels.OrderItem;
import com.tiffintom.models.DineinModels.OrderItemAddon;
import com.tiffintom.models.DineinModels.OrderItemIngredient;
import com.tiffintom.models.DineinModels.ProductAddonDao;
import com.tiffintom.models.DineinModels.ProductAddons;
import com.tiffintom.models.DineinModels.ProductIngredients;

@Database(entities = {CartItem.class, DineinCartItem.class, OrderItemAddon.class, OrderItemIngredient.class, OrderItem.class, Addon.class, ProductAddons.class, ProductIngredients.class
        , DineinOrderItem.class}, version = 2,exportSchema = false)
@TypeConverters({ArrayConvertersForDB.class})
public abstract class AppDatabase extends RoomDatabase {
    public abstract CartItemDao cartDao();

    public abstract DineinCartItemDao dineinCartItemDao();

    public abstract OrderItemAddonDao orderItemAddonDao();

    public abstract OrderItemIngredientDao orderItemIngredientDao();

    public abstract OrderItemDao orderItemDao();

    public abstract AddonDao addonDao();

    public abstract ProductAddonDao productAddonDao();

    public abstract ProductIngredientDao productIngredientDao();

    public abstract DineinOrderItemDao dineinOrderItemDao();

    public static final Migration MIGRATION_1_2 = new Migration(1, 2) {
        @Override
        public void migrate(SupportSQLiteDatabase database) {

        }
    };

}