package com.tiffintom.models;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import java.util.List;

/**
 * Created by Amrish on 24-08-2020.
 */
@Dao
public interface CartItemDao {
    @Query("SELECT * FROM CartItem")
    List<CartItem> getAll();

    @Insert
    void insertAll(CartItem... cartItem);

    @Delete
    void delete(CartItem cartItem);

    @Query("SELECT SUM(quantity) as items, SUM(Total) as total FROM CartItem")
    CartSummary getCartSummary();

    @Update
    void update(CartItem cartItem);

    @Query("SELECT (SUM(quantity)) FROM cartitem WHERE menu_id=:menuId")
    int getMenuItemCartCounts(int menuId);

    @Query("SELECT res_id FROM cartitem GROUP BY res_id LIMIT 1")
    int getRestaurantId();

    @Query("DELETE FROM cartitem")
    void nukeTable();

    @Query("SELECT * FROM cartitem WHERE cartItemId=:id")
    CartItem getCartItem(int id);

    @Query("SELECT * FROM cartitem WHERE menu_id=:menuId AND menu_size=:variantName AND (Addon_name is null or Addon_name= '') ")
    CartItem getCartMenuItem(int menuId, String variantName);

    /*Created by Dipawali(Addon Quantity update)*/
    @Query("SELECT * FROM cartitem WHERE menu_id=:menuId AND menu_size=:variantName")
    CartItem getCartAddonMenuItem(int menuId, String variantName);
}
