package com.tiffintom.models.DineinModels;

import androidx.annotation.NonNull;
import androidx.room.ColumnInfo;
import androidx.room.Entity;
import androidx.room.Ignore;
import androidx.room.PrimaryKey;

import com.google.gson.Gson;

import java.util.ArrayList;

@Entity
public class OrderItem {

    @PrimaryKey(autoGenerate = true)
    public int _id;
    @ColumnInfo(index = true)
    public int _order_id;
    public int _order_split_id;

    public String id, product_id, product_name, product_short_name, product_description, order_id, updater_id, order_split_id, preparation_location_id;
    public String special_instruction, category_name;
    public float price, sub_total, addons_price, ingredients_price, instruction_price, total;
    public float web_price, delivery_price, takeaway_price, waiting_price;
    public int quantity = 1;
    public boolean sent_to_kitchen, misc, is_banquet;
    @Ignore
    public String created_at;//2022-02-01T09:34:27.000000Z
    @Ignore
    public String group_name;//null
    @ColumnInfo(name = "block_id")
    public String block_id;
    @NonNull
    public int menu_id;//for get _id
    @Ignore
    public String addon_name;
    @Ignore
    public ArrayList<OrderItemAddon> order_item_addons = new ArrayList<>();
    @Ignore
    public ArrayList<OrderItemIngredient> order_item_ingredients = new ArrayList<>();


    @Ignore
    public Product product;//get from created order responce

    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

}

