package com.tiffintom.models.DineinModels;

import androidx.room.ColumnInfo;
import androidx.room.Entity;
import androidx.room.ForeignKey;
import androidx.room.Ignore;
import androidx.room.PrimaryKey;

import java.util.Objects;

/**
 * Created by Aradhna on 29-12-2021.
 */
//For Custome use only
@Entity(foreignKeys = @ForeignKey(entity = OrderItem.class, parentColumns = {"_id"}, childColumns = {"_order_item_id"}, onDelete = ForeignKey.CASCADE))
public class OrderItemAddon {
    @PrimaryKey(autoGenerate = true)
    public int _id;
    @ColumnInfo(index = true)
    public int _order_item_id;

    public String category;//custome variable
    public String order_item_id, order_id, addon_id, addon_name, id;
    public int updater_id;
    public String special_instruction;
    public float price, total;
    public int quantity = 1;
    @Ignore
    public String created_at;
    @Ignore
    public Addon addon;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OrderItemAddon that = (OrderItemAddon) o;
        return Objects.equals(addon_id, that.addon_id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(addon_id);
    }
}
