package com.tiffintom.models.DineinModels;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;

import java.util.List;

@Dao
public interface ProductAddonDao {
    @Query("SELECT * FROM ProductAddons WHERE disabled=0 ORDER BY sequence ASC")
    public List<ProductAddons> list();

    @Query("SELECT * FROM ProductAddons WHERE product_id=:productId AND disabled=0 ORDER BY sequence ASC")
    public List<ProductAddons> listByProduct(String productId);

    @Query("SELECT * FROM ProductAddons where `id`=:id")
    public ProductAddons view(String id);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    public void insert(ProductAddons productAddon);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    public void insertMultiple(List<ProductAddons> productAddons);

    @Delete
    public void deleteMultiple(List<ProductAddons> productAddons);

    @Query("DELETE FROM ProductAddons")
    void deleteAll();
}
