package com.tiffintom.models;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import com.tiffintom.models.DineinModels.DineinOrderItem;

import java.util.List;

/**
 * Created by Amrish on 24-08-2020.
 */
@Dao
public interface DineinOrderItemDao {
    @Query("SELECT * FROM DineinOrderItem")
    List<DineinOrderItem> getAll();

    @Insert
    void insertAll(DineinOrderItem... item);

    @Delete
    void delete(DineinOrderItem item);

    @Query("SELECT SUM(quantity) as items, SUM(Total) as total FROM DineinOrderItem")
    CartSummary getCartSummary();

    @Update
    void update(DineinOrderItem item);

    @Query("SELECT (SUM(quantity)) FROM dineinorderitem WHERE product_id=:menuId")
    int getMenuItemCartCounts(int menuId);

    @Query("DELETE FROM dineinorderitem")
    void nukeTable();

    @Query("SELECT * FROM dineinorderitem WHERE product_id=:menuId")
    DineinOrderItem getCartMenuItem(int menuId);
}
