package com.tiffintom.models;

import com.tiffintom.common.Validators;

import java.util.ArrayList;
import java.util.Objects;

/**
 * Created by Amrish on 22-08-2020.
 */
public class MenuItem {
    public int id;//: 256,
    public int restaurant_id;//: 3,
    public int category_id;//: 29,
    public String menu_name;//: "Meat Samosa",
    public int is_suggest;//: 0,
    public String price_option;//: "single", multiple
    public String menu_description;//: "",
    public String image_url;//: null,
    public String menu_type;//: "veg",
    public String menu_addon;//: "No",
    public String popular_dish;//: "Yes",
    public String featured;//: "No",
    public String spicy_dish;//: "",
    public String favourite;//: "N",
    public String status;//: "1",
    public String delete_status;//: "N",
    public String created;//: "2014-09-18T13:52:00+01:00",
    public String modified;//: "2020-06-01T06:05:02+01:00",
    public int sortorder;//: 0,
    public int sortOrder;//: 0,
    public String short_name;//: "",
    public boolean vegetarian;//: 0,
    public boolean contains_nuts;//: 0,
    public boolean milk;//: 0,
    public boolean mustard;//: 0,
    public boolean eggs;//: 0,
    public boolean fish;//: 0,
    public boolean gluten_free;//: 0,
    public boolean halal;//: 0,
    public boolean koshar;//: 0,
    public boolean vegan;//: 0,
    public boolean crustaceans;//: 0
    public boolean molluscs;//: 0
    public boolean sulphur_dioxide;//: 0
    public boolean sulphites;//: 0
    public boolean showImage; // custom variable
    public Category category;
    public String product_percentage;
    public ArrayList<Variant> menu_details, dinein_menu_details;
    public ArrayList<Variant> variants=new ArrayList<>();
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        MenuItem menuItem = (MenuItem) o;
        return id == menuItem.id;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    public float getProductPercentage() {
        if (Validators.isNullOrEmpty(product_percentage)) {
            return 0;
        } else return Float.parseFloat(product_percentage);
    }
}
