package com.tiffintom.models;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;
import androidx.room.Update;

import com.tiffintom.models.DineinModels.OrderItem;
import com.tiffintom.models.DineinModels.OrderItemAddon;
import com.tiffintom.models.DineinModels.OrderItemIngredient;

import java.util.List;

/**
 * Created by Amrish on 19-05-2021.
 */
@Dao
public interface OrderItemDao {
    @Query("SELECT * FROM OrderItem")
    List<OrderItem> getAll();

    @Query("SELECT * FROM OrderItem WHERE _order_id=:orderId")
    List<OrderItem> list(int orderId);

    @Query("SELECT * FROM OrderItem WHERE order_id=:orderId")
    List<OrderItem> list(String orderId);

    @Delete
    void delete(OrderItem orderItem);

    @Query("DELETE FROM OrderItem WHERE order_id=:orderId")
    void deleteAll(String orderId);

    @Query("DELETE FROM OrderItem WHERE _order_id=:orderId")
    void deleteAll(int orderId);

    @Update(onConflict = OnConflictStrategy.REPLACE)
    void update(OrderItem orderItem);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    long insertLong(OrderItem orderItem);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    public void insert(OrderItem orderItem);

    @Query("SELECT * FROM OrderItem WHERE id=:orderItemId")
    OrderItem view(String orderItemId);

    @Query("SELECT * FROM OrderItem WHERE menu_id=:menu_id")
    OrderItem view(int menu_id);

    @Query("SELECT COUNT(*) FROM OrderItem WHERE _order_split_id=:splitId")
    int count(int splitId);

    @Query("DELETE FROM OrderItem")
    void nukeTable();

    @Query("SELECT SUM(quantity) as items, SUM(Total) as total FROM orderitem")
    CartSummary getCartSummary();

    @Query("SELECT * FROM orderitem WHERE _id=:id")
    OrderItem getDineinOrderItem(int id);

    @Query("SELECT * FROM orderItemAddon WHERE addon_id=:id")
    List<OrderItemAddon> getDineinOrderAddonItem(String id);

    @Query("SELECT * FROM orderitemingredient WHERE ingredient_id=:id")
    List<OrderItemIngredient> getDineinOrderIngredientItem(String id);
}
