package com.tiffintom.models;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;

import com.tiffintom.models.DineinModels.ProductIngredients;

import java.util.List;

@Dao
public interface ProductIngredientDao {
    @Query("SELECT * FROM ProductIngredients WHERE disabled=0 ORDER BY sequence ASC")
    public List<ProductIngredients> list();

    @Query("SELECT * FROM ProductIngredients WHERE product_id=:productId AND disabled =0 ORDER BY sequence ASC")
    public List<ProductIngredients> listByProduct(String productId);

    @Query("SELECT * FROM ProductIngredients where `id`=:id")
    public ProductIngredients view(String id);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    public void insert(ProductIngredients productIngredient);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    public void insertMultiple(List<ProductIngredients> productIngredients);

    @Delete
    public void deleteMultiple(List<ProductIngredients> productIngredients);

    @Query("DELETE FROM ProductIngredients")
    public void deleteAll();
}
