package com.tiffintom.network;

import android.os.Handler;
import android.os.Looper;
import android.util.Log;

import com.tiffintom.MyApp;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.Map;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * Created by Amrish on 19-08-2020.
 */
public class NetworkInterceptor implements Interceptor {
    @Override
    public Response intercept(Chain chain) throws IOException {

        Request originalRequest = chain.request();
        Response response = null;
        try {
            Request.Builder tokenRequestBuilder = originalRequest.newBuilder();
            Map<String, String> headers = MyApp.getInstance().getMyPreferences  ().getHeaderTokens();
            tokenRequestBuilder.addHeader("package-name", MyApp.getInstance().getPackageName());
            if (headers != null) {
                for (Map.Entry<String, String> entry : headers.entrySet()) {
                    tokenRequestBuilder.header(entry.getKey(), entry.getValue());
                }
            }
            response = chain.proceed(tokenRequestBuilder.build());
            String xToken = response.header("x-token", null);
            String xRefreshToken = response.header("x-refresh-token", null);
            if (xToken != null && xRefreshToken != null) {
                MyApp.getInstance().getMyPreferences().saveHeaderTokens(xToken, xRefreshToken);
            }
        } catch (UnknownHostException e) {
            e.printStackTrace();
//            new Handler(Looper.getMainLooper()).post(() -> {
//                ToastUtils.makeToast(MyApp.getInstance(), "No internet connection available");
//            });
//            AndroidNetworking.cancelAll();
            return null;
        } catch (IOException e) {
            e.printStackTrace();
//            new Handler(Looper.getMainLooper()).post(() -> {
//                ToastUtils.makeToast(MyApp.getInstance(), "No internet connection!");
//            });
//            AndroidNetworking.cancelAll();
            return null;
        }

        return response;
    }
}