package com.tiffintom.utils;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.TextPaint;
import android.text.style.MetricAffectingSpan;
import android.widget.Toast;

import androidx.localbroadcastmanager.content.LocalBroadcastManager;

/**
 * Created by Amrish on 10-08-2020.
 */
public class ToastUtils {
    public static void makeToast(Activity context, String message) {
        Typeface font = Typeface.createFromAsset(context.getAssets(), "fonts/avenir_roman.otf");
        SpannableString spannableString = new SpannableString(message);
        spannableString.setSpan(new TypefaceSpan(font), 0, spannableString.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        if (context != null)
            context.runOnUiThread(() -> Toast.makeText(context, spannableString, Toast.LENGTH_SHORT).show());
    }

    public static void makeLongToast(Activity context, String message) {
        Typeface font = Typeface.createFromAsset(context.getAssets(), "fonts/avenir_roman.otf");
        SpannableString spannableString = new SpannableString(message);
        spannableString.setSpan(new TypefaceSpan(font), 0, spannableString.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        if (context != null)
            context.runOnUiThread(() -> Toast.makeText(context, spannableString, Toast.LENGTH_LONG).show());
    }

    public static void makeToast(Context context, String message) {
        Typeface font = Typeface.createFromAsset(context.getAssets(), "fonts/avenir_roman.otf");
        SpannableString spannableString = new SpannableString(message);
        spannableString.setSpan(new TypefaceSpan(font), 0, spannableString.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        if (context != null)
            Toast.makeText(context, spannableString, Toast.LENGTH_SHORT).show();
    }

    public static void makeSnackToast(Context context, String message) {
        Intent cartBroadcast = new Intent(Constants.TOAST_UPDATE);
        cartBroadcast.putExtra("message", message);
        LocalBroadcastManager.getInstance(context).sendBroadcast(cartBroadcast);
    }

    public static class TypefaceSpan extends MetricAffectingSpan {
        private final Typeface mTypeface;

        public TypefaceSpan(Typeface typeface) {
            mTypeface = typeface;
        }

        @Override
        public void updateMeasureState(TextPaint p) {
            p.setTypeface(mTypeface);
            p.setFlags(p.getFlags() | Paint.SUBPIXEL_TEXT_FLAG);
        }

        @Override
        public void updateDrawState(TextPaint tp) {
            tp.setTypeface(mTypeface);
            tp.setFlags(tp.getFlags() | Paint.SUBPIXEL_TEXT_FLAG);
        }
    }
}
